//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  Mint <- unsigned long integer
//
//  Zq (Px)
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::operator=(const unsigned long n)
{
  if( ndim()<=fDigit ) allocate(fDigit+1) ;

  __asm {
    mov   esi,this
    mov   eax,n                         // eax <- n fixed
    or    eax,eax                       // n=0 ?
    jnz   SET
#ifdef __BORLANDC__                     // in case n=0
    mov   dword ptr [esi.nDigit],eax
    mov   byte ptr [esi.nDim+3],1
#else
    mov   dword ptr [esi+NDIGIT],eax
    mov   byte ptr [esi+SIGN],1
#endif
    jmp   RET1
  }
SET:
  __asm {
#ifdef __BORLANDC__
    mov   byte ptr [esi.nDim+3],1           // result is positive
    mov   ecx,[esi.fDigit]
    mov   [esi.nDigit],ecx
    inc   dword ptr [esi.nDigit]             // nDigit=fDigit+1

    mov   esi,[esi]
#else
    mov   byte ptr [esi+SIGN],1
    mov   ecx,[esi+FDIGIT]
    mov   [esi+NDIGIT],ecx
    inc   dword ptr [esi+NDIGIT]

    mov   esi,[esi]
#endif
    mov   [ecx*NBYTE+esi],eax     // set n to integer part
//    or    ecx,ecx                 // is there fractional part ?
//    jz    RET1
    dec   ecx
    js    RET1
    xor   eax,eax
  }
clear:
  __asm {                                    // clear fractional part
//    mov   dword ptr [ecx*NBYTE+esi-NBYTE],eax
    mov   dword ptr [ecx*NBYTE+esi],eax
    dec   ecx
//    jnz   clear
    jns   clear
  }
RET1:
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif

  return *this ;
}
