//
//  Copyright (C) by S.Tomabechi 1995,1996,1997,1999,2000
//  All rights reserved.
//
//  primary decomposition
//
//  nPrimes (I) : number of primes
//
//  ^ꂽȑfQőf,̙pw 2 @ƂĕԂ.
//  PPMPQS@Ŏgp
//
//  1999/12/12  c肪ꌅɂȂƂA؂f binary search ŒT悤ɕύX
//
//  ߂l
//     true  : ł
//     false : łȂ
//
//  ӁAfactor base Ɋւ smooth ł邱
//        large prime ΂ŊĂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Mint.hpp"

#include <math.h>
#if 0
struct PPrimes  {
  unsigned short diff ;
  char logP ;
  char dmy ;
  unsigned long Root ;         //  4 byte Kv
  unsigned long SievePos[2] ;  //  4 byte Kv
} ;
#endif

bool BitDecomp(long nPrimes,unsigned long* Primes,Mint& q,unsigned long* v)
{
  bool result(true) ;
  long j(0) ;
  unsigned long p(0) ;

  __asm {
    mov   ebx,nPrimes           // number of factor base
    add   ebx,31
    shr   ebx,5                 //  1/32
  }
  __asm {                       // clear bit string
    xor   eax,eax
    mov   ecx,ebx
    mov   edi,v
    rep   stosd
  }
  __asm {
#ifdef __BORLANDC__
    mov   esi,q
    cmp   dword ptr [esi.nDim],0         // q is negative ?
    jge   Initialize
    neg   byte ptr [esi.nDim+3]
    mov   edi,v
    bts   dword ptr [edi],0              // v[0]=1
#else
    mov   esi,q
    cmp   dword ptr [esi+NDIM],0       // q is negative ?
    jge   Initialize
    neg   byte ptr [esi+SIGN]
    mov   edi,v
    bts   dword ptr [edi],0
#endif
  }


Initialize:
  __asm {
#ifdef __BORLANDC__
    mov   ecx,[esi.nDigit]
    mov   esi,[esi]
    xor   edi,edi
#else
    mov   ecx,[esi+NDIGIT]
    mov   esi,[esi]
    xor   edi,edi
#endif
    dec   ecx
    jz    Main_loop20
  }
Main_loop:
  __asm {
    dec   nPrimes
    jz    large_remainder

    inc   j                             // increase index
    mov   ebx,j
  }

  __asm {
    mov   eax,Primes
    mov   eax,[eax+ebx*4]

    mov   p,eax                         // p is a prime of factor base
    xor   edx,edx
  }
Div1:
  __asm mov ebx,ecx
DivLoop1:                        // divisible by p ?
  __asm {
    mov   eax,[ebx*NBYTE+esi]
    div   p
    dec   ebx
    jns   DivLoop1

    or   edx,edx                 // remainder is 0 ?
    jz   Div2                    // divide exactly

    and   edi,1
    jz    Main_loop              // divided even times
  }
  __asm {                        // dvided odd times
    mov   ebx,j
    mov   edx,ebx
    shr   ebx,5                  //  j/32
    and   edx,0000001fh          //  j%32

    mov   edi,v
    bts   [edi+4*ebx],edx        // make bit on

    xor  edi,edi                 // edi <- 0
    jmp  Main_loop
  }
Div2:
  __asm mov ebx,ecx
DivLoop2:
  __asm {
    mov   eax,[ebx*NBYTE+esi]
    div   p
    mov   [ebx*NBYTE+esi],eax
    dec   ebx
    jns   DivLoop2

    inc edi                      // divide edi-times

    cmp   dword ptr [ecx*NBYTE+esi],0  // top digit become zero
    jnz   Div1
    dec   ecx                     // decrease #digits
    jz    REDUCT_1                // unfactored part is single precision

    cmp   dword ptr [ecx*NBYTE+esi],0
    jnz   Div1
    dec   ecx
    jnz   Div1
  }
REDUCT_1:
  __asm {
    mov   ebx,j                  // ebx <- index
    jmp DivLoop12
  }

Main_loop20:
  __asm mov ebx,j
Main_loop2:
  __asm {
    dec   nPrimes
    jz    large_remainder

    inc   ebx

    mov   eax,Primes
    mov   eax,[eax+4*ebx]
    mov   p,eax                  // prime of factor base
  }
REDUCT:
  __asm {
    xor   edx,edx
  }
DivLoop12:                       // divisible by p ?
  __asm {
    mov   eax,[esi]
    div   p
    or    edx,edx
    jnz   SetBit
    mov   [esi],eax
    inc   edi
    jmp   DivLoop12              // try to divide more
  }
SetBit:
  __asm {
    or    edi,edi
    jz    Little                 // not divided at all
    and   edi,1                  // check parity
    jz    remainder_1            // divided even times
  }
  __asm {                        // divided odd time
    mov   eax,ebx
    mov   edx,eax
    shr   eax,5                  //  j/32
    and   edx,0000001fh          //  j%32

    mov   edi,v
    bts   [edi+4*eax],edx        // make bit on
    xor   edi,edi                // clear parity

  }
remainder_1:
  __asm {
    cmp    dword ptr [esi],1  // completely factored by factor base  ?
    jne    Main_loop2
    mov    result,1           // fully factored
    jmp    RET1
  }

Little:
  __asm {
    cmp   eax,p               // quotient < p ?   eax is prime if it is so
    jae   Main_loop2

    mov   eax,[esi]           // eax must be prime
  }

///////////////////////////
//
//  search prime by binary method

  // ֗鎞,؂邩 (f)^,(p)^̏ꍇ
  // vf̃CfbNXT
  //  binary search ɂTɕύX 1999.12.10
  __asm {
    mov  ecx,nPrimes
    add  ecx,ebx
    push esi
    mov  esi,Primes
//    cmp  eax,dword ptr Primes[ecx*4] // ̔r͂ȂĂǂ͂
//    ja   SetPP               // factor base ̑f傫
  }
Search_Position:
  __asm {
    mov  edx,ebx            // always ebx <= ecx
  }
Search_Position1:
  __asm {
    add  edx,ecx
    inc  edx
    shr  edx,1
    cmp  eax,[esi+edx*4]
    ja   SET_ebx           // greater than a prime of factor base
    jb   SET_ecx           // less than a prime of factor base

    mov  ebx,edx           // as same as a prime of factor base
    mov  edx,[esi+4*edx]
    pop  esi
    mov  p,edx
    jmp  REDUCT
  }
SET_ebx:
  __asm {
    mov ebx,edx          // search right half part
    jmp Search_Position1
  }
SET_ecx:
  __asm {
    mov ecx,edx          // search left half part
    jmp Search_Position
  }

large_remainder:
  __asm {
    mov   result,0            // error : not fully factored
  }

RET1:

  return result ;

}
