//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  decompose double in IEEE format
//
//  IEEE ` double ̏̎擾ƃZbg
#include "Dbl.hpp"

#ifdef __BORLANDC__
#pragma inline
#endif
int Dbl::Sign(void)                     // return signature
{                                       // return  1 : positive or zero
  int s(-1) ;                           //        -1 : negative
  __asm {
    mov eax,this
    mov eax,[eax+4]
    cmp eax,0x80000000
    jae RET1
    mov s,1
  }

RET1:
  return s ;
}

int Dbl::Exp(void)                      // return exponent
{
  int m ;
  __asm {
    mov eax,this
    mov eax,[eax+4]
    and eax,0x7ff00000
    shr eax,20
    sub eax,DBL_BIAS
    mov m,eax
  }
  return m ;
}

unsigned long Dbl::Low()      // return digits
{
  unsigned long n ;
  __asm {
    mov eax,this
    mov eax,[eax]
    shl eax,12
    mov n,eax
  }
  return n ;
}

unsigned long Dbl::High()     // L  32rbg
{
  unsigned long n ;
  __asm {
    mov ebx,this
    mov ecx,[ebx]
    shr ecx,20
    and ecx,0x00000fff

    mov edx,[ebx+4]
    and edx,0x000fffff
    shl edx,12
    or  edx,ecx

    mov n,edx
  }
  return n ;
}



void Dbl::SetHigh(unsigned long d)
{
  __asm {
    mov ebx,this
    mov ecx,[ebx+4]
    and ecx,0xfff00000
    mov eax,d
    shr eax,12
    or  ecx,eax
    mov [ebx+4],ecx

    mov ecx,[ebx]
    and ecx,0x000fffff
    mov eax,d
    shl eax,20
    or  ecx,eax
    mov [ebx],ecx
  }
}


void Dbl::SetLow(unsigned long d)
{
  __asm {
    mov ebx,this
    mov eax,[ebx]
    and eax,0xfff00000
    mov ecx,d
    shr ecx,12
    or  ecx,eax
    mov [ebx],ecx
  }
}


void Dbl::SetSign(int s)      // Zbg
{
  __asm {
    mov ebx,this
    mov eax,s
    and eax,0x80000000
    mov ecx,[ebx+4]
    and ecx,0x7fffffff
    or  ecx,eax
    mov [ebx+4],ecx
  }
}

void Dbl::SetExp(int e)
{
  __asm {
    mov ebx,this
    mov eax,e
    add eax,DBL_BIAS
    shl eax,20
    and eax,0x7ff00000
    mov ecx,[ebx+4]
    and ecx,0x800fffff
    or  ecx,eax
    mov [ebx+4],ecx
  }
}


bool Dbl::isZero()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp dword ptr [ebx+4],0
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}

bool Dbl::isPositiveInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp dword ptr [ebx+4],0x7ff00000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}

bool Dbl::isNegativeInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp dword ptr [ebx+4],0x0ff00000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}


bool Dbl::isIndefinite()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp dword ptr [ebx+4],0x0fff80000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}


bool Dbl::isDeNormal()
{
  bool f ;
  __asm {
    mov ebx,this
    mov eax,dword ptr [ebx+4]
    and eax,0x7ff00000
    mov f,0
//    cmp eax,0
    or   eax,eax
    jnz  RET1
    mov f,1
    cmp dword ptr [ebx+4],0
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,0
  }
RET1:
  return f ;

}


