//
//  Copyright (C) by S.Tomabechi 1995-1997
//  All rights reserved.
//
//  divide by factor base  ( for MPQS )
//
//  1995.01.17
//  ^ꂽfQőfł邩ǂׂ
//
//  1996.09.30
//    32rbg
//
//  1996.11.25
//    double large primes @ɑΉ
//

#ifdef __BORLANDC__
#pragma inline
#endif
#include "Mint.hpp"
#include "LBit.hpp"

#include <math.h>
#include "Error.hpp"

extern long SievePos[] ;
extern unsigned long Primes[] ;
extern unsigned long _FX[] ;
extern unsigned long _OFF ;
extern unsigned long SieveUnit ;
extern unsigned long Pmax ;
extern unsigned long Upper1 ;
extern Mint Upper2 ;
extern unsigned long Pmax2[] ;
extern unsigned long _nPrimes ;
extern Mint _fx ;
extern unsigned long _p1,_p2 ;

static Mint d(2) ;
static Mint __fx ;
extern long _DivResult ;
extern int nLoop_rho ;
extern const long _Kr_tab[] ;
extern Mint const2 ;
static Mint a1 ;
static Mint a2 ;

//  result:
//  _p1,_p2 : large primes
//
//  _DivResult: 0  fully factored
//              1  a large prime is remainded
//              2  2 large primes are remained
//             -1  remained part contains a very large prime
//
//
//  _p1,_p2 ꂸɎcf
//  ꂸɎcf̏ꍇ _p1=1 p2=prime ƂĕԂ
//
//  ߂l _DivResult: 0  fꂽ
//                     1  ꂸɎc͈̑f
//                     2  ꂸɎc͓̑f̐
//                     -1  ꂸɎcɑ傫ȑf
//

void DivideByBase(void)
{
  long j ;
  long nPrimes ;
  long Kr ;
  int nLoop ;


Initialize:
  __asm {
    mov   dword ptr [_DivResult],-1     // initialize return value

    mov   eax,_nPrimes                  // number of primes in factor base
    mov   nPrimes,eax
#ifdef __BORLANDC__
    mov   ecx,dword ptr [_fx.nDigit]    // fixed ecx = #digitis of q
    mov   esi,dword ptr [_fx]           // address of the digits array
#else
    mov   ecx,dword ptr [_fx+NDIGIT]
    mov   esi,dword ptr [_fx]
#endif
      lea  edi,_FX
      mov  eax,ecx
      rep  movsd                        // copy digits to _FX

      mov  ecx,eax
      dec  ecx                          // #digits-1
      mov  esi,1
      dec  nPrimes
      mov  edi,2
  }
MORE2:
  __asm {
      test dword ptr [_FX],1            // divisible by 2 ?
      jnz  Main_loop

      mov  ebx,ecx
      xor  edx,edx
  }
DIV_2:
  __asm {                              // divide by 2
      mov  eax,dword ptr _FX[ebx*NBYTE]
      div  edi
      mov  dword ptr _FX[ebx*NBYTE],eax
      dec  ebx
      jns  DIV_2

      cmp dword ptr _FX[ecx*NBYTE],0
      jnz  MORE2
      dec ecx

      jmp  MORE2                        // try more to divide by 2

  }

Main_loop:
  __asm {
    dec   nPrimes
    jz    large_remainder               // All done

    inc   esi                           // increment index

    mov   edi,dword ptr Primes[esi*4]   // factor base ̑f

//xor edx,edx
//jmp Div1

    lea   ebx,[esi*2+esi]               // SievePos ̃CfbNX

    xor   edx,edx                       // 邩ǂׂ
    mov   eax,dword ptr [_OFF]
    sub   eax,dword ptr SievePos[ebx*4+4]   // SievePos  f p Ŋ
    div   edi                               // ŏ̈ʒu
    or    edx,edx                           // ́ASieve œꂽ

#ifdef MPQS_DEBUG
jz  Div1
xor edx,edx
jmp Div1
#endif

    jz    Div2

    xor   edx,edx
    mov   eax,dword ptr [_OFF]
    sub   eax,dword ptr SievePos[ebx*4+8]
    div   edi
    or    edx,edx

#ifdef MPQS_DEBUG
jz  Div1
xor edx,edx
jmp Div1
#endif

    jz    Div2

    jmp   Main_loop                     // ̑fł͊؂Ȃ

  }
Div1:
  __asm mov ebx,ecx                     // ۂɊƂ̂߂Ɍۑ
DivLoop1:                               // ؂邩ǂׂ
  __asm {
    mov   eax,dword ptr _FX[ebx*NBYTE]
    div   edi                           // factor base ̑fŊĂ݂
    dec   ebx
    jns   DivLoop1

    or    edx,edx                       // ܂ 0 ?
    jnz   Main_loop                     // Ȃ̂Ŏ̑fŎ
  }

Div2:                                   // ֗Ƃ edx=0
  __asm mov ebx,ecx
DivLoop2:                               // ؂̂ŎۂɊ
  __asm {
    mov   eax,dword ptr _FX[ebx*NBYTE]
    div   edi
    mov   dword ptr _FX[ebx*NBYTE],eax
    dec   ebx
    jns   DivLoop2


#ifdef MPQS_DEBUG1
or  edx,edx
jz  SUCCESS
lea   ebx,[esi*2+esi]

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,dword ptr SievePos[ebx*4+4]
div   edi

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,dword ptr SievePos[ebx*4+8]
div   edi

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,dword ptr SievePos[ebx*4+12]
div   edi

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,dword ptr SievePos[ebx*4+16]
div   edi

jnz  RET2
#endif


  }
SUCCESS:
 __asm {
    cmp   dword ptr _FX[ecx*NBYTE],0    // ŏʌ 0 ɂȂ ?
    jne   Div1
    dec   ecx                           // 炷
    jz    REDUCT_1                      // ꌅɂȂ
//    jnz   Div1                          // Ɋ邩

//    mov   ebx,esi                       // c͈ꌅɂȂ
    cmp   dword ptr _FX[ecx*NBYTE],0    // ŏʌ 0 ɂȂ ?
    jne   Div1
    dec   ecx                           // 炷
    jnz   Div1                           // Ɋ邩
  }
REDUCT_1:                               // ꌅɂȂ
  __asm {
    mov   ebx,dword ptr [_FX]           // ebx Ɏcꌅu
    jmp   DivLoop12
  }

Main_loop2:                             // c͈ꌅ
  __asm {
    dec   nPrimes
    jz    check_more

    inc   esi

    mov   edi,Primes[esi*4]
  }
REDUCT:
  __asm {
    xor   edx,edx
  }
DivLoop12:                              // ؂邩ǂׂ
  __asm {
//    mov   eax,dword ptr [_FX]
    mov   eax,ebx
    div   edi
  }
DIV_MORE:
  __asm {
    or    edx,edx
    jz    Set
    cmp   eax,edi                       // ͏菬 ?
    ja    Main_loop2
    jmp   Little
  }
Set:
  __asm {
//    mov   dword ptr [_FX],eax
    mov   ebx,eax
    div   edi
    jmp   DIV_MORE                           // ɊĂ݂
  }

Little:
  __asm {
                              // Factor Base ̑fƈv邩
                              // Factor Base 傫f(̐)
                              // Facto Base ̑f̐ςɂȂĂ邱Ƃ͂Ȃ.
    cmp   dword ptr [Upper1],ebx // Large prime Ɣr
    jbe   RET1                   // Large prime ̂傫̂ NG
    cmp   ebx,dword ptr [Pmax] // factor base ̍őfƔr
    ja    SetP                   // c͑傫 Large Prime 菬
    mov   dword ptr [_DivResult],0
    jmp   RET1

  }

check_more:                      // ւ͎̂c肪ꌅ̂Ƃ
__asm {
//    mov   eax,dword ptr [_FX]
//    cmp   eax,dword ptr [Upper1] // Large Prime  傫 ?
//  mov   dword ptr [_FX],ebx
    mov   ebx,dword ptr [Upper1]   // greater than Large Prime ?
    ja    RET1                     // yes

  }
SetP:                            // (p) ^ ꂽ
  __asm {
    mov   dword ptr [_p2],ebx
    mov   dword ptr [_p1],1
    mov   dword ptr [_DivResult],1  // gained (p) type
    jmp   RET1
  }
large_remainder:
  __asm {
//cmp [Upper2].nDigit,2
//jne RET1

    cmp   ecx,1                  // c͓ ?
    jne   RET1                   // Oȏ͂ĂтȂ
    inc   ecx

    mov   eax,Pmax2[NBYTE]

    cmp   dword ptr _FX[NBYTE],eax    // Pmax2 > fx  ?  Ȕr͂Ȃ

    jb RET1
    ja OK1

    mov   eax,dword ptr [Pmax2]
    cmp   dword ptr [_FX],eax
    jb    RET1
  }

OK1:
  __asm {                        // q>Upper2 Ȃ̂Ă
#ifdef __BORLANDC__
    mov  edi,dword ptr [Upper2]
#else
    mov  edi,dword ptr [Upper2]
#endif
    mov  eax,dword ptr [edi+NBYTE]
    cmp  dword ptr _FX[NBYTE],eax
    ja   RET1

  }
OK:
  __asm {
    mov   ebx,dword ptr [_FX]
    and   ebx,7                           // mod 8
    mov   eax,dword ptr _Kr_tab[ebx*4]    // ] (2/_fx) vZ
    mov   Kr,eax
#ifdef __BORLANDC__
    mov   dword ptr [__fx].nDigit,ecx
    mov   byte ptr [__fx].nDim[3],1
    mov   esi,dword ptr [__fx].digit
#else
    mov   dword ptr [__fx+NDIGIT],ecx
    mov   byte ptr [__fx+SIGN],1
    mov   esi,dword ptr [__fx]
#endif
    mov   eax,dword ptr [_FX]
    mov   dword ptr [esi],eax
    mov   eax,dword ptr [_FX+NBYTE]
    mov   dword ptr [esi+NBYTE],eax
  }

                              // EulerKAf炵͕݂̂Ȃ
//  if( long(d.apower(const2,(__fx-1)>>=1,__fx))==Kr ) goto RET ;
  if( long(d.apower(const2,(Mint::_Mtemp.isSubUL(__fx,1UL))>>=1,__fx))==Kr )
    goto RET1 ;
                                        // ϖ@ɂ镪

  nLoop=nLoop_rho ;
  a1.nDigit=1 ;
  *a1.digit=6 ;
  a2.nDigit=1 ;
  *a2.digit=37 ;

TRY_MORE:
    d.nDigit=1 ;
    *d.digit=1 ;
    j=100 ;
RHO_LOOP:

//      d*=(a2-a1)  ;
      d*=Mint::_Mtemp.isSub(a2,a1) ;
      d.isRem(d,__fx) ;
                          // ++ 邱ƂɂĂӂ\D
                          // ̏ꍇ͈Ӑ}錋ʂȂmȂ
                          // D
      ++(*(Mint::_Mtemp.isMul(a1,a1)).digit) ;
      a1.isRem(Mint::_Mtemp,__fx) ;

      ++(*(Mint::_Mtemp.isMul(a2,a2)).digit) ;
      ++(*(a2.isMul(Mint::_Mtemp,Mint::_Mtemp)).digit) ;
      a2.isRem(a2,__fx) ;

    __asm {
       dec  j
       jnz  RHO_LOOP
    }
    d.isGCD(d,__fx) ;
    __asm {
      dec nLoop
      jz  RET1                 // łȂ
#ifdef __BORLANDC__
      mov esi,dword ptr [d].digit
      cmp dword ptr [esi],1
      je  TRY_MORE
      cmp dword ptr [d].nDigit,1
      jne TRY_MORE
#else
      mov esi,dword ptr [d]
      cmp dword ptr [esi],1
      je  TRY_MORE
      cmp dword ptr [d+NDIGIT],1
      jne TRY_MORE
#endif
    }
FOUND:
  __asm {
#ifdef __BORLANDC__
    mov  edi,dword ptr [d]
#else
    mov  edi,dword ptr [d]
#endif
    mov  ecx,dword ptr [edi]

/*****************
xor edx,edx
mov eax,dword ptr _FX[NBYTE]
div ecx
or  eax,eax
jnz RET1
mov eax,dword ptr [_FX]
div ecx
***************/

    mov  eax,dword ptr [_FX]
    mov  edx,dword ptr _FX[NBYTE]
    div  ecx                   // ꂽfŊ ]߂

    cmp  ecx,eax
    ja   SETPP                 // eax<=ecx ƂȂ悤בւ
    xchg ecx,eax
  }
SETPP:
  __asm {
    cmp  ecx,dword ptr [Upper1]    // Large prime 傫
    ja   RET1                      // 傫̂Ŏ̂Ă
    mov  dword ptr [_p1],eax
    mov  dword ptr [_p2],ecx
    mov  dword ptr [_DivResult],2
//jmp RET1
  }

RET2:
//__asm or eax,eax


RET1: ;


}
