//
//	Copyright (C) by S.Tomabechi 1993-1997
//	All rights reserved.
//
// divide real number by real number
//
//	̏߂
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define __MINT_CPP
#include "Fint.hpp"
#include "Error.hpp"

Fint& Fint::isDivF(const Mint& a,const Mint& b)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif
  int anDigit ;
  int afDigit ;
  int bnDigit ;
  int bfDigit ;

  __asm {
	mov esi,a
#ifdef __BORLANDC__
	mov eax,[esi.nDigit]
	mov ebx,[esi.fDigit]
#else
	mov eax,[esi+NDIGIT]
	mov ebx,[esi+FDIGIT]
#endif
	or	eax,eax
	jz	SetZero							// a is zero
	mov anDigit,eax
	mov afDigit,ebx

	mov esi,b
#ifdef __BORLANDC__
	mov eax,[esi.nDigit]
	mov ebx,[esi.fDigit]
#else
	mov eax,[esi+NDIGIT]
	mov ebx,[esi+FDIGIT]
#endif
	or	eax,eax						   // b is zero
	jz	ZeroDivide
	mov bnDigit,eax
	mov bfDigit,ebx
	jmp BigNumber
  }

SetZero:
  return *this=a ;

ZeroDivide:
  Error(zero divide) ;

	 // too big number
BigNumber:
  if( bnDigit>FFT_digit && afDigit>0 ) {
	if( b.fDigit!=0 ) return isMulF(a,(Mint&)(isInverse((Fint&)b))) ;
	else return isMulF(a,inverse(b)) ;
  }


  int ufDigit ;
  int shift ;
							  // decide fractional point of the result
							  // _ʒu߂
  if( afDigit>=bfDigit ) {
	if( afDigit!=0 ) {
	  ufDigit=afDigit ;
	  shift=bfDigit ;
	}
	else ufDigit=shift=GetPrecision() ;
							  // Ƃɐ
							  // shift 𑝂₵ČvZ
  }
  else {
	if( afDigit!=0 ) {
	  shift=bfDigit+(bfDigit-afDigit) ;
	  ufDigit=bfDigit ;		  // b ƌ킹A b̏Vtg
	}
	else {					  // a ͐
	  shift=2*bfDigit ;
	  ufDigit=bfDigit ;
	}
  }							  //  ufDigit ̓Vtg̏

  int unDigit=anDigit+shift ; //Vtg a( Ȃ킿 u )̌

  if( unDigit<bnDigit ) {
	this->fDigit=1 ;
	return *this=0 ;
  }

				   // bPxȂȉ̃ASY͓KpłȂ̂,
				   // Pxp̊֐ŏ
  if( bnDigit==1 ) {
	isShiftl(a,long(shift)<<5) ;
	fDigit=ufDigit ;

	if( b.isNegative() ) {
	  if( isNegative() ) nDim&=_POSITIVE_ ;	 // 𔽓]
	  else nDim|=_NEGATIVE_ ;
	}
					// compute as integer
	return	(Fint&)((Mint*)this)->isDivUL((Mint&)*this,*b.digit) ;
  }

  int sft(31) ;
  signed char bSign,qSign ;
  unsigned long q,res ;
  unsigned long v1,v2 ;

  int qnDigit=unDigit-bnDigit+1 ;
  unsigned long j ;
  unsigned long j_n4 ;

  int Count ;
  unsigned long ui,vi,ti ;
  if( _uMtemp.ndim()<=unDigit+1 ) _uMtemp.allocate(unDigit+1) ;
  if( _vMtemp.ndim()< bnDigit )	 _vMtemp.allocate(bnDigit) ;
  Count=ufDigit+1 ;
  Count=Count>qnDigit ? Count:qnDigit ;
  if( ndim()<Count ) allocate(Count) ;
							   // g
#ifndef __BORLANDC__
  unsigned long* uptr=Mint::_uMtemp.digit;
  unsigned long* vptr=Mint::_vMtemp.digit ;
#endif

//D1:
  __asm {
	mov	  ebx,this
	mov	  eax,ufDigit
#ifdef __BORLANDC__
	mov	  [ebx.fDigit],eax
	mov	  ebx,[ebx]
	mov	  ti,ebx
	mov	  esi,dword ptr [@Mint@_vMtemp]
	mov	  edi,dword ptr [@Mint@_uMtemp]
#else
	mov	  [ebx+FDIGIT],eax
	mov	  ebx,[ebx]
	mov	  ti,ebx
	mov	  esi,vptr
	mov	  edi,uptr
#endif
	mov	  dword ptr ui,edi	 // xAhXƂ蒼ׂ͕̂ɂȂ̂
	mov	  dword ptr vi,esi	 // CfbNXWX^oĂ

	mov	  edi,b
#ifdef __BORLANDC__
	mov	  al,[edi.nDim+3]
	mov	  edi,[edi]
#else
	mov	  al,[edi+SIGN]
	mov	  edi,[edi]
#endif
	mov	  bSign,al
	mov	  ebx,bnDigit		// v̗L
	bsr	  ecx,[ebx*NBYTE+edi-NBYTE]
	sub	  sft,ecx
	mov	  ecx,sft

	mov	  eax,[edi+ebx*NBYTE-NBYTE]
	shld  edx,eax,cl
  }
mult_vd:						  // _vMtemp=b<<sht
  __asm {
	dec	  ebx
	jz	  EXIT1
	mov	  edx,eax
	mov	  eax,[edi+ebx*NBYTE-NBYTE]
	shld  edx,eax,cl
	mov	  [esi+ebx*NBYTE],edx
	jmp	  mult_vd
  }
EXIT1:
  __asm {
	shl	  eax,cl
	mov	  [esi],eax

	mov	  esi,ui
	mov	  ebx,shift
	or	  ebx,ebx
	jz	  skip_Clear_u
	mov	  edx,ebx
	xor	  eax,eax
  }
Clear_u:				 // shift  ̌Ŗ߂
  __asm {
	mov	  [ebx*NBYTE+esi-NBYTE],eax
	dec	  ebx
	jnz	  Clear_u
	lea	  esi,[esi+edx*NBYTE]
  }
skip_Clear_u:
  __asm {

	mov	  ebx,anDigit  // a ̌ (VtgO)

	mov	  edi,a
#ifdef __BORLANDC__
	mov	  al,[edi.nDim+3]
	mov	  edi,[edi]
#else
	mov	  al,[edi+SIGN]
	mov	  edi,[edi]
#endif
	imul  bSign
	mov	  qSign,al

	xor	  edx,edx
	mov	  eax,[edi+ebx*NBYTE-NBYTE]
	shld  edx,eax,cl
	mov	  [esi+ebx*NBYTE],edx
  }
mult_ud:						  // r=u<<cl
  __asm {
	dec	  ebx
	jz	  EXIT2
	mov	  edx,eax
	mov	  eax,[edi+ebx*NBYTE-NBYTE]
	shld  edx,eax,cl
	mov	  [esi+ebx*NBYTE],edx
	jmp	  mult_ud
  }
EXIT2:
  __asm {
	shl	  eax,cl
	mov	  [esi],eax
  }
//D2:
  __asm {					// 
	mov	  ebx,bnDigit
	mov	  edi,vi			// v  CfbNX
	mov	  eax,[ebx*NBYTE+edi-NBYTE]
	mov	  v1,eax			// v̍ŏʌ
	mov	  eax,[ebx*NBYTE+edi-2*NBYTE]
	mov	  v2,eax			// v̎̌

	mov	  eax,unDigit		// ǔ
	mov	  j,eax				// j ̓JE^
	sub	  eax,bnDigit
	shl	  eax,2
	mov	  j_n4,eax

	add	  ti,eax
  }

D3:							   // ߂
  __asm {
	mov	  ebx,j
	mov	  esi,ui
	mov	  edx,[ebx*NBYTE+esi]	// dx=u[j]
	cmp	  edx,v1
	jne	  not_equal
	mov	  eax,0ffffffffh		  // u[j]==v1
	mov	  q,eax
	mov	  ecx,[ebx*NBYTE+esi-NBYTE]
  }
test0:
  __asm {
	add	  ecx,v1
	jc	  D4
	mov	  res,ecx
	jmp	  test1
  }
not_equal:
  __asm {
	mov	  eax,[ebx*NBYTE+esi-NBYTE]
	div	  v1
	mov	  q,eax		// q=
	mov	  res,edx	// res=]
  }
test1:
  __asm {
	mov	  eax,v2
	mul	  q
	mov	  ecx,[ebx*NBYTE+esi-2*NBYTE]
	sub	  ecx,eax
	mov	  ecx,res
	sbb	  ecx,edx
	jnc	  D4
  }
//q_1:
  __asm {			 // 傫߂
	dec	  q			 //  1 炷
	jmp	  test0
  }
D4:
  __asm {					// u-=q*v vZ
	mov	  edi,vi
	mov	  ecx,bnDigit
	mov	  esi,ui
	add	  esi,j_n4
	mov	  Count,ecx

	xor	  ecx,ecx	   // ecx=Overflow
	mov	  ebx,ecx	   // ebx=carry
  }
mult:
  __asm {
	mov	  eax,[edi]
	lea	  edi,[edi+NBYTE]
	mul	  q
	add	  eax,ecx
	adc	  edx,0
	mov	  ecx,edx		// ӂZ[u
  }
//next1:
  __asm {
	add	  eax,ebx
	adc	  ecx,0
	sbb	  [esi],eax
	mov	  ebx,0
//	  adc	ebx,0
	adc	  ebx,ebx
	lea	  esi,[esi+NBYTE]
	dec	  Count
	jnz	  mult
	mov	  eax,ecx
	mov	  ecx,0
	add	  eax,ebx
	adc	  ecx,0
	sbb	  [esi],eax
	adc	  ecx,0
  }
//D5:
  __asm {
	mov	  edi,ti
	mov	  eax,q
	mov	  [edi],eax
	jecxz D7
  }
//D6:
  __asm {			  // ߂̂ŉ߂
	dec	  dword ptr [edi]
	mov	  ecx,bnDigit
	mov	  edi,vi
	mov	  esi,ui
	add	  esi,j_n4

	xor	  ebx,ebx
  }
LOOP_3:
  __asm {
	mov	  eax,[ebx*NBYTE+edi]
	adc	  [ebx*NBYTE+esi],eax
	inc	  ebx
	dec	  ecx
	jnz	  LOOP_3
	adc	  dword ptr [ebx*NBYTE+esi],0
  }
D7:
  __asm {
	cmp	  j_n4,0
	jle	  D8
	sub	  j_n4,NBYTE
	dec	  j
	sub	  ti,NBYTE
	jmp	  D3
  }
D8:
  __asm {
	mov	  edi,this
#ifdef __BORLANDC__
	mov	  esi,[edi]
#else
	mov	  esi,[edi]
#endif

	mov	  ebx,qnDigit		// ̍őL

	mov	  cl,qSign
	xor	  eax,eax
  }
Search_nonZero:
  __asm {
	cmp	  [ebx*NBYTE+esi-NBYTE],eax
	jne	  nonZero
	dec	  ebx
	jnz	  Search_nonZero
	mov	  cl,1		// ׂĂ̌A 1 ɂ
  }
nonZero:
  __asm{
#ifdef __BORLANDC__
	mov	  [edi.nDigit],ebx
	mov	  [edi.nDim+3],cl
#else
	mov	  [edi+NDIGIT],ebx
	mov	  [edi+SIGN],cl
#endif
  }

#ifdef _MEMMAN_DEBUG
this->check(__FILE__,__LINE__) ;
#endif

  return *this ;

}
