//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  calculate log(\Gamma(z))  by Stirling formula
//
#include "Fint.hpp"
#include "FintFunc.hpp"
#include <iostream.h>
#include <fstream.h>
#include "Error.hpp"

Fint gammaln(const Fint& x)
{
#ifdef _MEMMAN
x.check(__FILE__,__LINE__) ;
#endif

  long c=500 ;
  long j ;
  if( x<0 || x>0 && x<c ) {
    long n=500 ;
    Fint y(x) ;
    Fint loggam=gammaln(x+n+1) ;
    while( n!=0 ) {
      y*=(x+n) ;
      n-- ;
    }
    loggam-=log(y) ;
    return loggam ;
  }


  Mint d ;
  Fint n(x.fdigit()+1,x.fdigit()) ;
  Mint m ;
  n=x ;

  Fint loggam ;
  Fint t(x) ;
  Fint t2(t*t) ;

  loggam=(2*x-1)*log(x)/2-x+log(2*pi(x.fdigit()))/2 ;
  int sign=-1 ;
  long k2=2 ;
  int nBn ;
  static char filename[]="./bernoull.tbl" ;
  ifstream inf(filename,ios::in|ios::binary) ;
  if( inf.bad() ) {
    cerr << endl << "Error : could not open file " << filename ;
    Error(file not found) ;
  }


  inf.read((char*)&nBn,sizeof(unsigned long)) ;
  read(inf,m) ;
  read(inf,m) ;
  for( j=1 ; j<nBn ; j++, k2+=2 ) {
    sign=-sign ;
    read(inf,m) ;

    n=m ;
    read(inf,m) ;
    d=m ;
    d*=(k2*(k2-1))  ;
    n/=d ;

    n/=t ;
    if( n==0 ) break ;
    if( sign>0 ) loggam+=n ;
    else loggam-=n ;
    t*=t2 ;
    if( t==0 ) break ;
  }
  inf.close() ;

#ifdef _MEMMAN
loggam.check(__FILE__,__LINE__) ;
//Mint::_MemMan.check(__FILE__,__LINE__) ;
#endif

  return loggam[-(loggam.fdigit()-x.fdigit())] ;

}
