//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  ÄrbgƂĈ
//
#include "LBit.hpp"
#include "Error.hpp"
#include <memory.h>
const int N32=32 ;
long LBit::Size=64 ;
LBit _Btemp(64) ;

LBit::LBit(const long _size)      // _size ̓rbg̒
{
  size= _size ;
  nArray=(_size+31)/32 ;
  bit=new unsigned long[nArray] ;
  if( !bit ) Error( bit string allocate error) ;
  for( int j=nArray ; j>0 ; j-- ) bit[j-1]=0 ;        // NA
}

LBit::LBit(const LBit& B)         // copy constructor
{
  size=B.size ;
  nArray=B.nArray ;
  bit=new unsigned long[nArray] ;
  if( !bit ) Error( bit string copy error) ;
  memcpy(bit,B.bit,sizeof(unsigned long)*nArray) ;
}

LBit& LBit::operator=(const LBit& B)        // assignment
{
  if( this==&B ) return *this ;
  if( nArray<B.nArray ) {             //  area is not sufficient
    delete [] bit ;
    bit=new unsigned long[B.nArray] ;
    if( !bit ) Error( bit string allocate error) ;
    nArray=B.nArray ;
  }
  size=B.size ;
  memcpy(bit,B.bit,sizeof(unsigned long)*B.nArray) ;
  return *this ;

}

/***************
LBit& LBit::operator~()
{
  for( j=0 ; j<nArray/32 ; j++ ) {
    bit[j]=~bit[j] ;
  }
  return

}
****************/

LBit LBit::operator^(const LBit& B)    // exclusive logical sum
{
  return (_Btemp=*this)^=B ;
}

void read(istream& is,LBit& B)
{
  long narray ;
  is.read((char*)&narray,sizeof(narray)) ;
  is.read((char*)&B.size,sizeof(B.size)) ;
  if( narray>B.nArray ) {
    delete [] B.bit ;
    B.bit=new unsigned long[narray] ;
  }
  B.nArray=narray ;
  is.read((char*)B.bit,sizeof(unsigned long)*B.nArray) ;
}
