//
//  Copyright (C) by S.Tomabechi 1993,1995
//     All rights reserved
//
//    computes logarithm
//
//    log((1+x)/(1-x))=2\sum(x^(2k+1)/(2k+1)) + R
//
//    x=y*2^m     log(x)=log(y)+mlog(2)
//
//    1995.05.27
//      Vtg 0<y<2 ߂ہC2 byte ŃVtg߂
//      ߂ӂ邱Ƃ. 4 byteŌvZ悤ύX.
//

#include "Fint.hpp"
#include "Error.hpp"

Fint log(const Fint& x)
{

#ifdef _MEMMAN
x.check(__FILE__,__LINE__) ;
#endif

  static int _log2_fdigit(-1) ;
  if( x<=0 ) {
    cout << endl << x ;
    Error(parameter not positive) ;
  }
  Fint y(x),t(x.fdigit()+1,x.fdigit()),
       yy,ln(x) ;
  unsigned long c ;
  Fint w ;
  long leng=len(y) ;
  leng-=(long(NBITS)*y.fdigit()+1) ;  // modified at 1995.05.27
  y>>=leng ;         //   shift so that 0<y<2

  t=(y-1)/(y+1) ;
  yy=t*t ;
  ln=t ;
  c=1 ;
  for(;;) {    // compute log(y)
    t*=yy ;
    c+=2UL ;

    if( (w=t/c)==0 ) break ;
    ln+=w ;
  }

  ln<<=1 ;
//  ln*=2UL ;

  if( leng ) {
                     // calculate log(2) when its does not have enough precision
    if( _log2_fdigit<x.fdigit() ) {
      Fint::_log2[x.fdigit()-Fint::_log2.fdigit()] ;
      t=1 ;
      t/=3UL ;       // make use of 2=(1+1/3)/(1-1/3)
      Fint::_log2=t ;
      c=1 ;
      for(;;) {
        t/=9UL ;
        c+=2UL ;
        if( (w=t/c)==0 ) break ;
        Fint::_log2+=w ;
      }
      Fint::_log2<<=1 ;     // *=2
      _log2_fdigit=x.fdigit() ;
    }
    ln+=leng*Fint::_log2 ;
  }

#ifdef _MEMMAN
ln.check(__FILE__,__LINE__) ;
#endif

  return ln[-(ln.fdigit()-x.fdigit())] ;
}
