//
//  Copyright (C) by S.Tomabechi November 1996
//  All rights reserved.
//
//  primality test of Mersenne number by Lucas' method
//  Mp=2^p-1 is prime ?
//

#include "Mint.hpp"
#include "MintFunc.hpp"
#include "MBit.hpp"

bool Lucas(unsigned long p)
{
  Mint Mp(1) ;
  Mp<<=p ;
  Mp-- ;               //  Mp=2^p-1
  Mint s,t ;
  MBit bs(s),bMp(Mp) ; // alias of s and Mp
  Mint u ;

  unsigned long j ;
  if( p==2 ) s=0 ;
  else {
    s=4 ;
    for( j=p-2 ; j!=0 ; j-- ) {
//if( j%100==0 ) cout << j << " " ;
      s=s*s-2 ;       // s.isSquare(s) ;  s-=2 ;
      t=s>>p ;        // s=2^p*t+r=(2^p-1)*t+t+r

//      bs&=bMp ;       // s mod (2^p-1)
      s.isRem2(s,p) ;
      s+=t ;
      if( s>=Mp ) s-=Mp ;

    }
  }
  if( s==0 ) {
    cout << " is Mersenne number" ;
    return true ;
  }
  else {
    cout << " is not Mersenne number" ;
    return false ;
  }
}
