//
//  Copyright (C) by S.Tomabechi 1994,1997
//  All rights reserved.
//
//  p-1 method by Pollard
//

#include "Mint.hpp"
#include "Error.hpp"

bool powerdetect(Mint& n,Mint& p,unsigned long& e) ;
Mint SquareTest(const Mint& n) ;

static Mint p_11(const Mint& N,Mint& x,const unsigned long B) ;

Mint p_1(const Mint& N,const unsigned long B1)
{
  Mint s,t,x,y,g,P,b ;
  long B2 ;
  long j,k ;
  unsigned long e ;

  if( powerdetect(N,g,e) ) return g ;
  g=SquareTest(N) ;
  if( g>0 ) return g ;
  
First_stage:
#if 0
cout << endl << "(p-1)-method " << endl << N << flush ;
cout << endl << "1-st stage " << flush ;
#endif
  for( j=0 ; j<1 ; j++ ) {
    if( (P=p_11(N,x,B1))>1 ) return P ;
//    B1<<=1 ;
  }

#if 0
cout << "2-nd stage " << flush  ;
#endif
  B2=100*B1 ;
  Mint* f ;
  long step2=240 ;
  long deg ;
  f=new Mint[65] ;
  for( s=1,deg=0,f[0]=1,j=0 ; j<step2 ; j++ ) {
    if( gcd(j,step2)==1 ) {
      deg++ ;
      f[deg].isMul(s,f[deg-1])&=N ; // f[deg]=mod(s*f[deg-1],N) ;
      for( k=deg-1 ; k>=1 ; k-- ) {
        g.isMul(s,f[k-1]) ;
        f[k].isSub(g,f[k])&=N ;     // f[k]=mod(s*f[k-1]-f[k],N) ;
      }
      (~f[0])&=N ;                  // f[0]=mod(-f[0],N) ;
    }
    (s*=x)%=N  ;
  }
  t=1 ;
  for( j=0 ; j<=B2/step2 ; j++ ) {
    P=f[deg] ;
    for( k=deg-1 ; k>=0 ; k-- ) {
      ((P*=t)+=f[k])%=N ;           // P=mod(P*t+f[k],N) ;
    }
    g.isGCD(P,N) ;
    if( g>1 && g<N ) {
       delete [] f ;
      return g ;
    }
    (t*=s)%= N ;
  }
  delete [] f ;
  return 1 ;

}

static Mint  p_11(const Mint& N,Mint& x,const unsigned long B)
{
  x=2 ;
  Mint x1(x),P(2),g ;
  unsigned long p,q,q1,l ;

  unsigned long c ;
  p=1 ;

     // q <-> i
     // p work
     //  q1=q2=1 ;
  q=1 ;
  q1=1 ;
NextPrime:
  for( c=0 ;; c=0 ) {

    for(;;) {
      q=nextprm(q) ;      // q i Ԗڂ̑f
      if( q>B ) {         // B ͍lő̈
        g.isGCD(P,N) ;
                         // q1 ̃[v܂łɎgpőf
        if( g==1 ) return 1 ;
        else { l=q ; q=q1 ;  x=x1 ; goto Backtrack ; }
      }

Compute_power:
      p=q ;
      l=B/q ;
      while( p<=l ) p*=q ;   // B zȂ q ̙p߂

      x.power(x,Mint(p),N) ;
      g.isSubUL(x,1) ;
      (P*=g)&=N ;
      if( ++c==1 ) break ;
    }

Compute_GCD:               // c=20 ̂Ƃ֗
    g.isGCD(P,N) ;
    if( g==1 ) { q1=q ;  x1=x ; }  // ǂ܂łoĂ
    else { l=q ; q=q1 ; x=x1 ; break ;  }    // Õ[v𔲂
  }
Backtrack:
  if( p>B ) return 1 ;

//cout << endl << "BackTrack " ;
//cout << endl << "g " << g ;
//cout << endl << "q1 l " << q1 << " " << l ;

  for( ; q<=l ; ) {
    q=nextprm(q) ;
    p=q ;

Finished:
    for(; ;) {
      x=power(x,Mint(q),N) ;
      g.isGCD(x-1,N) ;
      if( g==1 ) {
        p*=q ;
        if( p>B ) break ;   // goto BackTrack ;
      }
      else {
        if( g<N ) return g ;
        else return 1 ; // rare occuerunce. failed
      }
    }
  }
  return 1 ;

}
