//
//  Copyright (C) by S.Tomabechi 1995,2000
//  All rights reserved.
//
//  power mod p
//
#ifdef __BORLANDC__
#pragma inline
#endif

unsigned long power(const unsigned long x,const unsigned long n,
                    const unsigned long p)
{
#ifndef __BORLANDC__
  unsigned long y ;
#endif

  __asm {
    mov   ebx,1                // y <- 1
    mov   esi,n                // esi <- n fixed
    bsr   edi,esi              // edi = bit length of n
    jz    RET1                 // exit if n=0
    mov   ecx,p                // ecx <- p fixed
  }
POSITIVE:
  __asm {
    mov  eax,x
    xor  edx,edx
    div  ecx
  }
LOOP1:
  __asm {
    test si,1               // n is odd ?
    jz   SQUARE              // even
    mov  eax,ebx            // y
    mov  ebx,edx            // save x
    mul  edx                // y*x
    div  ecx                 // %p
    xchg ebx,edx           // ebx <- (y*x)%p   edx <- x
  }
SQUARE:
  __asm {
    dec edi
    js  RET1
    shr esi,1                // n /= 2
    mov  eax,edx               // eax <- x
    mul  edx                   // x*x
    div ecx                  // %p
    jmp LOOP1
  }
RET1:
#ifdef __BORLANDC__
  __asm {
    mov eax,ebx
  }
  return _EAX ;
#else
  __asm {
    mov y,ebx
  }
  return y ;
#endif

}
