//
//	Copyright (C) by S.Tomabechi 1995,1999
//	All rights reserved.
//
//	decompose integer by given primes
//
//	long nPrimes		  : (I)	 number of primes
//	unsigned long* Priems : (I)	 array of primes
//	unsigend long* index  : (I/O) power
//	Mint  q				  : (I/O) remained part which is not divided by given primes
//
//	return value  1 : decomposed completely
//				  0 : not so
//
//	1995.01.17
//	^ꂽ 4byte fQŐfA̙pwindex ɉ
//	ŏɌĂԂ܂ɁAĂяo index NAĂ
//	factor base ̑f͑傫ɊւďɂȂĂ邱
//
//	ex.
//	  for( j=0 ; j<nPrimes ; j++ ) index[j]=0 ;
//	  PrimeDecomp(nPrimes,Primes,index,a) ;
//	  PrimeDecomp(nPrimes,Primes,index,b) ;
//	  index ɂ a*b ̑f̙pwZbg
//
//
//	long nPrimes		  : (I)	 f̌
//	unsigned long* Priems : (I)	 f̔z
//	unsigend long* index  : (I/O) pw
//	Mint  q				  : (I/O)	 f鐮(؂Ȃc̕)
//
//	߂l	1 : ؂ꂽ
//			0 : ^ꂽfQł́A؂Ȃ
//

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"


int PrimeDecomp(unsigned long nPrimes,unsigned long* Primes,
				unsigned long* index,Mint& q)
{

  long j(-1) ;
  int rc ;
  unsigned long p(0) ;

Initialize:
  __asm {
#ifdef __BORLANDC__
	mov	  ebx,q
	mov	  ecx,[ebx.nDigit]		 // 
	mov	  esi,[ebx]		  // L
#else
	mov	  ebx,q
	mov	  ecx,[ebx+NDIGIT]
	mov	  esi,[ebx]
#endif
	dec	  ecx

  }
Try_Div:
  __asm {
	xor	  edi,edi						// power
										// edi ͊ꂽ
  }
Main_loop:
  __asm {
	dec	  nPrimes
	js	  RET0

	inc	  j
	mov	  edx,j
	mov	  ebx,Primes

	mov	  eax,[edx*4+ebx]
	cmp	  eax,p
	je	  Main_loop

	or	  eax,eax
	jz	  Main_loop
  }
Main_loop1:
  __asm {
	mov	  p,eax							// p is a prime

	xor	  edx,edx
  }
Div1:
  __asm	  mov ebx,ecx
DivLoop1:								// divisible ?
  __asm {
	mov	  eax,[ebx*4+esi]
	div	  p
	dec	  ebx
	jns	  DivLoop1

	or	  edx,edx
	jz	  Div2							// divisible

	or	  edi,edi
	jz	  Main_loop						// p does not divde q

	mov	  edx,j
	mov	  ebx,index
	add	  [edx*4+ebx],edi				// add index of power
										// ꂽ񐔂
	xor	  edi,edi
	or	  ecx,ecx						// 1 digit ?
	jnz	  Main_loop
	cmp	  dword ptr [esi],1				// remained part is 1 ?
	je	  FACTORED						// decomposed completely

	xor	  edx,edx
	mov	  eax,[esi]
	div	  p
	cmp	  eax,p						   // quotient < prime ?
										// ̕菬 ?
	ja	  Main_loop

	mov	  ebx,Primes
	mov	  edx,j
	mov	  eax,[esi]
  }
MORE:
  __asm {
	dec	  nPrimes
	js	  RET0						   // divided by all primes
										// fs
	inc	  edx
	cmp	  eax,[ebx+4*edx]	// compare insted of division
							// cĂ鐮ƁAfr
	ja	  MORE
	jb	  RET0
	mov	  j,edx
	jmp	  Main_loop1
  }

FACTORED:
  __asm {
	mov	  eax,1							// succeed
	jmp	  RET1
  }
Div2:									//divide exactly q <- q/p
										// ۂɊāAɒu
  __asm mov ebx,ecx
DivLoop2:
  __asm {
	mov	  eax,[ebx*4+esi]
	div	  p
	mov	  [ebx*4+esi],eax
	dec	  ebx
	jns	  DivLoop2

	inc	  edi							// ꂽ񐔂 1 ₷

	cmp	  dword ptr [ecx*4+esi],0	   //  ?
	jnz	  Div1
	dec	  ecx							//  1 炷

	cmp	  dword ptr [ecx*4+esi],0	   //  ?
	jnz	  Div1
	dec	  ecx							//  1 炷
	jmp	  Div1							// try more
										// Ɋ邩ׂ
  }

RET0:
  __asm xor eax,eax	  // not fully factored
RET1:
  __asm {
	mov rc,eax
	inc ecx
	mov ebx,q
#ifdef __BORLANDC__
	mov [ebx.nDigit],ecx
#else
	mov [ebx+NDIGIT],ecx
#endif
  }

  return rc ;

}

