//
//	Copyright (C) by S.Tomabechi 1997
//	All rights reserved.
//
//	compute square by Karatsuba's method
//
//	faster than to compute as a*a ( isMulF(a,a) )
//

#ifdef __BORLANDC__
#pragma inline
#endif
#define _ONLY_FINTDECL_
#include "Fint.hpp"
//#include "Error.hpp"

///////////////////////////
//
//	squaring number
//
Fint& Fint::isSquare(const Fint& a)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif
  int afDigit ;

  __asm {
	mov esi,a
#ifdef __BORLANDC__
	mov eax,[esi.fDigit]
	mov afDigit,eax
	mov ebx,[esi.nDigit]
#else
	mov eax,[esi+FDIGIT]
	mov afDigit,eax
	mov ebx,[esi+NDIGIT]
#endif
	shl	 ebx,1
	cmp	 ebx,eax
	ja	 PRODUCT
	mov	 esi,this					  // a!=0 but a*a=0
#ifdef __BORLANDC__
	mov	 dword ptr [esi.nDigit],0
	mov	 [esi.fDigit],eax
	mov	 byte ptr [esi.nDim+3],1
#else
	mov	 dword ptr [esi+NDIGIT],0
	mov	 [esi+FDIGIT],eax
	mov	 byte ptr [esi+SIGN],1
#endif
	jmp	 RET1
  }
PRODUCT:
  __asm {
#ifdef __BORLANDC__					  // treate as integer
	mov dword ptr [esi.fDigit],0
#else
	mov dword ptr [esi+FDIGIT],0
#endif
  }

  ((Mint*)this)->isSquare((Mint&)a) ; // porduct as integer
#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
#endif

  __asm {
	mov esi,a
	mov edi,this
	cmp esi,edi
	je	SET_THIS
	mov eax,afDigit
#ifdef __BORLANDC__					  // integer -> real number
	mov [esi.fDigit],eax
#else
	mov [esi+FDIGIT],eax
#endif
  }
SET_THIS:
  __asm {
	mov eax,afDigit
#ifdef __BORLANDC__
	mov [edi.fDigit],eax
	mov esi,[edi]
	mov ecx,[edi.nDigit]
#else
	mov [edi+FDIGIT],eax
	mov esi,[edi]
	mov ecx,[edi+NDIGIT]
#endif
  }

  __asm {

	lea	  ebx,[esi+eax*NBYTE]
	sub	  ecx,eax
	jbe	  this_is_Zero

#ifdef __BORLANDC__
	sub	  [edi.nDigit],eax
#else
	sub	  [edi+NDIGIT],eax
#endif
	mov	  eax,[ebx-NBYTE]		//	round
	add	  eax,0x80000000
	xor	  edx,edx
  }
AddMove:
  __asm {
	mov	  eax,[edx*NBYTE+ebx]
	adc	  eax,0
	mov	  [edx*NBYTE+esi],eax
	lea	  edx,[edx+1]
	dec	  ecx
	jnz	  AddMove
	jnc	  RET1					   // without carry

#ifdef __BORLANDC__
	inc	  dword ptr [edi.nDigit]	   // with carry
#else
	inc	  dword ptr [edi+NDIGIT]
#endif
	mov	  dword ptr [edx*NBYTE+esi],1
	jmp	  RET1
  }

this_is_Zero:						   // set 0
  __asm {
#ifdef __BORLANDC__
	mov byte ptr [edi.nDim+3],1
	mov dword ptr [edi.nDigit],0
#else
	mov byte ptr [edi+SIGN],1
	mov dword ptr [edi+NDIGIT],0
#endif
  }

RET1:
#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

