//
//  Copyright (C) by S.Tomabechi by 1994,1995,1997
//  All rights reserved.
//
//  subtraction single precision integer from multiple precision integer
//
//  dxPx
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isSubUL(const Mint& a,const unsigned long n)
{
#ifdef _MEMMAN
a.check(__FILE__,__LINE__) ;
#endif
       // if a is negative, calculate -((-a)+b)
  __asm {
    mov ebx,a
#ifdef __BORLANDC__
    cmp dword ptr [ebx.nDim],0
    jge POSITIVE
    neg  byte ptr [ebx.nDim+3]
#else
    cmp dword ptr [ebx+NDIM],0
    jge POSITIVE
    neg byte ptr [ebx+SIGN]
#endif
  }

  isAddUL(a,n) ;

  __asm {
    mov ebx,a
    cmp ebx,this
    je  Negate
#ifdef __BORLANDC__
    neg byte ptr [ebx.nDim+3]           // reset signature
#else
    neg byte ptr [ebx+SIGN]
#endif
  }
Negate:
  return isNeg(*this) ;

POSITIVE:

  int shift(a.fDigit) ;
  int anDigit(a.nDigit) ;
  int rDigit=( anDigit>shift ? anDigit:(shift+1)) ;

  if( ndim()<rDigit+1 ) {
    if( this==&a ) reallocate(rDigit+1) ;
    else allocate(rDigit+1) ;
  }

  __asm {
    mov   edi,this
    mov   esi,a

    cmp   edi,esi                       // parameter and return value are same ?
    je    SubSelf
#ifdef __BORLANDC__
    mov   eax,anDigit                   // copy number of digits
    mov   [edi.nDigit],eax
    mov   ecx,shift                     // copy fration part
    mov   [edi.fDigit],ecx
    mov   al,byte ptr [esi.nDim+3]
    mov   byte ptr [edi.nDim+3],al

    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   eax,anDigit
    mov   dword ptr [edi+NDIGIT],eax
    mov   ecx,shift
    mov   dword ptr [edi+FDIGIT],ecx
    mov   al,byte ptr [esi+SIGN]
    mov   byte ptr [edi+SIGN],al

    mov   esi,[esi]
    mov   edi,[edi]
#endif

    jecxz  Subtract
    cmp   ecx,anDigit
    jbe   Copy
    mov   ecx,anDigit
    dec   ecx
    js    SET_ZERO
//  jecxz SET_ZERO                      // in case a=0
  }
Copy:
  __asm {
    mov   eax,dword ptr [ecx*NBYTE+esi]
    mov   dword ptr [ecx*NBYTE+edi],eax
    dec   ecx
    jns   Copy
  }
SET_ZERO:
  __asm {
    mov ecx,shift
    mov edx,anDigit
    sub ecx,edx
    jbe Subtract
    xor eax,eax                 // bug fix 2000/06/10
  }
MORE:
  __asm {
    mov [edx*NBYTE+edi],eax
    inc edx
    dec ecx
    jnz MORE
  }
Subtract:
  __asm {
    mov  ecx,shift
    mov  eax,anDigit
    cmp  ecx,eax
    jb   SUB_NN
    mov  ebx,n
    neg  ebx
    mov  [ecx*NBYTE+edi],ebx
    or   ebx,ebx
    jz   RET1

  }
//N_IS_ZERO:
  __asm {
    inc  ecx
    mov  esi,this
#ifdef __BORLANDC__
    mov [esi.nDigit],ecx
#else
    mov dword ptr [esi+NDIGIT],ecx
#endif
    stc
    jmp Overflow
  }
SUB_NN:
  __asm {
    mov   edx,ecx
    sub   ecx,eax                       //  shift-anDigit  <=0
    mov   eax,[edx*NBYTE+esi]
    sub   eax,n               // edx=b
    mov   [edx*NBYTE+edi],eax
    inc   ecx
    jecxz Overflow
  }
SubLoop:
  __asm {                               // do for remained digits
    inc   edx
    mov   eax,dword ptr [edx*NBYTE+esi]
    sbb   eax,0
    mov   dword ptr [edx*NBYTE+edi],eax

    inc   ecx                    // Ō̌܂ő˂΂ȂȂ
    jnz   SubLoop
    jmp   Overflow               //  borrow is remained ?
  }
SubSelf:
  __asm {
#ifdef __BORLANDC__
    mov   edi,[esi]
#else
    mov   edi,dword ptr [esi]
#endif
    mov   ecx,shift
    mov   edx,anDigit
    sub   ecx,edx
    jbe   SUB2
    xor   eax,eax
  }
SET_ZERO2:
  __asm {
    mov   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   SET_ZERO2
  }
SUB2:
  __asm {
    mov   ecx,shift
    mov   eax,anDigit
    cmp   ecx,eax
    jb    SUB4

    mov   ebx,n
    neg   ebx
    mov   [ecx*NBYTE+edi],ebx
    or    ebx,ebx                // n=0 ?
    jz    RET1
  }
//SUB3:
  __asm {
    inc  ecx                     // in case *this is small real number < 1
    mov  esi,this
#ifdef __BORLANDC__
    mov [esi.nDigit],ecx
#else
    mov dword ptr [esi+NDIGIT],ecx
#endif
    stc                            // set carry flag on
    jmp   Overflow                 // take a complement
  }
SUB4:
  __asm {
    mov   edx,ecx
    sub   ecx,eax
    mov   ebx,n
    sub   [edx*NBYTE+edi],ebx // edx=b
    inc   ecx
    jecxz  Overflow
    mov   eax,0                         // DO NOT CHANGE carry flag
  }
SUB_LOOP2:
  __asm {
    inc   edx
    sbb   dword ptr [edx*NBYTE+edi],eax
//    sbb   dword ptr [edx*NBYTE+edi],0
    jnc   end                 // without borrow
    inc   ecx
    jnz   SUB_LOOP2
  }
Overflow:
  __asm {
    jnc   end

    mov   esi,this              // overflow
#ifdef __BORLANDC__
    neg   byte ptr [esi.nDim+3]
    mov   esi,[esi]
#else
    neg   byte ptr [esi+SIGN]
    mov   esi,[esi]
#endif

    mov   ecx,rDigit
    mov   edx,1
    clc
  }
neg_loop:                     // calculate complement
  __asm {
    mov   eax,[esi]
    not   eax
    adc   eax,edx
    mov   edx,0
//    adc   edx,0
    adc   edx,edx            // save carry flag
    mov   [esi],eax
    lea   esi,[esi+NBYTE]   // here DO NOT CAHNGE carry flag
    dec   ecx
    jnz   neg_loop
  }
end:
  __asm {
    mov   edi,this
#ifdef __BORLANDC__
    mov   esi,[edi]
#else
    mov   esi,[edi]
#endif

    mov   ecx,rDigit
    xor   eax,eax
  }
NORMALIZE:
  __asm {                       // check #digits
    cmp   dword ptr [ecx*NBYTE+esi-NBYTE],eax // 0 ?
    jne   SET_DIGIT
    dec   ecx
    jnz   NORMALIZE

#ifdef __BORLANDC__
    mov  byte ptr [edi.nDim+3],1    // normalize zero. avoid -0
#else
    mov   byte ptr [edi+SIGN],1
#endif
  }
SET_DIGIT:
  __asm {
#ifdef __BORLANDC__
    mov [edi.nDigit],ecx       // set # of significant digits
#else
    mov dword ptr [edi+NDIGIT],ecx
#endif
  }
RET1:
#ifdef _MEMMAN
_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

