//
//  Copyright (C) by S.Tomabechi 1998,1999
//  All rights reserved.
//
//  square root mod p s.t.  x^2=a mod p
//
//  f p   a ɂ p @Ƃ a ̕ x
//
//      x^2=a mod p
//
//  ߂.
//  ̊֐𗘗pƂ, Kronecker-Jacobi L g
//   a  p Ɋւĕ]ł邱Ƃm߂Ă.
//  (a/p)=1  ̂ƂԂ. (a/p)=-1 ̂Ƃ̓|v邩mȂ.
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include <iostream.h>
#include <iomanip.h>
unsigned long power(const unsigned long x,const unsigned long n,const unsigned long p) ;
long Kronecker(const unsigned long a,const unsigned long n) ;

unsigned long sqrt(const unsigned long a,const unsigned long p)
{

  unsigned long q ;
  unsigned long r ;

  __asm {
    mov ebx,p
  }
  __asm {
    mov eax,a             // a%p
    xor edx,edx
    div ebx

    or  edx,edx           // p|a ?
    jz  RET0
  }
  __asm {
    mov eax,ebx
    and eax,3              // p mod 4
    cmp eax,3
    jne mod8
    jmp RET1
  }

mod8:                      // p!=3 mod 4
  __asm {
    mov eax,ebx
    and eax,7             // p mod 8
    cmp eax,5             // p=5 mod 8 ?
    jne CASE1
    jmp CASE5
  }
CASE1:
  __asm {
    cmp eax,1
    je  Shanks
    jmp RETa
  }
Shanks:
  __asm {
    xor esi,esi
    mov eax,ebx
    dec eax
  }
EVEN_1:
  __asm {
    test eax,1
    jnz  EXIT_LOOP
    inc esi
    shr eax,1
    jmp EVEN_1
  }
EXIT_LOOP:
  __asm {
    mov r,esi
    mov q,eax                 // p-1=2^r*q
  }

   unsigned long nn(p) ;
   unsigned long n ;
Find_generator:               // generate random number 

   __asm {
     mov eax,nn
     mov ebx,1664525
     mul ebx
     add eax,1013904223
     mov nn,eax
     xor edx,edx
     div p
     mov n,edx
   }
   if( Kronecker(n,p)!=-1 ) goto Find_generator ;
//Initialize:
  unsigned long y=power(n,q,p) ;
  q=power(a,(q-1)>>1,p) ;

  __asm {
    mov ebx,p             // ebx <- p fixed 
    mov eax,q             // x=q
    mul eax               //  x*x
    div ebx               //  edx <- (x*x) mod p
    mov eax,a
    mov ecx,eax
    mul edx               //  a*((x*x) mod p)
    div ebx               //  mod p
    mov a,edx             // a=b

    mov eax,q
    mul ecx               // * a
    div ebx
    mov q,edx             // x <- x*a mod p
  }
LOOP_1:
  __asm {
    mov eax,a
    cmp eax,1
    je  RETq
    mul eax               // b*b
    div ebx               // edx <- b*b mod p
    mov edi,1
  }
IS_1:
  __asm {
    cmp edx,1             // b2=1 ?
    je  LEAVE_1
    mov eax,edx
    mul edx               // eax <- eax *eax
    div ebx               // mod p   edx=b^2
    inc edi
    jmp IS_1
  }
LEAVE_1:
  __asm {
    cmp edi,r
    je  RET00
    mov eax,y
    mov edx,eax
    mov ecx,r
    sub ecx,edi
    dec ecx
    jz  MUL_LOOP_END
  }
MUL_LOOP:
  __asm {
    mul eax
    div ebx
    mov eax,edx
    dec ecx
    jnz MUL_LOOP
  }
MUL_LOOP_END:
  __asm {
    mov esi,edx
    mov eax,esi
    mul esi
    div ebx
    mov y,edx   // y <- (t^2)%p

    mov eax,a   //
    mul edx
    div ebx
    mov a,edx   // b<-(b*y)%p

    mov r,edi   // r <- m

    mov eax,q
    mul esi
    div ebx
    mov q,edx
    jmp LOOP_1
  }

RETq:
  return q ;
RET00:
  goto RET0 ;

CASE5:
  if( power(a,(p-1)>>2,p)==1 ) {
    return power(a,(p+3)>>3,p) ;
  }
  else {
            // calculate (2*a*power(4*a,(p-5)/8,p))%p 
    __asm {
      mov   eax,a
      xor   edx,edx
      shld  edx,eax,2
      shl   eax,2
      div   p
      mov   r,edx
    }

    q=power(r,(p-5)>>3,p) ;

    __asm {
      mov ecx,p
      mov eax,q
      mul a
      div ecx
      mov eax,edx
      xor edx,edx
      shld edx,eax,1
      shl  eax,1
      div ecx
      mov q,edx
      jmp RETq
    }
  }
RET0:
  return 0 ;
RETa:
  return a ;
RET1:
  return power(a,(p+1)>>2,p) ;
}


