//
//	Copyright (C) by S.Tomabechi 1993-1996
//	All rights reserved.
//
//	assign a number to Mint by signed long integer
//
//	Px̑
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::operator=(const long n)
{
  int tfDigit ;
  __asm {
	mov esi,this
#ifdef __BORLANDC__
	mov eax,[esi.fDigit]
#else
	mov eax,[esi+FDIGIT]
#endif
	mov tfDigit,eax
#ifdef __BORLANDC__
	mov ebx,[esi.nDim]
#else
	mov ebx,[esi+NDIM]
#endif
	and ebx,_DIGITS_
	cmp eax,ebx
	jb	ASSIGN
  }

  allocate(tfDigit+1) ; 	 // enlarge array

  __asm {
	mov   esi,this
  }
ASSIGN:
  __asm {
	mov   edx,n 						// eax <- n fixed
	or	  edx,edx						// n=0 ?
	jnz   NONZERO
#ifdef __BORLANDC__
	mov   dword ptr [esi.nDigit],edx	 // n=0
	mov   byte ptr [esi.nDim+3],1
#else
	mov   dword ptr [esi+NDIGIT],edx
	mov   byte ptr [esi+SIGN],1
#endif

	jmp   RET1
  }

NONZERO:
  __asm {
	mov   al,1					// al : signature
	or	  edx,edx
	jge   SET				   // n is positive
  }

  __asm {					   // n is negative
	neg   edx				  // absolute value of n
	neg   al				   // negate signature
  }

SET:
  __asm {
#ifdef __BORLANDC__
	mov   [esi.nDim+3],al
	mov   ecx,[esi.fDigit]
	mov   [esi.nDigit],ecx
	inc   dword ptr [esi.nDigit]

	mov   esi,[esi]
#else
	mov   [esi+SIGN],al
	mov   ecx,[esi+FDIGIT]
	mov   [esi+NDIGIT],ecx
	inc   dword ptr [esi+NDIGIT]

	mov   esi,[esi]
#endif
	mov   [ecx*NBYTE+esi],edx	// set integer n
//	  or	ecx,ecx 						 // is there fractional part
//	  jz	RET1
	dec   ecx
	js	  RET1
	xor   eax,eax
  }
CLEAR:
  __asm {
	mov   [ecx*NBYTE+esi],eax  // clear frational part
	dec   ecx
	jns   CLEAR
  }
RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}
