//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  compute cyclotomic number
//
//  deg :degree  x^deg-1=\prod \phi_n(x)
//  x   variable
//
#ifdef __BORLANDC__
#   include <vector.h>
#else 
#   include <vector>    
#endif
#include "Mint.hpp"
#include "MintFunc.hpp"
using namespace std ;

Mint cyc_num(unsigned long d,long x)
{
#if 0
  Mint c ;
  unsigned long q ;
  c=1 ;
  for( q=1 ; q<d  ; q++ ) ++(c*=x) ;    // c <- c*x+1

  for( q=2 ; q<d ; q++ ) {
    if( d%q==0 ) c/=cyc_num(q,x) ;      // divide by cyclotomic number with smaller degree
  }
  return c ;
#else
  Mint c ;
  unsigned long q,dq ;
  unsigned long sqd=isqrt(d) ;
//  if( sqd*sqd==d ) sqd-- ;
  c=1 ;
  for( q=1 ; q<d  ; q++ ) ++(c*=x) ;    // c <- c*x+1

  for( q=2 ; q<=sqd ; q++ ) {
    if( (d%q)==0 ) {
        c/=cyc_num(q,x) ;
        dq=d/q ;
        if( dq!=q ) c/=cyc_num(dq,x) ;

    }
//    if( d%q==0 ) c/=cyc_num(q,x) ;      // divide by cyclotomic number with smaller degree
  }
  return c ;
#endif
}


//
//  (x^n-1)/(x-1) 㐔Iɉ~ɕA
//  ~̒lzŕԂ
//

bool alg_factor_GRU(unsigned long n,unsigned long x,vector<Mint>& factors)
{
unsigned long q ;
//  int m ;
    int k(0) ;
    unsigned long sqn=isqrt(n) ;
    unsigned long nq ;
    for( q=1 ; q<=sqn ; q++ ) {
        if( n%q==0 ) {
            factors.push_back(cyc_num(q,x)) ;
cout << endl << "deg " << q ;
cout << endl << factors.back() ;
            nq=n/q ;
            if( nq!=q ) {
cout << endl << "deg " << nq ;
                factors.push_back(cyc_num(nq,x)) ;
cout << endl << factors.back() ;
            }   

        }
    }
    return true ;

}

//
//  (x^n-1)/(x-1) (n ͊) 㐔Iɉ~ɕA
//  ~̒lzŕԂ
//
bool alg_factor_GRU2(unsigned long n,unsigned long x,vector<Mint>& factors)
{
unsigned long q ;
//  int m ;
    int k(0) ;
    unsigned long n2=n<<1 ;
    unsigned long sqn=isqrt(n2) ;
    unsigned long nq ;
    if( (n&1)==0 ) return false ;
cout << endl << "n2 " <<n2 <<" sqrt " << sqn ;
    for( q=1 ; q<=sqn ; q++ ) {
        if( n2%q==0 ) {

            if( n%q!=0 && q!=2) {
                cout << endl << " q " << q ;
                factors.push_back(cyc_num(q,x)) ;
            }
            nq=n2/q ;
            if( nq!=q && n2%nq==0 && n%nq!=0 && q!=2  ) {
                cout << endl << " nq " << nq ;
                factors.push_back(cyc_num(nq,x)) ;
            }

        }
    }

    return true ;

}

#ifdef CYC_NUM_MAIN
#include <stdlib.h>
#include "Error.hpp"

#if 0
int main(void)
{
    Mint phi ;
    unsigned long d ;
    int x ;
    int j,k ;
    vector<Mint> factors ;
    Mint a,b ;
    for(;;) {
        cout << endl << "Input deg " ;
        cin >> d ;
        if( d==0 ) break ;
        while( !factors.empty() ) factors.pop_back() ;
        cout << endl << " value x " ;
        cin >> x ;
        if( !alg_factor_GRU2(d,x,factors) ) continue  ;
        a=1 ;
        for( j=0 ; j<factors.size() ; j++ ) a*=factors[j] ;
        b=(power(x,d)+1)/(x+1) ;

        if( a!=b ) {
            cout << endl << factors.size() ;
            cout << endl << a ;
            cout << endl << b ;
            Error(a9a9a9) ;
        }
    }
    return 1 ;
}
#endif


int main(void)
{
    Mint phi ;
    unsigned long d ;
    int x ;
    int j,k ;
    vector<Mint> factors ;
    Mint a,b ;
    for(;;) {
        cout << endl << "Input deg " ;
        cin >> d ;
        if( d==0 ) break ;
        while( !factors.empty() ) factors.pop_back() ;
        cout << endl << " value x " ;
        cin >> x ;
        if( !alg_factor_GRU(d,x,factors) ) continue  ;
        a=1 ;
        for( j=0 ; j<factors.size() ; j++ ) a*=factors[j] ;
        b=(power(x,d)-1)/(x-1) ;

        if( a!=b ) {
            cout << endl << factors.size() ;
            cout << endl << a ;
            cout << endl << b ;
            Error(a9a9a9) ;
        }
cout << endl << len10(a) << " digits " ;
cout << endl << len10(b) << " digits " ;
    }
    return 1 ;
}
#endif