//
//  Copyright (C) by S.Tmabechi 1995,1997
//  All rights reserved.
//
//  returns quotient and remainder by Euclidean division
//
//  Ə]Ԃ
//
//  a=q*b+r
//    q : 
//    r : ]  sign(a)=sing(r). a Ɠ̏]ōŏ̂
//
//  1995.12.28 index register ̎gԈႦĂ
//             ̌ʕsȃAhX̓eĂ
//
//  1999.05.03 Pxł̏Z̏ꍇɁA]̐̕ݒ肪ĂD
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"
#include <stdlib.h>

//
//      a : (I) dividend
//      b : (I) divisor
//      q : (O) quotient
//      r : (O) remainder
//
void divide(const Mint& a,const Mint& b,Mint& q,Mint& r)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif
                              // zero divide ?
  int anDigit(a.nDigit) ;
  int bnDigit(b.nDigit) ;
  if( bnDigit==0 ) Error(zero divide) ;

  if( anDigit<bnDigit ) {   // a<b quotient=0 remainder=a
    __asm {                 // 폜̐Βl
      mov eax,q
#ifdef __BORLANDC__
      mov dword ptr [eax.nDigit],0
      mov byte ptr [eax.nDim+3],1
#else
      mov dword ptr [eax+NDIGIT],0
      mov byte ptr [eax+SIGN],1
#endif
    }
    r=a ;                   // remainder
    return ;
  }

  if( bnDigit==1 ) {        // ͂Ђƌ
    q.isDivUL(a,(unsigned long)b) ;
    if( b.isNegative() ) ~q ;
    *r.digit=Mint::_res ;

    if( Mint::_res==0 ) {
      r.nDigit=0 ;
      r.nDim&=_POSITIVE_ ;    // 𐳂ɂ
    }
    else {
      r.nDigit=1 ;
      (r.nDim&=_DIGITS_)|=(a.nDim&0xff000000) ; // modified 1999/05/03
    }
    return ;
  }


  int shift(31) ;
  int qnDigit=anDigit-bnDigit+1 ;
  signed char aSign,qSign,bSign ;
  unsigned long q0,res ;
  unsigned long v1,v2 ;
  unsigned long j ;       // Z̃[v̉
  unsigned long j_n4 ;    //  (j-n)*4
  int Count ;
  unsigned long* ui,*vi,*ti ;

  if( r.ndim()<=anDigit ) r.allocate(anDigit+1) ;
  if( Mint::_vMtemp.ndim()<bnDigit ) Mint::_vMtemp.allocate(bnDigit) ;
  if( q.ndim()<qnDigit ) q.allocate(qnDigit) ; // i[̈m
#ifndef __BORLANDC__
  unsigned long* vptr=Mint::_vMtemp.digit ;
#endif

//D1:
  __asm {

    mov   edi,q
#ifdef __BORLANDC__
    mov   edi,[edi]
    mov   ti,edi
    mov   esi,dword ptr [@Mint@_vMtemp]
    mov   edi,r
    mov   edi,[edi]
#else
    mov   edi,[edi]
    mov   ti,edi
    mov   esi,vptr
    mov   edi,r
    mov   edi,[edi]
#endif
    mov   ui,edi   // xAhXƂ蒼ׂ͕̂ɂȂ̂
    mov   vi,esi   // CfbNXWX^oĂ

    mov   ebx,bnDigit    // v̌

    mov   edi,b
#ifdef __BORLANDC__
    mov   al,[edi.nDim+3]
    mov   edi,[edi]
#else
    mov   al,[edi+SIGN]
    mov   edi,[edi]
#endif
    mov   bSign,al
         // ォ 0 łȂrbgT
    bsr    ecx,[ebx*NBYTE+edi-NBYTE]
    sub    shift,ecx
    mov    ecx,shift
  }
                           // VtgȂ烁Rs[
  __asm {
    mov   eax,[edi+ebx*NBYTE-NBYTE]
//    shld  edx,eax,cl
  }
mult_vd:                            // _vMtemp=b<<shift
  __asm {
    dec   ebx
    jz    EXIT1
    mov   edx,eax
    mov   eax,[edi+ebx*NBYTE-NBYTE]
    shld  edx,eax,cl
    mov   [esi+ebx*NBYTE],edx
    jmp   mult_vd
  }
EXIT1:
  __asm {
    shl   eax,cl
    mov   [esi],eax

    mov   edi,a
#ifdef __BORLANDC__
    mov   al,[edi.nDim+3]
    mov   edi,[edi]
#else
    mov   al,[edi+SIGN]
    mov   edi,[edi]
#endif
    mov   aSign,al
    imul  bSign
    mov   qSign,al
    mov   esi,ui

    mov   ebx,anDigit               // a ̌
    xor   edx,edx
    mov   eax,[edi+ebx*NBYTE-NBYTE]
    shld  edx,eax,cl
    mov   [esi+ebx*NBYTE],edx  // ŏʌ̂ӂ
  }
mult_ud:                            // r=u<<shift
  __asm {
    dec   ebx
    jz    EXIT2
    mov   edx,eax
    mov   eax,[edi+ebx*NBYTE-NBYTE]
    shld  edx,eax,cl
    mov   [esi+ebx*NBYTE],edx
    jmp   mult_ud
  }
EXIT2:
  __asm {
    shl   eax,cl
    mov   [esi],eax
  }

//D2:
  __asm {                   // 
    mov   ebx,bnDigit       // b̌
    mov   edi,vi
    mov   eax,[ebx*NBYTE+edi-NBYTE]
    mov   v1,eax            // v̍ŏʌ
    mov   eax,[ebx*NBYTE+edi-2*NBYTE]
    mov   v2,eax            // v̎̌

    mov   eax,anDigit       // ǔ
    mov   j,eax
    sub   eax,ebx
    shl   eax,2
    mov   j_n4,eax

    add   ti,eax
  }

D3:                               // 肷
  __asm {
    mov   ebx,j
    mov   esi,ui
    mov   edx,[ebx*NBYTE+esi]  // edx=u[j]
    cmp   edx,v1          // u[j]=v1 ?
    jne   not_equal
    mov   eax,0ffffffffh            // u[j]=v1 eax=RADIX-1
    mov   q0,eax
    mov   ecx,[ebx*NBYTE+esi-NBYTE]   // ecx=u[j-1]
  }
test0:
  __asm {
    add   ecx,v1
    jc    D4
    mov   res,ecx
    jmp   test1
  }                           // 肷
not_equal:
  __asm {
    mov   eax,[ebx*NBYTE+esi-NBYTE]   // eax=u[j-1]  edx=u[j]
    div   v1                  // (u[j]*RADIX+u[j-1])/v1
    mov   q0,eax              // q0=̏
    mov   res,edx             // res=]
  }
test1:
  __asm {                    // v2*q0>(u[j]*RADIX+u[j-1]-q0*v1)*RADIX+u[j-2] ?
    mov   eax,v2              // eax=v2
    mul   q0                  // eax=v2*q0
    mov   ecx,[ebx*NBYTE+esi-2*NBYTE] // ecx=u[j-2]
    sub   ecx,eax             // ecx=u[j-2]-q0*v2
    mov   ecx,res             //
    sbb   ecx,edx                       // -(u[j]*RADIX+u[j-1]-q0*v1)
    jnc   D4                            //
  }
//q_1:
  __asm {
    dec   q0                  // čČ
    jmp   test0
  }

D4:
  __asm {                   // u-q*v |Ĉ
    mov   edi,vi
    mov   ecx,bnDigit
    add   esi,j_n4
    mov   Count,ecx

    xor   ecx,ecx           // ӂNA ecx=Overflow
    mov   ebx,ecx           // ebx=0
  }
mult:
  __asm {
    mov   eax,[edi]
    lea   edi,[edi+NBYTE]
    mul   q0
    add   eax,ecx           // ̌ borrow 
    adc   edx,0             // ӂ̌ɓ`
    mov   ecx,edx           // ӂZ[u
  }
//next1:
  __asm {
    add   eax,ebx           //  borrow 
    adc   ecx,0             // ӂ borrow Ƃď̌ɓ`
    sbb   [esi],eax    // u-q*v
    mov   ebx,0
//    adc   ebx,0             // borrow Z[u
    adc   ebx,ebx
    lea   esi,[esi+NBYTE]
    dec   Count
    jnz   mult              // ̌
    mov   eax,ecx
    mov   ecx,0
    add   eax,ebx
//    adc   ecx,0
    adc   ecx,ecx
    sbb   [esi],eax
    adc   ecx,0
  }
//D5:                         // ]̌
  __asm {
    mov   edi,ti
    mov   eax,q0
    mov   [edi],eax  // Z[u
    jecxz D7
  }
//D6:
  __asm {                   // ߂̂ŉ߂
    dec   dword ptr [edi]   //  
    mov   ecx,bnDigit
    mov   edi,vi
    mov   esi,ui
    add   esi,j_n4

    xor   ebx,ebx           // ebx=0 ƂƂƂ carry 
  }
Sub_loop:
  __asm {
    mov   eax,[ebx*NBYTE+edi]
    adc   [ebx*NBYTE+esi],eax   // v[j] ɉ
    inc   ebx
    dec   ecx
    jnz   Sub_loop                 // ̌
    adc   dword ptr [ebx*NBYTE+esi],0 // ő包ɁAӂ
  }
D7:
  __asm {                   // ZJԂ
//    cmp   j_n4,0            // ׂĂ̌ɂčsȂ ?
//    jle   D8
    sub   j_n4,NBYTE
    jc D8
    dec   j
    sub   ti,NBYTE
    jmp   D3                // ̌̏
  }


D8:                         // tK ]߂
  __asm {                   // ̉ߒŋ߂]́A d*v ŋ߂
    mov   esi,ui
    mov   ebx,bnDigit
    mov   ecx,shift
    or ecx,ecx
    jnz Renomal_0
    lea esi,[esi+ebx*NBYTE-NBYTE]
    jmp Search_nonZero
  }
Renomal_0:
  __asm {
    mov   eax,[esi]
  }
Renormal:                // փVtgEփVtgĐ]߂
  __asm {                   // u /= d
    dec   ebx
    jz    EXIT3
    mov   edx,eax
    mov   eax,[esi+NBYTE]
    shrd  edx,eax,cl
    mov   [esi],edx
    lea   esi,[esi+NBYTE]
    jmp   Renormal
  }
EXIT3:
  __asm {
    shr   eax,cl
    mov   [esi],eax

    }
Search_nonZero:
  __asm {
    mov   cl,aSign
    mov   ebx,bnDigit
    xor   eax,eax
  }
Check_digit_r:                 // 𒲂ׂ
  __asm {
    cmp   [esi],eax
    jne   nonZero_r
    lea   esi,[esi-NBYTE]
    dec   ebx
    jnz   Check_digit_r
                               // ̌͌Ȃ
    mov   cl,1                 // 𐳂ɂ
  }
nonZero_r:
  __asm {
    mov   esi,r

#ifdef __BORLANDC__
    mov   [esi.nDigit],ebx
    mov   [esi.nDim+3],cl
    mov   esi,q
    mov   edi,[esi]
#else
    mov   [esi+NDIGIT],ebx
    mov   [esi+SIGN],cl
    mov   esi,q
    mov   edi,[esi]
#endif
    mov   cl,qSign
    mov   ebx,qnDigit
    xor   eax,eax
  }
Check_digit_q:                   // ̌𒲂ׂ
  __asm {
    cmp   [ebx*NBYTE+edi-NBYTE],eax
    jne   nonZero_q
    dec   ebx
    jnz   Check_digit_q

    mov   cl,1
  }
nonZero_q:
  __asm {
#ifdef __BORLANDC__
    mov   [esi.nDigit],ebx
    mov   [esi.nDim+3],cl
#else
    mov   [esi+NDIGIT],ebx
    mov   [esi+SIGN],cl
#endif
  }
#ifdef _MEMMAN_DEBUG
Mint::_MemMan.check(__FILE__,__LINE__) ;
q.check(__FILE__,__LINE__) ;
r.check(__FILE__,__LINE__) ;
#endif

}
