//
//  Copyright (C) by S.Tomabechi 1998
//  ALl rights reserved.
//
//  return a module p
//
//  if a<0 b>0
//  a mod b is calculated as follows.
//  p-(-a mod p) mod p
//
#include "Error.hpp"

unsigned long mod(const long a,const unsigned long p)
{
  __asm {
    mov ebx,p        // modulus
    or  ebx,ebx
    jz  ERR          // Is modulus p zero ?
    xor edx,edx
    mov eax,a
    or  eax,eax
    jge POSITIVE

    neg eax          // a is negative
    div ebx          // calculate as -(-amod p)
    or  edx,edx
    jz  SET_RES

    sub ebx,edx      // p+a%p
    mov edx,ebx
    jmp SET_RES
  }
POSITIVE:
  __asm {
    div p
  }
SET_RES:
  __asm {
    mov p,edx
    jmp RET1
  }
ERR:
  Error( zero divide ) ;
RET1:
  return p ;
}

