//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  Montgomery reduction class
//  (not fast)
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "Mont.hpp"

//Mint Mont::modulus ;
//Mint Mont::inverse ;
//Mint Mont::IR ;
//Mont Mont::_Motemp ;
#ifdef __BORLANDC__
long Mont::mantissa ;
#endif


#if 1
Mont&  Mont::reduce(const Mint& x)
{
//cout << endl << "enter reduced" ;
#ifndef __BORLANDC__
  long mantis=Mont::mantissa ;
#endif
  if( x.isZero() ) { rep.nDigit=0 ; return *this ; }
  rep.isMul(x,inverse) ;
//  if( rep.nDigit>mantissa ) rep.nDigit=mantissa ;    //  mod R
  __asm {
    mov   esi,this
#ifdef __BORLANDC__
    mov   ecx,[esi.rep.nDigit]
    mov   ebx,[@Mont@mantissa]
#else
    mov   ecx,dword ptr [esi+NDIGIT]
    mov   ebx,mantis  // VC++  static o ւ̃ANZX̎dȂ
#endif
    cmp  ecx,ebx
    jbe  MulModulus

#ifdef __BORLANDC__
    mov   edi,[esi]
//    mov   edi,[esi.rep]
#else
    mov   edi,[esi]
#endif
    xor   eax,eax
  }
SEARCH_NON_ZERO:
  __asm {
    cmp   dword ptr [ebx*NBYTE+edi-NBYTE],eax
    jne   NON_ZERO
    dec   ebx
    jnz   SEARCH_NON_ZERO
  }
NON_ZERO:
  __asm {
#ifdef __BORLANDC__
    mov   [esi.rep.nDigit],ebx
#else
    mov   [esi+NDIGIT],ebx
#endif
  }


MulModulus:
  (rep*=modulus )+=x ;

  __asm {                 // t<- rep/R
    mov   esi,this
#ifdef __BORLANDC__
    mov   ecx,[esi.rep.nDigit]
    mov   ebx,[@Mont@mantissa]
#else
    mov   ecx,[esi+NDIGIT]
    mov   ebx,mantis   // VC++  static o ւ̃ANZX̎dȂ
#endif
    sub   ecx,ebx
    jae   SET_DIGIT
    xor   ecx,ecx
 }
SET_DIGIT:
 __asm {
#ifdef __BORLANDC__
    mov   [esi.rep.nDigit],ecx
    mov   edi,[esi.rep]
#else
    mov   [esi+NDIGIT],ecx
    mov   edi,[esi]
#endif
    jecxz RET1
    lea   esi,[ebx*NBYTE+edi]
  }
MOVE:
  __asm {
    mov   eax,[ecx*NBYTE+esi-NBYTE]
    mov   [ecx*NBYTE+edi-NBYTE],eax
    dec   ecx
    jnz   MOVE

  }
//  rep.isSub(rep,modulus);
RET1:
#if 1
#ifdef __BORLANDC__
  __asm {
    mov esi,this
    mov ebx,[@Mont@mantissa]
    cmp [esi.rep.nDigit],ebx
    jb  RET0
  }
#else
  __asm {
    mov esi,this
    mov ebx,mantis
    cmp [esi+NDIGIT],ebx
    jb  RET0
  }
#endif
  rep.isSub(rep,modulus) ;
#endif
RET0:
//  if( rep>=modulus ) rep-=modulus ;
//  if( rep.nDigit>mantissa ) rep.isSub(rep,modulus) ;
  return *this ;

}

#else

Mont&  Mont::reduce(const Mint& x)
{

  unsigned long p=(unsigned long)inverse ;
  unsigned long t ;
  unsigned long u ;
  t=(ndigit(x)+1)/2 ;
  if( 2*matissa>ndim(rep) ) {
    if( &rep==&x ) {
      rep.reallocate(2*mantissa) ;
    }
    else {
      rep.allocate(2*mantissa) ;
    }
  }
  if( &rep!=&x ) rep=x ;
  for( int j=0 ; j<t ; j++ ) {
    u=rep.digit[j]*p ;
    rep+=(u*modulus)[j] ;
  }

  __asm {                 // t<- rep/R
    mov   esi,this
#ifdef __BORLANDC__
    mov   ecx,[esi.rep.nDigit]
    mov   ebx,[@Mont@mantissa]
#else
    mov   ecx,dword ptr [esi+NDIGIT]
    mov   ebx,mantis   // VC++  static o ւ̃ANZX̎dȂ
#endif
    sub   ecx,ebx
    jae   SET_DIGIT
    xor   ecx,ecx
 }
SET_DIGIT:
 __asm {
#ifdef __BORLANDC__
    mov   [esi.rep.nDigit],ecx
    mov   edi,[esi.rep]
#else
    mov   [esi+NDIGIT],ecx
    mov   edi,[esi]
#endif
    jecxz RET1
    lea   esi,[ebx*NBYTE+edi]
  }
MOVE:
  __asm {
    mov   eax,[ecx*NBYTE+esi-NBYTE]
    mov   [ecx*NBYTE+edi-NBYTE],eax
    dec   ecx
    jnz   MOVE

  }
//  rep.isSub(rep,modulus);
RET1:
#if 1
  __asm {
    mov esi,this
    mov ebx,[@Mont@mantissa]
    cmp [esi.rep.nDigit],ebx
    jb  RET0
  }
  rep.isSub(rep,modulus) ;
#endif
RET0:
//  if( rep>=modulus ) rep-=modulus ;
//  if( rep.nDigit>mantissa ) rep.isSub(rep,modulus) ;
  return *this ;

}


#endif




