//
//	Copyright (C) 2001 by S.Tomabechi
//	All rights reserved.
//
//	calculate theta function
//	\theta(z,\tau) = \sum exp(2\pi*i(nz+1/2*(n\tau*n)))
//
//	see Mumford's book
//
// t00 <-> theta1
// t01 <-> theta2
#include "Complex.hpp"
#include "Matrix.hpp"
#include "Matrix.hpp"
#include "CPUTime.hpp"


Complex J_trans(const Complex& z,const Complex& tau) ;
Complex theta(const Complex& z,const Complex& t) ;
Complex theta1(const Complex& z,const Complex& t) ;
Complex dtheta(const Complex& z,const Complex& t) ;

Complex dctheta(const Complex& z,const Complex& t,const unsigned long n,const unsigned long a,
				const unsigned long b)
{
	Complex I(0,1) ;
//	Complex c=exp(2*pi()*I*(a*t*a/2/n/n+a*(n*z+b)/n/n)) ;
	Complex c=exp(2*pi()*I*(a*t*a/2+a*(n*z+b))/n/n) ;
	return c*dtheta(z+(a*t+b)/n,t)+
		a*c*theta(z+(a*t+b)/n,t)/n ;
}

Complex ctheta(const Complex& z,const Complex& t,const unsigned long n,const unsigned long a,
				const unsigned long b)
{
	Complex I(0,1) ;
//	Complex c=exp(2*pi()*I*(a*t*a/2/n/n+a*(n*z+b)/n/n)) ;
	Complex c=exp(2*pi()*I*(a*t*a/2+a*(n*z+b))/n/n) ;
	return c*theta(z+(a*t+b)/n,t) ;
}

Complex e(const Complex& a)
{
	return exp(2*pi()*Complex(0,1)*a) ;
}


#if 0
void reduction(Complex& t,Matrix<Mint>& A)
{
	Mint n ;
	Fint m ;
	Matrix<Mint> B(2,2) ;
//Initialize
	A(0,0)=A(1,1)=1 ;
	A(0,1)=A(1,0)=0 ;
// Reduce real part
	for(;;) {
		n=nearInt(real(t)) ;
		t=t-n ;
		B(0,0)=A(0,0)-n*A(1,0) ;   // translation by n
		B(0,1)=A(0,1)-n*A(1,1) ;
		B(1,0)=A(1,0) ;
		B(1,1)=A(1,1) ;
		A=B ;
// Finished
//cout << endl << t ;
		m=norm(t) ;
		if( m>=1 || ndigit(m-1)<2 ) return ;

		t=-conj(t)/m ;
//cout << endl << "m " << m ;

		B(0,0)=-A(1,0) ;   // translation by n
		B(0,1)=-A(1,1) ;
		B(1,0)=A(0,0) ;
		B(1,1)=A(0,1) ;
		A=B ;
	}



}
#endif


// Imт傫ƌvZs\(exp 傫Ȃ)Ȃ
// Jacobi ̕ϊg ( -> -1/тɑ΂)
//
// (z,+2)=(z,)
#if 0
Complex theta(const Complex& z,const Complex& tau)
{

	if( abs(imag(tau))>1000 ) {
		// use Jacobi's substitution
		// tau -> -1/tau
		return e(Complex(1)/8)*e(-z*z/(2*tau))/sqrt(tau)*theta1(z/tau,-1/tau) ;

	}
	else return theta1(z,tau) ;
}
#else
Complex theta(const Complex& zz,const Complex& tt)
{
	Complex I(0,1) ;

#if 1
	Matrix<Mint> A(2,2)	 ;
	Complex t=tt ;
	Complex z ;
	Complex m ;
	Complex ct ;
//cout << endl << "t " << t ;
//cout << endl << "zz " << zz << " " << abs(real(zz)) << " " << ( abs(real(zz))>1 );
	if( abs(real(zz))>1  || true ) {
		reduction(t,A) ;
cout << endl << "post reduct " << endl <<A ;
//cout << endl << "t " << t ;
		if( A(1,0)!=0 ) {
			ct=A(1,0)*tt+A(1,1) ;
//cout << endl << "ct " << ct ;
			z=zz/ct ;
//cout << endl << " zz" << (pi()*I*A(1,0)*zz*zz/ct) ;
//	m= ;
			m=exp(pi()*I*A(1,0)*zz*zz/ct) ;
//	m=exp(pi()*I*A(1,0)*zz*zz/ct) ;
//cout << endl << " m " << m << flush ;
//cout << endl << "sqrt " << sqrt(ct) ;
			m*=sqrt(ct) ;
//cout << endl << "8-th root " << exp(2*pi()*I/8) ;
			if( A(1,0)==0 ) ;
			else if( long(A(1,0))&1 ) {
				m*=exp(-2*pi()*I/8)*Kronecker(A(1,1),A(1,0)) ;
			}
			else {
				m*=power(I,(A(1,1)-1)/2)*Kronecker(A(1,0),abs(A(1,1))) ;
			}
		}
		else {
			z=zz ;
			t=tt-A(0,1) ;
			m=1 ;
		}
	}
	else {
		z=zz ;
//		t=tt ;
		m=1 ;
	}

//	  if( A(1,0)!=0 )
//cout << endl << "m " << endl << m ;


#else
	Complex t=tt ;
	Complex z=zz ;
#endif
	Complex zt=exp(2*pi(ndigit(real(z)))*I*(z+t/2)) ;
	Complex ztn=exp(2*pi(ndigit(real(z)))*I*(-z+t/2)) ;
	Complex et=exp(2*pi(ndigit(real(z)))*I*t) ;
	Complex nt(zt) ;
	Complex ntn(ztn) ;
	Complex T(zt) ;
	Complex w(1) ;
	Complex wn(1) ;
	T=1 ;
	unsigned long n ;
/*
	T+=zt ;
	T+=ztn ;
*/
#if 1
cout << endl << "et  " << et ;
cout << endl << "zt  " << zt ;
cout << endl << "ztn " << ztn ;
#endif
	for( n=1 ; ; n++ ) {
//		w*=zt*nt ;
		w*=nt ;
		wn*=ntn ;
#if 0
cout << endl << "w   " << w ;
cout << endl << "w   " <<exp(2*pi()*I*(n*z+n*t*n/2)) ;
cout << endl << "wn   " << wn ;

cout << endl << "wn   " <<exp(2*pi()*I*(-z*n+n*t*n/2)) ;
cout << endl << "ntn   " <<ntn ;
#endif
		if( w==0 && wn==0 ) break ;
		(T+=w)+=wn ;
		nt*=et ;
		ntn*=et ;
//cout << endl << T ;
//		nt*=et ;
	}
	return T/m ;
}
#endif

Complex theta1(const Complex& zz,const Complex& tt)
{
	Complex I(0,1) ;

#if 0
	Matrix<Mint> A(2,2)	 ;
	Complex t=tt ;
	Complex z=zz ;
	reduction(t,A) ;
	Complex ct=A(1,0)*tt+A(1,1) ;
	Complex z ;
	z=zz/ct ;
	Complex m ;
	m=exp(pi()*I*A(1,0)*zz*zz/ct) ;
	m*=sqrt(ct) ;
	m*=exp(2*pi()*I/8) ;


#else
	Complex t=tt ;
	Complex z=zz ;
#endif
	Complex zt=exp(2*pi(ndigit(real(z)))*I*(z+t/2)) ;
	Complex ztn=exp(2*pi(ndigit(real(z)))*I*(-z+t/2)) ;
	Complex et=exp(2*pi(ndigit(real(z)))*I*t) ;
	Complex nt(zt) ;
	Complex ntn(ztn) ;
	Complex T(zt) ;
	Complex w(1) ;
	Complex wn(1) ;
	T=1 ;
	unsigned long n ;
/*
	T+=zt ;
	T+=ztn ;
*/
#if 0
cout << endl << "et  " << et ;
cout << endl << "zt  " << zt ;
cout << endl << "ztn " << ztn ;
#endif
	for( n=1 ; ; n++ ) {
//		w*=zt*nt ;
		w*=nt ;
		wn*=ntn ;
#if 0
cout << endl << "w   " << w ;
cout << endl << "w   " <<exp(2*pi()*I*(n*z+n*t*n/2)) ;
cout << endl << "wn   " << wn ;

cout << endl << "wn   " <<exp(2*pi()*I*(-z*n+n*t*n/2)) ;
cout << endl << "ntn   " <<ntn ;
#endif
		if( w==0 && wn==0 ) break ;
		(T+=w)+=wn ;
		nt*=et ;
		ntn*=et ;
//cout << endl << T ;
//		nt*=et ;
	}
	return T ;
}



Complex dtheta(const Complex& zz,const Complex& tt)
{
	Complex I(0,1) ;

#if 0
	Matrix<Mint> A(2,2)	 ;
	Complex t=tt ;
	Complex z=zz ;
	reduction(t,A) ;
	Complex ct=A(1,0)*tt+A(1,1) ;
	Complex z ;
	z=zz/ct ;
	Complex m ;
	m=exp(pi()*I*A(1,0)*zz*zz/ct) ;
	m*=sqrt(ct) ;
	m*=exp(2*pi()*I/8) ;


#else
	Complex t=tt ;
	Complex z=zz ;
#endif
	Complex zt=exp(2*pi(ndigit(real(z)))*I*(z+t/2)) ;
	Complex ztn=exp(2*pi(ndigit(real(z)))*I*(-z+t/2)) ;
	Complex et=exp(2*pi(ndigit(real(z)))*I*t) ;
	Complex nt(zt) ;
	Complex ntn(ztn) ;
	Complex T(zt) ;
	Complex w(1) ;
	Complex wn(1) ;
	T=0 ;
	unsigned long n ;
/*
	T+=zt ;
	T+=ztn ;
*/
#if 0
cout << endl << "et  " << et ;
cout << endl << "zt  " << zt ;
cout << endl << "ztn " << ztn ;
#endif
	for( n=1 ; ; n++ ) {
//		w*=zt*nt ;
		w*=nt ;
		wn*=ntn ;
#if 0
cout << endl << "w   " << w ;
cout << endl << "w   " <<exp(2*pi()*I*(n*z+n*t*n/2)) ;
cout << endl << "wn   " << wn ;

cout << endl << "wn   " <<exp(2*pi()*I*(-z*n+n*t*n/2)) ;
cout << endl << "ntn   " <<ntn ;
#endif
		if( w==0 && wn==0 ) break ;
		T+=2*pi()*I*(w+wn) ;
//		(T+=w)+=wn ;
		nt*=et ;
		ntn*=et ;
//cout << endl << T ;
//		nt*=et ;
	}
	return T ;
}

Complex J_trans(const Complex& z,const Complex& tau)
{
	return e(Complex(1)/8)*e(-z*z/(2*tau))/sqrt(tau)*theta1(z/tau,-1/tau) ;
}

#if 0

int main(void)
{
	Complex z ;
	Complex tau ;
	Complex I(0,1) ;
	Complex c,t ;

	z=1 ;
	z/=100;
//	tau=Complex(0,sqrt(Fint(3)))/2;
	tau=10000+I/1000 ;
	cout << endl << theta(z,tau) ;
	cout << endl << theta1(z,tau) ;


	return 1 ;
}

#endif
#if 0
int main(void)
{
	Complex z ;
	Complex tau ;
	Complex I(0,1) ;
	Complex c,t ;
	Fint cc(0.01) ;
	Complex t01,t00,t10,t11 ;
	z=Complex(1,1)	;
	z=1 ;
	z=1 ;
	z/=2 ;
	z+=0.181*I ;

	cout << endl << exp(pi()*I*z) ;
	cout << endl << exp(2*pi()*I*z) ;
	tau=Complex(0.00150,0.005) ;
	cout << endl << exp(z) ;
	cout << endl << "exp " << exp(pi()*I*tau) ;
	z=0 ;
	t00=ctheta(z,tau,2,0,0) ;
	t01=ctheta(z,tau,2,0,1) ;
	t10=ctheta(z,tau,2,1,0) ;
	t=t10*t10*t10*t10 +t01*t01*t01*t01 ;

	cout << endl << t00*t00*t00*t00 ;
	cout << endl << t ;

	tau=I*cc ;
	z=0 ;
	cout << endl << theta(z,tau) ;
	tau=I*(1/cc) ;
	cout << endl << theta(z,tau)/sqrt(cc) ;


//	return 1 ;


	cout << endl << "theta(z  ) " << theta(z,tau) ;
	cout << endl << "theta(-z ) " << theta(-z,tau) ;
	cout << endl << "theta(z+1/2 ) " << theta(z+0.5,tau) ;
	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	t00=ctheta(z+1,tau,2,0,0) ;
	cout << endl << "t00(x+1) " << t00 ;
	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	t01=ctheta(z,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	t11=ctheta(z,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	t11=ctheta(z+1,tau,2,1,1) ;
	cout << endl << "t11(z+1) " << t11 ;
	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	t00=e(tau/2+z)*ctheta(z+1+tau,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	t01=ctheta(z,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	t01=e(tau/2+z)*ctheta(z+1+tau,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	t10=e(tau/2+z)*ctheta(z+1+tau,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	t11=ctheta(z,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	t11=e(tau/2+z)*ctheta(z+1+tau,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	cout << endl << "theta(1/2tau+1/2 ) " << theta(tau*0.5+0.5,tau) ;

//return 0 ;
	z=0 ;
	t11=ctheta(z+1,tau,2,1,1) ;
	cout << endl << "t11(0) " << t11 ;
	t11=ctheta(z+0.5,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	cout << endl << "theta(z+1) " << theta(z+1,tau) ;
	cout << endl << "theta(z+2) " << theta(z+2,tau) ;
	cout << endl << "theta(z+3) " << theta(z+3,tau) ;
	cout << endl << "theta(z+t) " << theta(z+tau,tau) ;
	t=theta(z+tau*pi(),tau) ;
	c=exp(-pi()*I*tau-2*pi()*I*z) ;
	t=c*theta(z,tau) ;
	cout << endl << "theta(z+t) " << t;



	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	z+=tau ;
//	z=0.5 ;
	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
//	return 0 ;



	t11=ctheta(z,tau,2,1,0) ;
	cout << endl << "t11 " << t11 ;
	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	t01=ctheta(z,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	cout << endl << "t01 " << theta(z+0.5,tau) ;
	t01=ctheta(-z,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	cout << endl << "t10 " << e(tau/8+z/2)*theta(z+0.5*tau,tau) ;
	t10=ctheta(-z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;

	t11=ctheta(z,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	cout << endl << "t11 " << e(tau/8+(z+0.5)/2)*theta(z+0.5*tau+0.5,tau) ;
	t11=ctheta(-z,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;

//	t11=ctheta(-z,tau,2,0,0) ;
//	cout << endl << "t11 " << t11 ;

//	cout << endl << theta(Complex(0.5,0.0),Complex(0.5,0.0)) ;
}

#endif


#if 0
int main(void)
{
	Complex tau,tau1,t,t1,c ;
	Complex zero(0) ;
	Matrix<Mint> A(2,2) ;
	tau=Complex(0,1) ;
	t=ctheta(zero,tau,2,0,0) ;
	A(0,0)=1 ;	A(0,1)=0 ;
	A(1,0)=4 ; A(1,1)=1 ;
	tau1=(A(0,0)*tau+A(0,1))/(A(1,0)*tau+A(1,1)) ;
	c=A(1,0)*tau+A(1,1) ;
	t1=ctheta(zero,tau1,2,0,0) ;
	cout << endl << "t^2/t1^2 " << (t/t1)*(t/t1) ;
	cout << endl << "ct+d " << c ;
	cout << endl << "Matrix"  << endl << A ;

	return 1 ;
}
#endif

#if 0
// t11(0,t)=0 mF
int main(void)
{
	Complex tau,c ;
	Complex zero(0) ;
	Matrix<Mint> A(2,2) ;

	tau=Complex(1919810,1) ;
	cout << endl << "t11 " << ctheta(zero,tau,2,1,1) ;
	tau=Complex(1919810,12) ;
	cout << endl << "t11 " << ctheta(zero,tau,2,1,1) ;
	tau=Complex(1919810,1234) ;
	cout << endl << "t11 " << ctheta(zero,tau,2,1,1) ;
//	cout << endl << "t11 " << theta(zero,tau) ;
	return 1 ;
}
#endif

#if 0
// t00 zero ̊mF
int main(void)
{
	CPUTime cpu ;
	Complex tau,c ;
	Complex z ;
	Complex t,t1 ;
	Complex I(0,1) ;
	Matrix<Mint> A(2,2) ;

	tau=Complex(1,1) ;
	z=tau+tau/2+Fint(1)/2 ;
	t=theta(z,tau) ;
//	z+=tau ;
	tau+=2 ;
//	z+=1 ;
	t1=theta(z,tau) ;
	cout << endl << "t  " << t ;
	cout << endl << "t1 " << t1 ;
//	cout << endl << t1/t ;
	cout << endl << e(-tau/2-z) ;

	return 1 ;
}
#endif

#if 0
// z -> -z ɑ΂U镑
// z -> z+1/2
int main(void)
{
	CPUTime cpu ;
	Complex tau,c ;
	Complex z,u ;
	Complex t,t1 ;
	Complex I(0,1) ;
	Complex t00,t01,t10,t11 ;
	Complex s ;

	tau=Complex(1,10111111) ;
	z=Complex(0.32,1.32) ;
	u=-z ;
	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	s=t00 ;
	t00=ctheta(u,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	cout << endl << s/t00 ;

	t01=ctheta(z,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	s=t01 ;
	t01=ctheta(u,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	cout << endl << s/t01 ;

	t10=ctheta(z,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	s=t10 ;
	t10=ctheta(u,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	cout << endl << s/t10 ;

	t11=ctheta(z,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	s=t11 ;
	t11=ctheta(u,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	cout << endl << s/t11 ;





	tau=Complex(1,1) ;
	z=Complex(0.32,1.32) ;
	u=z+Complex(0.5) ;
	t00=ctheta(z,tau,2,0,1) ;
	cout << endl << "t00 " << t00 ;
	s=t00 ;
	t00=ctheta(u,tau,2,0,0) ;
	cout << endl << "t00 " << t00 ;
	cout << endl << s/t00 ;

	t01=ctheta(z,tau,2,0,0) ;
	cout << endl << "t01 " << t01 ;
	s=t01 ;
	t01=ctheta(u,tau,2,0,1) ;
	cout << endl << "t01 " << t01 ;
	cout << endl << s/t01 ;

	t10=ctheta(z,tau,2,1,1) ;
	cout << endl << "t10 " << t10 ;
	s=t10 ;
	t10=ctheta(u,tau,2,1,0) ;
	cout << endl << "t10 " << t10 ;
	cout << endl << s/t10 ;

	t11=ctheta(z,tau,2,1,0) ;
	cout << endl << "t11 " << t11 ;
	s=t11 ;
	t11=ctheta(u,tau,2,1,1) ;
	cout << endl << "t11 " << t11 ;
	cout << endl << s/t11 ;

	return 1 ;
}

#endif

#if 1
// e[^萔ɊւJacobi ̌
int main(void)
{
	CPUTime cpu ;
	Complex tau,c ;
	Complex z,u ;
	Complex t,t1 ;
	Complex I(0,1) ;
	Complex t00,t01,t10,t11 ;
	Complex s ;

	tau=Complex(1,1) ;
	z=0 ;
	t00=ctheta(z,tau,2,0,0) ;

	t01=ctheta(z,tau,2,0,1) ;

	t10=ctheta(z,tau,2,1,0) ;

	cout << endl << "t00^4 " << t00*t00*t00*t00 ;
	cout << endl << "t10^4+t01^4 " << (t01*t01*t01*t01+t10*t10*t10*t10) ;

	return 1 ;
}
#endif
#if 0

int main(void)
{
	CPUTime cpu ;
	Complex tau,c ;
	Complex z,u ;
	Complex t,t1 ;
	Complex I(0,1) ;
	Complex t00,t01,t10,t11 ;
	Complex s ;

	tau=Complex(1,0.00100000) ;
	z=0 ;
	cout << endl << "dt11 " << dctheta(z,tau,2,1,1) ;
	t01=ctheta(z,tau,2,0,1) ;
	t10=ctheta(z,tau,2,1,0) ;
	t00=ctheta(z,tau,2,0,0) ;
	cout << endl << (-pi()*t01*t10*t00) ;
	return 1 ;
}
#endif
