//
//	Multiple precision fixed point number class	 Ver 2.40
//
//	Copyright (C) 1993-1998	 by S.Tomabechi
//		 All rights reserved
//
//	 Fractional points may different for each instaces.
//
//		Œ菬_̃NX.
//		X̃CX^X̏_̈ʒúAقȂĂ悢D
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif


#ifndef __FINT_HPP
#define __FINT_HPP

#include "Mint.hpp"
#ifdef __BORLANDC__
#	 pragma warn -lvc
#endif


class Rational ;
class Complex ;

class Fint : public Mint
{
#ifdef _TEST
#include "testfunc.inc"
#endif

		friend class Rational ;
		friend class Complex ;
public:
								// constructors
		Fint(const short n) ;
		Fint(const int n) ;
		Fint(const long n) ;
		Fint(const unsigned long n) ;
		Fint(const double& d) ;
		Fint(const long double& d) ;
		Fint() ;
		Fint(int size,int fsize) ;	// constructor specifing lenght of factional part
						 // xʂɐ䂷邽߂̃RXgN^
		Fint(const Fint& a):Mint((const Mint&)a) {}
		Fint(const Mint& a) ;
		Fint(const char* const c) ;

		~Fint(){} ;								// do nothing

		Fint& operator=(const Fint& a) ;
		Fint& operator=(const Mint& a) ;
		Fint& operator=(const short n) ;
		Fint& operator=(const int n) ;
		Fint& operator=(const long n) ;
		Fint& operator=(const unsigned long n) ;
		Fint& operator=(const double& d) ;
		Fint& operator=(const long double& d) ;
		Fint& operator=(const char Number[]) ;

		Fint	operator>>(const int a) const ;
		Fint	operator>>(const long a) const ;
		Fint	operator>>(const unsigned long a) const ;
		Fint	operator<<(const int a) const ;
		Fint	operator<<(const long a) const ;
		Fint	operator<<(const unsigned long a) const ;

											// arithmetic operators
		Fint& operator+=(const Fint& a) ;
		Fint& operator+=(const Mint& a) ;
		Fint& operator+=(const long n) ;
		Fint& operator+=(const short n) ;
		Fint& operator+=(const int n) ;
		Fint& operator+=(const unsigned long n) ;
		Fint& operator+=(const double& d) ;
		Fint& operator+=(const long double& d) ;

		Fint& operator-=(const Fint& a) ;
		Fint& operator-=(const Mint& m) ;
		Fint& operator-=(const short n) ;
		Fint& operator-=(const int n) ;
		Fint& operator-=(const long n) ;
		Fint& operator-=(const unsigned long n) ;
		Fint& operator-=(const double& d) ;
		Fint& operator-=(const long double& d) ;

		Fint& operator*=(const Fint& a) ;
		Fint& operator*=(const Mint& m) ;
		Fint& operator*=(const short n) ;
		Fint& operator*=(const int n) ;
		Fint& operator*=(const long n) ;
		Fint& operator*=(const unsigned long n) ;
		Fint& operator*=(const double& d) ;
		Fint& operator*=(const long double& d) ;

		Fint& operator/=(const Fint& a) ;
		Fint& operator/=(const Mint& a) ;
		Fint& operator/=(const short n) ;
		Fint& operator/=(const int n) ;
		Fint& operator/=(const long n) ;
		Fint& operator/=(const unsigned long n) ;
		Fint& operator/=(const double& d) ;
		Fint& operator/=(const long double& d) ;

		Fint& operator>>=(const int s) ;
		Fint& operator>>=(const long s) ;
		Fint& operator>>=(const unsigned long s) ;
		Fint& operator<<=(const int s) ;
		Fint& operator<<=(const long s) ;
		Fint& operator<<=(const unsigned long s) ;
													 // comparison
		bool	operator==(const Fint& a) const ;
		bool	operator==(const Mint& a) const ;
		bool	operator==(const short n) const ;
		bool	operator==(const int n) const ;
		bool	operator==(const long n) const ;
		bool	operator==(const unsigned long n) const ;

		bool	operator!=(const Fint& a) const ;
		bool	operator!=(const Mint& n) const ;
		bool	operator!=(const short n) const ;
		bool	operator!=(const int n) const ;
		bool	operator!=(const long n) const ;
		bool	operator!=(const unsigned long n) const ;

		bool	operator>(const Fint& a) const ;
		bool	operator>(const Mint& n) const ;
		bool	operator>(const short n) const ;
		bool	operator>(const int n) const ;
		bool	operator>(const long n) const ;
		bool	operator>(const unsigned long n) const ;
		bool	operator>(const double f) const ;

		bool	operator<(const Fint& a) const ;
		bool	operator<(const Mint& n) const ;
		bool	operator<(const short n) const ;
		bool	operator<(const int n) const ;
		bool	operator<(const long n) const ;
		bool	operator<(const unsigned long n) const ;
		bool	operator<(const double f) const ;

		bool	operator>=(const Fint& f) const ;
		bool	operator>=(const Mint& n) const ;
		bool	operator>=(const short n) const ;
		bool	operator>=(const int n) const ;
		bool	operator>=(const long n) const ;
		bool	operator>=(const unsigned long n) const ;

		bool	operator<=(const Fint& f) const ;
		bool	operator<=(const Mint& n) const ;
		bool	operator<=(const short n) const ;
		bool	operator<=(const int n) const ;
		bool	operator<=(const long n) const ;
		bool	operator<=(const unsigned long n) const ;
		bool	operator<=(const double n) const ;

		Fint& operator[](const long s) ;		 // shift as number with radix 2^32
												 // 2^32iƂẴVtg
		Fint	operator()(const long s) const ;  //  shift as number with radix 2^32

		Fint& operator++() ;			// ++x
		Fint	operator++(int) ;		// x++
		Fint& operator--() ;			// --x
		Fint	operator--(int) ;		// x--

		Fint	operator+() const ;
		Fint	operator-() const ;
		Fint& operator~() ;						// negation
												// ̔]
												// conversion operator
			  operator long double() const ;
			  operator double() const ;

		Fint& round(const int n) ;
		Fint& round(const long n) ;

		int fdigit() const ;


		// friend arithmetic operators
		friend Fint operator+(const Fint& a,const Fint& b) ;
		friend Fint operator+(const Fint& a,const Mint& b) ;
		friend Fint operator+(const Fint& a,const short b) ;
		friend Fint operator+(const Fint& a,const int b) ;
		friend Fint operator+(const Fint& a,const long b) ;
		friend Fint operator+(const Fint& a,const unsigned long b) ;
		friend Fint operator+(const Fint& a,const double& b) ;
		friend Fint operator+(const Fint& a,const long double& b) ;

		friend Fint operator+(const Mint& m,const Fint& f) ;
		friend Fint operator+(const short n,const Fint& f) ;
		friend Fint operator+(const int n,const Fint& f) ;
		friend Fint operator+(const long n,const Fint& f) ;
		friend Fint operator+(const unsigned long n,const Fint& f) ;
		friend Fint operator+(const double& d,const Fint& f) ;
		friend Fint operator+(const long double& d,const Fint& f) ;
		friend Fint operator+(const long double& d,const Mint& n) ;
		friend Fint operator+(const Mint& n,const long double& d) ;

		friend Fint operator-(const Fint& a,const Fint& b) ;
		friend Fint operator-(const Fint& a,const Mint& b) ;
		friend Fint operator-(const Fint& a,const short b) ;
		friend Fint operator-(const Fint& a,const int b) ;
		friend Fint operator-(const Fint& a,const long b) ;
		friend Fint operator-(const Fint& a,const unsigned long b) ;
		friend Fint operator-(const Fint& a,const double& b) ;
		friend Fint operator-(const Fint& a,const long double& b) ;

		friend Fint operator-(const Mint& m,const Fint& f) ;
		friend Fint operator-(const short n,const Fint& f) ;
		friend Fint operator-(const int n,const Fint& f) ;
		friend Fint operator-(const long n,const Fint& f) ;
		friend Fint operator-(const unsigned long n,const Fint& f) ;
		friend Fint operator-(const double& d,const Fint& f) ;
		friend Fint operator-(const long double& d,const Fint& f) ;
		friend Fint operator-(const Mint& n,const long double& d) ;
		friend Fint operator-(const long double& d,const Mint& n) ;

		friend Fint operator*(const Fint& f,const Fint& a) ;
		friend Fint operator*(const Fint& f,const Mint& a) ;
		friend Fint operator*(const Fint& f,const short n) ;
		friend Fint operator*(const Fint& f,const int n) ;
		friend Fint operator*(const Fint& f,const long a) ;
		friend Fint operator*(const Fint& f,const unsigned long n) ;
		friend Fint operator*(const Fint& f,const double& d) ;
		friend Fint operator*(const Fint& f,const long double& d) ;

		friend Fint operator*(const Mint& m,const Fint& f) ;
		friend Fint operator*(const short n,const Fint& f) ;
		friend Fint operator*(const int n,const Fint& f) ;
		friend Fint operator*(const long n,const Fint& a) ;
		friend Fint operator*(const unsigned long n,const Fint& f) ;
		friend Fint operator*(const double& d,const Fint& f) ;
		friend Fint operator*(const long double& d,const Fint& f) ;
		friend Fint operator*(const Mint& n,const double& d) ;
		friend Fint operator*(const Mint& n,const long double& d) ;
		friend Fint operator*(const double& d,const Mint& n) ;
		friend Fint operator*(const long double& d,const Mint& n) ;

		friend Fint operator/(const Fint& f,const Fint& a) ;
		friend Fint operator/(const Fint& f,const Mint& a) ;
		friend Fint operator/(const Fint& f,const short n) ;
		friend Fint operator/(const Fint& f,const int n) ;
		friend Fint operator/(const Fint& f,const long n) ;
		friend Fint operator/(const Fint& f,const unsigned long n) ;
		friend Fint operator/(const Fint& f,const double& d) ;
		friend Fint operator/(const Fint& f,const long double& d) ;

		friend Fint operator/(const short n,const Fint& f) ;
		friend Fint operator/(const int n,const Fint& f) ;
		friend Fint operator/(const long n,const Fint& f) ;
		friend Fint operator/(const unsigned long n,const Fint& f) ;
		friend Fint operator/(const double& d,const Fint& f) ;
		friend Fint operator/(const long double& d,const Fint& f) ;
		friend Fint operator/(const Mint& n,const Fint& f) ;
		friend Fint operator/(const Mint& n,const double& d) ;
		friend Fint operator/(const Mint& n,const long double& d) ;
		friend Fint operator/(const double& d,const Mint& n) ;
		friend Fint operator/(const long double& d,const Mint& n) ;

		friend Fint operator|(const Mint& n,const Mint& m) ;
		friend Fint operator|(const Mint& n,const short m) ;
		friend Fint operator|(const Mint& n,const int m) ;
		friend Fint operator|(const Mint& n,const long m) ;
		friend Fint operator|(const Mint& n,const unsigned long m) ;

		friend Fint operator|(const short m,const Mint& n) ;
		friend Fint operator|(const int m,const Mint& n) ;
		friend Fint operator|(const long m,const Mint& n) ;
		friend Fint operator|(const unsigned long m,const Mint& n) ;

		friend ostream& operator<<(ostream& os,const Fint& a) ;
		friend istream& operator>>(istream& is,Fint& a) ;

		friend void write(ostream& os,const Fint& f) ;
		friend void read(istream& is,Fint& f) ;

		friend bool operator>(const double d,const Fint& f) ;
		friend bool operator>(const unsigned long n,const Fint& f) ;

		friend Fint abs(const Fint& x) ;
		friend Fint cubrt(const Fint& x) ;
		friend Mint Int(const Fint& a) ;
		friend Fint inverse(Fint& a) ;
		friend Fint sqrt(const Fint& a) ;
		friend int	sign(const Fint& f) ;
		friend Fint Ramanujan_pi(int precision) ;
		friend Fint Chudnovsky(int precision) ;
		friend Fint exp(const Fint& x) ;
friend Fint new_exp(const Fint& x) ;
		friend Fint log(const Fint& x) ;
		friend Fint power(const Fint& x,const Mint& n) ;

		friend Fint power(const Fint& x,const unsigned long n) ;
		friend Fint power(const Fint& x,const long n) ;	  // power
		friend Fint round(const Fint& f,const int n) ;
		friend Fint round(const Fint& f,const long n) ;
		friend Fint square(const Fint& a) ;
		friend int SetPrecision(const int _precision) ;
		friend Mint nearInt(const Fint& f) ;

protected :
public:
		bool allocate(int size,int fsize) ;
		bool allocate(const int size) {
			return ((Mint*)this)->allocate(size) ;
		}

//public:

		Fint& isAdd(const Fint& a,const Fint& b) ;
		Fint& isAdd(const Fint& a,const Mint& b) ;
		Fint& isAdd(const Fint& a,const short b) ;
		Fint& isAdd(const Fint& a,const int b) ;
		Fint& isAdd(const Fint& a,const long b) ;
		Fint& isAdd(const Fint& a,const double& b) ;
		Fint& isAdd(const Fint& a,const long double& b) ;
		Fint& isAddUL(const Fint& a,const unsigned long b) ;
		Fint& isAdd(const Mint& a,const double& b) ;
		Fint& isAdd(const Mint& a,const long double& b) ;

		Fint& isSub(const Fint& a,const Fint& b) ;
		Fint& isSub(const Fint& a,const Mint& b) ;
		Fint& isSub(const Fint& a,const short b) ;
		Fint& isSub(const Fint& a,const int b) ;
		Fint& isSub(const Fint& a,const long b) ;
		Fint& isSub(const Fint& a,const double& b) ;
		Fint& isSub(const Fint& a,const long double& b) ;
		Fint& isSubUL(const Fint& a,const unsigned long b) ;
		Fint& isSub(const Mint& a,const Fint& b) ;
		Fint& isSub(const short a,const Fint& b) ;
		Fint& isSub(const int a,const Fint& b) ;
		Fint& isSub(const long a,const Fint& b) ;
		Fint& isSub(const unsigned long a,const Fint& b) ;
		Fint& isSub(const double& a,const Fint& b) ;
		Fint& isSub(const long double& a,const Fint& b) ;
		Fint& isSub(const Mint& a,const double& b) ;
		Fint& isSub(const Mint& a,const long double& b) ;
		Fint& isSub(const double& a,const Mint& b) ;
		Fint& isSub(const long double& a,const Mint& b) ;

		Fint& isMulF(const Mint& a,const Mint& b) ;
		Fint& isMul(const Fint& a,const Fint& b) ;
		Fint& isMul(const Fint& a,const Mint& b) ;
		Fint& isMul(const Fint& a,const short b) ;
		Fint& isMul(const Fint& a,const int b) ;
		Fint& isMul(const Fint& a,const long b) ;
		Fint& isMul(const Fint& a,const double& b) ;
		Fint& isMul(const Fint& a,const long double& b) ;
		Fint& isMulUL(const Fint& a,const unsigned long b) ;
		Fint& isMul(const double& a,const Fint& b) ;
		Fint& isMul(const long double& a,const Fint& b) ;
		Fint& isMul(const Mint& a,const double& b) ;
		Fint& isMul(const Mint& a,const long double& b) ;

		Fint& isDiv(const Fint& a,const Fint& b) ;
		Fint& isDivF(const Mint& a,const Mint& b) ;
		Fint& isDiv(const Fint& a,const Mint& b) ;
		Fint& isDiv(const Fint& a,const short b) ;
		Fint& isDiv(const Fint& a,const int b) ;
		Fint& isDiv(const Fint& a,const long b) ;
		Fint& isDiv(const Fint& a,const double& b) ;
		Fint& isDiv(const Fint& a,const long double& b) ;
		Fint& isDivUL(const Fint& a,const unsigned long b) ;
		Fint& isDiv(const Mint& a,const Fint& b) ;
		Fint& isDiv(const short a,const Fint& b) ;
		Fint& isDiv(const int a,const Fint& b) ;
		Fint& isDiv(const long a,const Fint& b) ;
		Fint& isDiv(const unsigned long a,const Fint& b) ;
		Fint& isDiv(const double& a,const Fint& b) ;
		Fint& isDiv(const long double& a,const Fint& b) ;
		Fint& isInverse(const Fint& a) ;
		Fint& isSqrt(const Fint& a) ;

		Fint& isRound(const Fint& a,const int s) ;

		Fint& isSquare(const Fint& a) ;
private:

							 // comparison
							 // 召֌W
		int compare(const Fint& f) const ;
		int compare(const Mint& n) const ;
		int compareL(const long n) const ;
		int compare(const unsigned long n) const ;
		int compareUL(const unsigned long n) const ;

		void Put(ostream& os,long mdigit) const ;

		   // DO NOT USE  (system variables)
		   // ̕ϐʂ̊֐痘pĂ͂ȂȂ
		static Fint _Ftemp ;
		static Fint _uFtemp ;
		static Fint _vFtemp ;
		static Fint _pi ;
		static Fint _log2 ;
		static Fint _e ;
} ;

#ifndef _ONLY_FINTDECL_
# include "FintFunc.hpp"
#endif

inline int Fint::fdigit() const
{
  return fDigit ;
}


#ifndef __BORLANDC__
inline Fint::operator long double() const
{
	return (double)*this ;
}
#endif

inline Fint inverse(Fint& a)
{
	return Fint::_Ftemp.isInverse(a) ;
}

//
//	compute square
//	faster than multiplication a*a for large a
//
inline Fint square(const Fint& a)
{
	return Fint::_Ftemp.isSquare(a) ;
}

////////////////////////////////////
//
//	atithmetic operations
//
inline Fint& Fint::isAdd(const Fint& a,const Fint& b)
{
	return (Fint&)(((Mint*)this)->isAdd((Mint&)a,(Mint&)b)) ;
}

inline Fint& Fint::isAdd(const Fint& a,const Mint& b)
{
	return (Fint&)(((Mint*)this)->isAdd((Mint&)a,b)) ;
}

inline Fint& Fint::isAdd(const Fint& a,const short b)
{
	return isAdd(a,long(b)) ;
}

inline Fint& Fint::isAdd(const Fint& a,const int b)
{
	return isAdd(a,long(b)) ;
}

inline Fint& Fint::isAdd(const Fint& a,const long b)
{
	return (Fint&)(((Mint*)this)->isAdd((Mint&)a,b)) ;
}

inline Fint& Fint::isAddUL(const Fint& a,const unsigned long b)
{
	return (Fint&)(((Mint*)this)->isAddUL((Mint&)a,b)) ;
}

inline Fint& Fint::isAdd(const Fint& a,const double& d)
{
	return isAdd(a,(long double)d) ;
}

inline Fint& Fint::isAdd(const Fint& a,const long double& d)
{
	_Ftemp.fDigit=0 ;
	return isAdd(a,_Ftemp=d) ;
}
inline Fint& Fint::isAdd(const Mint& a,const double& b)
{
	return isAdd(a,(long double)b) ;
}

inline Fint& Fint::isAdd(const Mint& a,const long double& b)
{
	Fint::_uFtemp.fDigit=0 ;
	return (Fint&)(((Mint*)this)->isAdd((Mint&)(Fint::_uFtemp=b),a)) ;
}

inline Fint& Fint::isSub(const Fint& a,const Fint& b)
{
	return (Fint&)(((Mint*)this)->isSub((Mint&)a,(Mint&)b)) ;
}

inline Fint& Fint::isSub(const Fint& a,const Mint& b)
{
	return (Fint&)(((Mint*)this)->isSub((Mint&)a,b)) ;
}


inline Fint& Fint::isSub(const Fint& a,const short b)
{
	return isSub(a,long(b)) ;
}

inline Fint& Fint::isSub(const Fint& a,const int b)
{
	return isSub(a,long(b)) ;
}

inline Fint& Fint::isSub(const Fint& a,const long b)
{
	return (Fint&)(((Mint*)this)->isSub((Mint&)a,b)) ;
}

inline Fint& Fint::isSubUL(const Fint& a,const unsigned long b)
{
	return (Fint&)(((Mint*)this)->isSubUL((Mint&)a,b)) ;
}

inline Fint& Fint::isSub(const Fint& a,const double& d)
{
	return isSub(a,(long double)d) ;
}

inline Fint& Fint::isSub(const Fint& a,const long double& b)
{
	_uFtemp.fDigit=0 ;
	return (Fint&)(((Mint*)this)->isSub((Mint&)a,(Mint&)(_uFtemp=b))) ;
}

inline Fint& Fint::isSub(const Mint& a,const Fint& b)
{
	return (Fint&)(((Mint*)this)->isSub(a,(Mint&)b)) ;
}

inline Fint& Fint::isSub(const short a,const Fint& b)
{
	return isSub(long(a),b) ;
}

inline Fint& Fint::isSub(const int a,const Fint& b)
{
	return isSub(long(a),b) ;
}

inline Fint& Fint::isSub(const long a,const Fint& b)
{
	return ~isSub(b,a) ;
}

inline Fint& Fint::isSub(const unsigned long a,const Fint& b)
{
	return ~isSubUL(b,a) ;
}

inline Fint& Fint::isSub(const Mint& a,const double& b)
{
	return isSub(a,(long double)b) ;
}

inline Fint& Fint::isSub(const Mint& a,const long double& b)
{
	_uFtemp.fDigit=0 ;
	return (Fint&)(((Mint*)this)->isSub(a,(Mint&)(_uFtemp=b))) ;
}

inline Fint& Fint::isSub(const double& a,const Fint& b)
{
	return isSub((long double)a,b) ;
}

inline Fint& Fint::isSub(const double& a,const Mint& b)
{
	return isSub((long double)a,b) ;
}


inline Fint& Fint::isSub(const long double& a,const Fint& b)
{
	return isSub(a,(Mint&)b) ;
}

inline Fint& Fint::isSub(const long double& a,const Mint& b)
{
	_uFtemp.fDigit=0 ;
	return (Fint&)(((Mint*)this)->isSub((Mint&)(_uFtemp=a),b)) ;

}

inline Fint& Fint::isMul(const Fint& a,const Fint& b)
{
	return isMulF((Mint&)a,(Mint&)b) ;
}

inline Fint& Fint::isMul(const Fint& a,const Mint& b)
{
	return isMulF((Mint&)a,b) ;
}

inline Fint& Fint::isMul(const Fint& a,const short b)
{
	return isMul(a,long(b)) ;
}

inline Fint& Fint::isMul(const Fint& a,const int b)
{
	return isMul(a,long(b)) ;
}

inline Fint& Fint::isMul(const Fint& a,const long b)
{
	return (Fint&)(((Mint*)this)->isMul((Mint&)a,b)) ;
}

inline Fint& Fint::isMulUL(const Fint& a,const unsigned long b)
{
	return (Fint&)(((Mint*)this)->isMulUL((Mint&)a,b)) ;
}

inline Fint& Fint::isMul(const Fint& a,const double& b)
{
	return isMul(a,(long double)b) ;
}

inline Fint& Fint::isMul(const Fint& a,const long double& b)
{
	_Ftemp.fDigit=0 ;
	return isMul(a,_Ftemp=b) ;
}

inline Fint& Fint::isMul(const Mint& a,const double& b)
{
	return isMul(a,(long double)b) ;
}

inline Fint& Fint::isMul(const Mint& a,const long double& b)
{
	Fint::_uFtemp.fDigit=0 ;
	return isMulF((Mint&)(Fint::_uFtemp=b),a) ;
}

inline Fint& Fint::isMul(const double& a,const Fint& b)
{
	return isMul(b,a) ;
}

inline Fint& Fint::isMul(const long double& a,const Fint& b)
{
	return isMul(b,a) ;
}

inline Fint& Fint::isDiv(const Fint& a,const Fint& b)
{
	return isDivF((Mint&)a,(Mint&)b) ;
}

inline Fint& Fint::isDiv(const Fint& a,const Mint& b)
{
	return isDivF((Mint&)a,b) ;
}

inline Fint& Fint::isDiv(const Fint& a,const short b)
{
	return isDiv(a,long(b)) ;
}

inline Fint& Fint::isDiv(const Fint& a,const int b)
{
	return isDiv(a,long(b)) ;
}

inline Fint& Fint::isDiv(const Fint& a,const long b)
{
	return (Fint&)((Mint*)this)->isDiv((Mint&)a,b) ;
}

inline Fint& Fint::isDivUL(const Fint& a,const unsigned long b)
{
	return (Fint&)((Mint*)this)->isDivUL((Mint&)a,b) ;
}

inline Fint& Fint::isDiv(const Fint& a,const double& b) \
{
	return isDiv(a,(long double)b) ;
}
inline Fint& Fint::isDiv(const Fint& a,const long double& b)
{
	_Ftemp.fDigit=1 ;
	return isDiv(a,(_uFtemp=b)) ;
}

inline Fint& Fint::isDiv(const Mint& a,const Fint& b)
{
	return isDivF(a,(Mint&)b) ;
}
inline Fint& Fint::isDiv(const short a,const Fint& b)
{
	return isDiv(long(a),b) ;
}

inline Fint& Fint::isDiv(const int a,const Fint& b)
{
	return isDiv(long(a),b) ;
}

inline Fint& Fint::isDiv(const long a,const Fint& b)
{
	_uFtemp.fDigit=1 ;
	return isDiv(_uFtemp=a,b) ;
}

inline Fint& Fint::isDiv(const unsigned long a,const Fint& b)
{
	_uFtemp.fDigit=1 ;
	return isDiv(_uFtemp=a,b) ;
}

inline Fint& Fint::isDiv(const double& a,const Fint& b)
{
	return isDiv((long double)a,b) ;
}

inline Fint& Fint::isDiv(const long double& a,const Fint& b)
{
	_uFtemp.fDigit=1 ;
	return isDiv(_uFtemp=a,b) ;
}


long double cubrt(long double& d) ;
inline int GetPrecision()
{
	return Fint::Precision ;
}

/////////////////////
//
//	signature
//
//	 return value	 1 : f is Positive
//					 -1 : f is Negative
//					  0 : f is Zero
//

inline int sign(const Fint& f)
{
	return sign((Mint&)f) ;
}
inline int sgn(const Fint& f)
{
	return sign(f) ;
}

//////////////////////////////////
//
//	length of fractional part
//
inline int fdigit(const Fint& f)
{
	return f.fdigit() ;
}


//////////////////////////////////
//
//	shift as number with radix 2^32
//
//	operand will be changed.
inline Fint& Fint::operator[](const long s)
{
	return (Fint&)isShift32((const Mint&)*this,s) ;
}

// operand will not be changed
inline Fint Fint::operator()(const long s) const
{
	return (Fint&)((Mint&)_Ftemp.isShift32((const Mint&)*this,s)) ;
}

//////////////////////
//
//	negate
//
inline Fint Fint::operator-() const
{
	return (Fint&)((Mint&)_Ftemp).isNeg(*this) ;
}
///////////////////////////
//
// absolute value
//
inline Fint abs(const Fint& f)
{
	(Fint::_Ftemp=f).nDim&=0x01ffffff ;
	return Fint::_Ftemp ;
}

//////////////////////////////////
//
//	round
//

inline Fint& Fint::round(const int n)
{
	return isRound(*this,n) ;
}

inline Fint& Fint::round(const long n)
{
	return isRound(*this,int(n)) ;
}

inline Fint round(const Fint& f,const int n)
{
	return Fint::_Ftemp.isRound(f,n) ;
}

inline Fint round(const Fint& f,const long n)
{
	return Fint::_Ftemp.isRound(f,int(n)) ;
}

//////////////////////////////
//
//	negate
//
inline Fint& Fint::operator~()
{
	return (Fint&)((Mint*)this)->isNeg(*this) ;
}

////////////////////////////////
//
//	assign
//
inline Fint& Fint::operator=(const Fint& a)
{
	return	(Fint&)((Mint*)this)->operator=((Mint&)a) ;
}

inline Fint& Fint::operator=(const short n)
{
	return operator=(long(n)) ;
}

inline Fint& Fint::operator=(const int n)
{
	return operator=(long(n)) ;
}

inline Fint& Fint::operator=(const long n)
{
	return (Fint&)((Mint*)this)->operator=(n) ;
}

inline Fint& Fint::operator=(const unsigned long n)
{
	return (Fint&)((Mint*)this)->operator=(n) ;
}

#ifndef __BORLANDC__
inline Fint&	Fint::operator=(const long double& d)
{
	return *this=(double)d ;
}
#endif

inline Mint& Mint::operator=(const Fint& f)
{
	return *this=Int(f) ;
}


///////////////////////
//
//	addition
//
inline Fint operator+(const Fint& a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator+(const Fint& a,const Mint& b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}



inline Fint operator+(const Fint& a,const short b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator+(const Fint& a,const int b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator+(const Fint& a,const long b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator+(const Fint& a,const unsigned long b)
{
	return Fint::_Ftemp.isAddUL(a,b) ;
}

inline Fint operator+(const Fint& a,const double& b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator+(const Fint& a,const long double& b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}


inline Fint operator+(const Mint& a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}

inline Fint operator+(const short a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}

inline Fint operator+(const int a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}

inline Fint operator+(const long a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}


inline Fint operator+(const unsigned long a,const Fint& b)
{
	return Fint::_Ftemp.isAddUL(b,a) ;
}


inline Fint operator+(const double& a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}


inline Fint operator+(const long double& a,const Fint& b)
{
	return Fint::_Ftemp.isAdd(b,a) ;
}

inline Fint& Fint::operator+=(const Fint& f)
{
	return isAdd(*this,f) ;
}


inline Fint& Fint::operator+=(const Mint& n)
{
	return isAdd(*this,n) ;
}

inline Fint& Fint::operator+=(const short n)
{
	return isAdd(*this,n) ;
}

inline Fint& Fint::operator+=(const int n)
{
	return isAdd(*this,n) ;
}

inline Fint& Fint::operator+=(const long n)
{
	return isAdd(*this,n) ;
}

inline Fint& Fint::operator+=(const unsigned long n)
{
	return isAddUL(*this,n) ;
}

inline Fint& Fint::operator+=(const double& d)
{
	return isAdd(*this,d) ;
}

inline Fint& Fint::operator+=(const long double& d)
{
	return isAdd(*this,d) ;
}

inline Mint& Mint::operator+=(const Fint& f)
{
	return isAdd(*this,Int(f)) ;
}


//////////////////
//
//	subtraction
//
inline Fint operator-(const Fint& a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const Fint& a,const Mint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const Fint& a,const short b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const Fint& a,const int b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const Fint& a,const long b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const Fint& a,const unsigned long b)
{
	return Fint::_Ftemp.isSubUL(a,b) ;
}

inline Fint operator-(const Fint& a,const double& b)
{
	return Fint::_Ftemp.isSub(a,(long double)b) ;
}

inline Fint operator-(const Fint& a,const long double& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}



inline Fint operator-(const Mint& a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}


inline Fint operator-(const short a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const int a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const long a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const unsigned long a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const double& a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const long double& a,const Fint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint& Fint::operator-=(const Fint& f)
{
	return isSub(*this,f) ;
}

inline Fint& Fint::operator-=(const Mint& n)
{
	return isSub(*this,n) ;
}

inline Fint& Fint::operator-=(const short n)
{
	return isSub(*this,n) ;
}

inline Fint& Fint::operator-=(const int n)
{
	return isSub(*this,n) ;
}

inline Fint& Fint::operator-=(const long n)
{
	return isSub(*this,n) ;
}

inline Fint& Fint::operator-=(const unsigned long n)
{
	return isSubUL(*this,n) ;
}

inline Fint& Fint::operator-=(const double& d)
{
	return isSub(*this,d) ;
}

inline Fint& Fint::operator-=(const long double& d)
{
	return isSub(*this,d) ;
}

inline Mint& Mint::operator-=(const Fint& f)
{
	return isSub(*this,Int(f)) ;
}


/////////////////////////////////
//
//	multiplication
//

inline Fint operator*(const Fint& a,const Fint& b)
{
	return Fint::_Ftemp.isMulF((Mint&)a,(Mint&)b) ;
}


inline Fint operator*(const Fint& a,const Mint& b)
{
	return Fint::_Ftemp.isMulF((Mint&)a,b) ;
}

inline Fint operator*(const Fint& a,const short b)
{
	return Fint::_Ftemp.isMul(a,b) ;
}

inline Fint operator*(const Fint& a,const int b)
{
	return Fint::_Ftemp.isMul(a,b) ;
}

inline Fint operator*(const Fint& a,const long b)
{
	return Fint::_Ftemp.isMul(a,b) ;
}

inline Fint operator*(const Fint& a,const unsigned long b)
{
	return Fint::_Ftemp.isMulUL(a,b) ;
}

inline Fint operator*(const Fint& a,const double& b)
{
	return Fint::_Ftemp.isMul(a,(long double)b) ;
}

inline Fint operator*(const Fint& a, const long double& b)
{
	return Fint::_Ftemp.isMul(a,b) ;
}


inline Fint operator*(const Mint& a,const Fint& b)
{
	return Fint::_Ftemp.isMulF((Mint&)b,a) ;
}


inline Fint operator*(const short a,const Fint& b)
{
	return Fint::_Ftemp.isMul(b,a) ;
}

inline Fint operator*(const int a,const Fint& b)
{
	return Fint::_Ftemp.isMul(b,a) ;
}
inline Fint operator*(const long a,const Fint& b)
{
	return Fint::_Ftemp.isMul(b,a) ;
}

inline Fint operator*(const unsigned long a,const Fint& b)
{
	return Fint::_Ftemp.isMulUL(b,a) ;
}

inline Fint operator*(const double& a,const Fint& b)
{
	return Fint::_Ftemp.isMul(b,a) ;
}


inline Fint operator*(const long double& a,const Fint& b)
{
	return Fint::_Ftemp.isMul(b,a) ;
}

inline Fint& Fint::operator*=(const Fint& f)
{
	return isMul(*this,f) ;
}

inline Fint& Fint::operator*=(const Mint& n)
{
	return isMul(*this,n) ;
}

inline Fint& Fint::operator*=(const short n)
{
	return isMul(*this,n) ;
}

inline Fint& Fint::operator*=(const int n)
{
	return isMul(*this,n) ;
}

inline Fint& Fint::operator*=(const long n)
{
	return isMul(*this,n) ;
}

inline Fint& Fint::operator*=(const unsigned long n)
{
	return isMulUL(*this,n) ;
}

inline Fint& Fint::operator*=(const double& d)
{
	return isMul(*this,d) ;
}

inline Fint& Fint::operator*=(const long double& d)
{
	return isMul(*this,d) ;
}


///////////////////////////////
//
//	division
//
inline Fint operator/(const Fint& a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}


inline Fint operator/(const Fint& a,const Mint& b)
{

	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const Fint& a,const short b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const Fint& a,const int b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}


inline Fint operator/(const Fint& a,const long b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const Fint& a,const unsigned long b)
{
	return Fint::_Ftemp.isDivUL(a,b) ;
}

inline Fint operator/(const Fint& a,const double& b)
{
	return Fint::_Ftemp.isDiv(a,(long double)b) ;
}

inline Fint operator/(const Fint& a,const long double& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}


inline Fint operator/(const short a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const int a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const long a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const unsigned long a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}


inline Fint operator/(const double& a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint operator/(const long double& a,const Fint& b)
{
	return Fint::_Ftemp.isDiv(a,b) ;
}

inline Fint& Fint::operator/=(const Fint& f)
{
	return isDiv(*this,f) ;
}

inline Fint& Fint::operator/=(const Mint& n)
{
	return isDiv(*this,n) ;
}

inline Fint& Fint::operator/=(const short n)
{
	return isDiv(*this,n) ;
}

inline Fint& Fint::operator/=(const int n)
{
	return isDiv(*this,n) ;
}

inline Fint& Fint::operator/=(const long n)
{
	return isDiv(*this,n) ;
}

inline Fint& Fint::operator/=(const unsigned long n)
{
	return isDivUL(*this,n) ;
}

inline Fint& Fint::operator/=(const double& d)
{
	return isDiv(*this,d) ;
}

inline Fint& Fint::operator/=(const long double& d)
{
	return isDiv(*this,d) ;
}




///////////////////////////////////
//
//	shift operator
//
inline Fint& Fint::operator>>=(const int s)
{
	return (Fint&)((Mint*)this)->operator>>=(long(s)) ;
}

inline Fint& Fint::operator>>=(const long s)
{
	return (Fint&)((Mint*)this)->operator>>=(s) ;
}

inline Fint& Fint::operator>>=(const unsigned long s)
{
	return (Fint&)((Mint*)this)->operator>>=(long(s)) ;
}


inline Fint Fint::operator>>(const int s) const
{
	return (_Ftemp=*this)>>=long(s) ;
}

inline Fint Fint::operator>>(const long s) const
{
	return (_Ftemp=*this)>>=s ;
}

inline Fint Fint::operator>>(const unsigned long s) const
{
	return (_Ftemp=*this)>>=long(s) ;
}

inline Fint& Fint::operator<<=(const int s)
{
	return (Fint&)((Mint*)this)->operator<<=(long(s)) ;
}

inline Fint& Fint::operator<<=(const long s)
{
	return (Fint&)((Mint*)this)->operator<<=(s) ;
}

inline Fint& Fint::operator<<=(const unsigned long s)
{
	return (Fint&)((Mint*)this)->operator<<=(long(s)) ;
}



inline Fint Fint::operator<<(const int s) const
{
	return (_Ftemp=*this)<<=long(s) ;
}
inline Fint Fint::operator<<(const long s) const
{
	return (_Ftemp=*this)<<=s ;
}

inline Fint Fint::operator<<(const unsigned long s) const
{
	return (_Ftemp=*this)<<=long(s) ;
}

/////////////////////////////////////////
//
//	increment , decrement
//
inline Fint& Fint::operator++()	 // prefix
{
	return isAddUL(*this,1) ;
}

inline Fint	 Fint::operator++(int)	// postfix
{
	_Ftemp=*this ;
	isAddUL(*this,1) ;
	return _Ftemp ;
}

inline Fint& Fint::operator--()	 // prefix
{
	return isSubUL(*this,1) ;
}

inline Fint	 Fint::operator--(int)	// postfix
{
	_Ftemp=*this ;
	isSubUL(*this,1) ;
	return _Ftemp ;
}



//////////////////////
//
//	comparison
//
inline int Fint::compare(const Fint& f) const
{
	return this->compare((Mint&)f) ;
}

inline int Fint::compare(const unsigned long n) const
{
	return nDim>0 ? compareUL(n):isLess ;
}


inline bool Fint::operator==(const Fint& f) const
{
	return compare((Mint&)f)==isEqual ;
}

inline bool Fint::operator==(const Mint& n) const
{
	return compare(n)==isEqual ;
}

inline bool operator==(const Mint& n,const Fint& f)
{
	return f==n ;
}

inline bool Fint::operator==(const short n) const
{
	return operator==(long(n)) ;
}

inline bool Fint::operator==(const int n) const
{
	return operator==(long(n)) ;
}

inline bool operator==(const short n,const Fint& f)
{
	return f==n ;
}

inline bool operator==(const int n,const Fint& f)
{
	return f==n ;
}

inline bool Fint::operator==(const long n) const
{
	return compareL(n)==isEqual ;
}

inline bool operator==(const long n,const Fint& f)
{
	return f==n ;
}

inline bool Fint::operator==(const unsigned long n) const
{
	return compare(n)==isEqual ;
}

inline bool operator==(const unsigned long n,const Fint& f)
{
	return f==n ;
}

inline bool Fint::operator!=(const Fint& f) const
{
	return !operator==(f) ;
}

inline bool Fint::operator!=(const Mint& n) const
{
	return !operator==(n) ;
}

inline bool operator!=(const Mint& n,const Fint& f)
{
	return f!=n ;
}

inline bool Fint::operator!=(const short n) const
{
	return operator!=(long(n)) ;
}

inline bool Fint::operator!=(const int n) const
{
	return operator!=(long(n)) ;
}

inline bool operator!=(const short n,const Fint& f)
{
	return f!=n ;
}

inline bool operator!=(const int n,const Fint& f)
{
	return f!=n ;
}

inline bool Fint::operator!=(const long n) const
{
	return !operator==(n) ;
}

inline bool operator!=(const long n,const Fint& f)
{
	return f!=n ;
}

inline bool Fint::operator!=(const unsigned long n) const
{
	return !(compare(n)==isEqual) ;
}

inline bool operator!=(const unsigned long n,const Fint& f)
{
	return f!=n ;
}

inline bool Fint::operator>(const Fint& f) const
{
	return compare((Mint&)f)==isGreater ;
}

inline bool Fint::operator>(const Mint& n) const
{
	return compare(n)==isGreater ;
}

inline bool operator>(const Mint& n,const Fint& f)
{
	return f<n ;
}

inline bool Fint::operator>(const short n) const
{
	return operator>(long(n)) ;
}

inline bool Fint::operator>(const int n) const
{
	return operator>(long(n)) ;
}

inline bool operator>(const short n,const Fint& f)
{
	return f<n ;
}

inline bool operator>(const int n,const Fint& f)
{
	return f<n ;
}

inline bool Fint::operator>(const long n) const
{
	return compareL(n)==isGreater ;
}

inline bool Fint::operator>(const double d) const
{
	_Ftemp.fDigit=0 ;
	return compare((Mint&)_Ftemp=d)==isGreater ;
}

inline bool operator>(const double d,const Fint& f)
{
	Fint::_Ftemp.fDigit=0 ;
	return f.compare((Mint&)Fint::_Ftemp=d)==isLess ;
}

inline bool operator>(const long n,const Fint& f)
{
	return f<n ;
}

inline bool Fint::operator>(const unsigned long n) const
{
	return compare(n)==isGreater ;
}

inline bool operator>(const unsigned long n,const Fint& f)
{
	return f.compare(n)==isLess ;
}

inline bool Fint::operator<(const Fint& f) const
{
	return compare((Mint&)f)==isLess ;
}

inline bool Fint::operator<(const Mint& n) const
{
	return compare(n)==isLess ;
}

inline bool operator<(const Mint& n,const Fint& f)
{
	return f>n ;
}

inline bool Fint::operator<(const short n) const
{
	return operator<(long(n)) ;
}

inline bool Fint::operator<(const int n) const
{
	return operator<(long(n)) ;
}

inline bool operator<(const short n,const Fint& f)
{
	return f>n ;
}

inline bool operator<(const int n,const Fint& f)
{
	return f>n ;
}

inline bool Fint::operator<(const long n) const
{
	return compareL(n)==isLess ;
}

inline bool operator<(const long n,const Fint& f)
{
	return f>n ;
}

inline bool Fint::operator<(const unsigned long n) const
{
	return compare(n)==isLess ;
}

inline bool operator<(const unsigned long n,const Fint& f)
{
	return f>n ;
}

inline bool Fint::operator<(const double d) const
{
	_Ftemp.fDigit=0 ;
	return operator<(_Ftemp=d) ;
}

inline bool operator<(const double d,const Fint& f)
{
	return f>d ;
}

inline bool Fint::operator>=(const Fint& f) const
{
	return !(compare((Mint&)f)==isLess) ;
}

inline bool Fint::operator>=(const Mint& n) const
{
	return !(compare(n)==isLess) ;
}

inline bool operator>=(const Mint& n,const Fint& f)
{
	return f<=n ;
}

inline bool Fint::operator>=(const short n) const
{
	return !(compareL(long(n))==isLess) ;
}

inline bool Fint::operator>=(const int n) const
{
	return !(compareL(long(n))==isLess) ;
}

inline bool operator>=(const short n,const Fint& f)
{
	return f<=n ;
}

inline bool operator>=(const int n,const Fint& f)
{
	return f<=n ;
}

inline bool Fint::operator>=(const long n) const
{
	return !(compareL(n)==isLess) ;
}

inline bool operator>=(const long n,const Fint& f)
{
	return f<=n ;
}

inline bool Fint::operator>=(const unsigned long n) const
{
	return !(compare(n)==isLess) ;
}

inline bool operator>=(const unsigned long n,const Fint& f)
{
	return f<=n ;
}

inline bool Fint::operator<=(const Fint& f) const
{
	return !(compare((Mint&)f)==isGreater) ;
}

inline bool Fint::operator<=(const Mint& n) const
{
	return !(compare(n)==isGreater) ;
}

inline bool operator<=(const Mint& n,const Fint& f)
{
	return f>=n ;
}

inline bool Fint::operator<=(const short n) const
{
	return operator<=(long(n)) ;
}

inline bool Fint::operator<=(const int n)	 const
{
	return operator<=(long(n)) ;
}

inline int operator<=(const short n,const Fint& f)
{
	return f>=n ;
}
inline bool operator<=(const int n,const Fint& f)
{
	return f>=n ;
}

inline bool Fint::operator<=(const long n) const
{
	return !(compareL(n)==isGreater);
}

inline bool operator<=(const long n,const Fint& f)
{
	return f>=n ;
}

inline bool Fint::operator<=(const unsigned long n) const
{
	return !(compare(n)==isGreater) ;
}

inline bool Fint::operator<=(const double d) const
{
	_Ftemp.fDigit=0 ;
	return operator<=(_Ftemp=d) ;
}

inline bool operator<=(const unsigned long n,const Fint& f)
{
	return f>=n ;
}

inline Fint Fint::operator+() const
{
	return *this ;
}



void write(ostream& os,Fint& f) ;
void read(istream& is,Fint& f) ;


// not useful operators
// ܂̉Zq
// ̉ZqAgpȂ΂ȂȂ󋵂͑z肵ɂD

Fint operator+(const Mint& n,const long double& d) ;

inline Fint operator+(const long double& d,const Mint& n)
{
	return n+d ;
}

Fint operator/(const Mint& n,const long double& d) ;

Fint operator/(const long double& d,const Mint& n) ;

inline Fint operator+(const Mint& n,const double& d)
{
	return n+(long double)d ;
}

inline Fint operator+(const double& d,const Mint& n)
{
	return n+(long double)d ;
}

inline Fint operator-(const Mint& n,const double& d)
{
	return n-(long double)d ;
}

inline Fint operator-(const double& d,const Mint& n)
{
	return (long double)d-n ;
}

inline Fint operator*(const Mint& n,const double& d)
{
	return Fint::_Ftemp.isMul(n,d) ;
}

inline Fint operator*(const double& d,const Mint& n)
{

	return Fint::_Ftemp.isMul(n,d) ;
}

inline Fint operator*(const long double& d,const Mint& n)
{
	 return Fint::_Ftemp.isMul(n,d) ;
}

inline Fint operator/(const Mint& n,const Fint& f)		// added 1995.05.08
{
	return Fint::_Ftemp.isDiv(n,f) ;
}

inline Fint operator/(const Mint& n,const double& d)
{
	Fint::_uFtemp.fDigit=0 ;
	return Fint::_Ftemp.isDivF(n,Fint::_uFtemp=d) ;
}

inline Fint operator/(const double& d,const Mint& n)
{
	Fint::_uFtemp.fDigit=0 ;
	return Fint::_Ftemp.isDivF(Fint::_uFtemp=d,n) ;
}

inline Fint operator|(const Mint& n,const Mint& m)
{
	return Fint::_Ftemp.isDivF(n,m) ;
}



inline Fint operator/(const long double& d,const Mint& n)
{
	Fint::_uFtemp.fDigit=0 ;
	return Fint::_Ftemp.isDivF(Fint::_uFtemp=d,n) ;
}

inline Fint operator+(const Mint& a,const long double& b)
{
	return Fint::_Ftemp.isAdd(a,b) ;
}

inline Fint operator-(const Mint& a,const long double& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator-(const long double& a,const Mint& b)
{
	return Fint::_Ftemp.isSub(a,b) ;
}

inline Fint operator/(const Mint& n,const long double& d)
{
	Fint::_uFtemp.fDigit=0 ;
	return Fint::_Ftemp.isDivF(n,Fint::_uFtemp=d) ;
}

#endif // #ifndef __FINT_HPP
