//
//	Copyright (C) by S.Tomabechi 1993-1997
//	All rights reserved.
//
//	real functions
//
#ifndef __FINTFUNC_HPP
#define __FINTFUNC_HPP

int fdigit(Fint& f) ;

Fint abs(const Fint& f) ;				// absolute value
Fint acos(const Fint& x) ;				// arc cosine
Fint asin(const Fint& x) ;				// arc sine
Fint atan(const Fint& x) ;				// arc tangent
Fint atan(const Fint& x,const Fint& y); // arc tangent

Mint ceil(const Fint& x) ;			 // ceil   the smallest integer which is greater than x
Fint cos(const Fint& x) ;			 // cosine
Fint cosh(const Fint& x) ;			 // hyperbolic cosine
Fint cubrt(const Fint& x) ;			 // cubic root
Fint exp(const Fint& x) ;			 // exponential
Mint floor(const Fint& x) ;			 // floor  the greatest integer which is less than or equatl to x
Fint gamma(const Fint& x) ;			 // gamma function
Fint gammaln(const Fint& x) ;		 // logarithmic gamma funcion
Mint Int(const Fint& a) ;			 // integer part
Fint inverse(const Mint& a) ;		 //
Fint log(const Fint& a) ;			 // natural logarithm
Fint pi(int precision) ;			 // \pi
Fint power(const Fint& x,const Mint& n) ;	 // power
Fint power(const Mint& n,const Fint& f) ;
Fint power(const Fint& x,const Fint& f) ;
Fint power(const Fint& x,const int n) ;
Fint sin(const Fint& a) ;			 // sine
Fint sinh(const Fint& x) ;			 // hyperbolic sine (sinhcosh.cpp)
Fint sqrt(const Fint& x) ;			 // square root
Fint tan(const Fint& t) ;			 // tangent

//Fint agmpi(int precision) ;	 // \pi by Legendre-Gauss formula
//Fint Borwein_pi2(int precision) ;	 // \pi by Borweins' formula (qudaratic convergent)
Fint Euler(int precision=-1) ;	  // Eulers' constant  (Euler.cpp)

Fint dzeta2(int precision=-1) ;	   // \zeta^'(2) '(2)
//Fint Machin(int precision) ;		 // Machin ̌ɂ~
Fint Ramanujan_pi(int precision) ; // \pi by Ramanujan's formula
Fint Chudnovsky(int precision) ;   // \pi by Chudnovsky's formula

Fint agm(Fint a,Fint b) ;		   // arithmetic-geometric mean
Fint K(const Fint& a,const Fint& b) ;	// elliptic integral
Fint E(Fint a,Fint b) ;
Fint K(const Fint& k) ;
Fint E(const Fint& k) ;
Fint F(Fint p,const Fint& t) ;
Fint E2(Fint p,const Fint& t) ;

Fint zeta3(int precision=-1) ;


// ~
inline Fint pi(int _precision=0)
{
  return Chudnovsky(_precision) ;
//	return Ramanujan_pi(_precision) ;
}

inline Fint sqrt(const Fint& x)
{
  return Fint::_Ftemp.isSqrt(x) ;
}
inline

Fint power(const Fint& x,const int n)
{
	return power(x,long(n)) ;
}
#endif
