//
//	Copyright (C) by S.Tomabechi 1995-1997,2000
//	All rights reserved.
//
//	Sieve Part of MPQS method
//
//	1995/03/07 created
//
//	1996/11/25
//	 PPMPQSpɕύX
//	 ʒu߂ōςނ悤ɂ

//
//	unsigned long nPrimes :  f̌
//	unsigned long SieveWidth2 : ӂ邤S͈
//	unsigned long SieveUnit   : łӂ邤͈
//
//	SievePos[0] 
//	SievePos[1] : ʒu
//	SievePos[2] : ʒu
// total 16 bytes

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "PPMPQS.hpp"
extern unsigned long _A[] ;
extern unsigned long _B[] ;
extern unsigned long nSieveResult ;
extern unsigned long SieveResult[] ;
extern Mint _a ;
extern Mint _b ;
extern unsigned long SieveUnit ;
extern unsigned long SieveWidth ;
extern unsigned long SieveWidth2 ;
extern char Cutoff ;
extern const unsigned long MaxSieveResult ;

extern char SieveArray[] ;

extern long _nResult ;		// number of cancidates which seem to be smooth
#ifdef PROFILE_TEST
#include "CPUTime.hpp"
extern CPUTime cpu_sieve_init ;
extern CPUTime cpu_sieve ;
#endif

void Sieve(PPrimes* Primes,unsigned long nPrimes,unsigned long nPrimes2,unsigned long nPowers)
{
  unsigned long off ;
  unsigned long andigit ;
  unsigned long bndigit  ;
  unsigned long a2_p ;
  long b_p ;
  long r_p ;
  long Mmodp ;
  long v3 ;
  long t3 ;
  unsigned long p ;
  unsigned long cnt ;
#ifdef PROFILE_TEST
cpu_sieve_init.Start() ;
#endif

  __asm {
#ifdef __BORLANDC__
	mov   ecx,dword ptr [_a.nDigit] 	 // #digits
	mov   andigit,ecx
	mov   esi,dword ptr [_a]
	lea   edi,[_A]						// copy to work area
	rep   movsd							// ʂȂ悤̕

	mov   ecx,dword ptr [_b.nDigit]
	mov   bndigit,ecx
	mov   esi,dword ptr [_b]
	lea   edi,[_B]
	rep   movsd
#else
	mov   ecx,[_a+NDIGIT]
	mov   andigit,ecx
	mov   esi,[_a]
	lea   edi,[_A]
	rep   movsd

	mov   ecx,[_b+NDIGIT]
	mov   bndigit,ecx
	mov   esi,[_b]
	lea   edi,[_B]
	rep   movsd
#endif

	mov   eax,nPrimes
	dec   eax
	dec   eax
	mov   cnt,eax
	mov   esi,Primes
	lea   esi,[esi+16]
	mov   edi,2
  }

LOOP1:
	__asm {
	  dec cnt
	  js  PRE_LOOP3

	  lea	esi,[esi+16]
	  movzx eax,word ptr [esi]			// difference
	  add  edi,eax						// edi is prime

	  mov	eax,[esi+4] 				// square root of N mod p
	  mov	r_p,eax


	  xor	edx,edx
	  mov	eax,[SieveWidth]
	  div	edi
	  mov	Mmodp,edx					// SieveWidth mod p


	  mov	ebx,andigit 				//
	  xor	edx,edx
	}
DIV_A:									// compute a mod p
	__asm {
	  mov	eax,[_A+ebx*NBYTE-NBYTE]
	  div	edi
	  dec	ebx
	  jnz	DIV_A

	  shl	edx,1						// 2*a mod p
	  mov	a2_p,edx


	  mov	ebx,bndigit
	  xor	edx,edx
	}
DIV_b:									// compute -b mod p
	__asm {
	  mov	eax,[_B+ebx*NBYTE-NBYTE]
	  div  edi
	  dec	ebx
	  jnz	DIV_b

	  neg	edx
	  add	edx,edi
	  mov	b_p,edx 					// b_p<p łKv͂Ȃ

	  xor	ebx,ebx 					// compute 2a^-1 mod p
  }
//Check_a:
  __asm {

//	  mov	eax,edi
	mov   v3,edi
	mov   ecx,1 						// ecx is inverse
	mov   eax,a2_p
  }
DIV1:
  __asm {
	xor   edx,edx
	div   v3							// a/v3
	mov   t3,edx						// save residue
	mul   ebx
	sub   ecx,eax						// ecx -= q*v1
	xchg  ecx,ebx
	mov   eax,t3
	or	  eax,eax
	jz	  RET1
	xchg  eax,v3
	jmp   DIV1
  }

RET1:

   __asm {
	 add   ecx,edi

	 mov   eax,b_p						// eax=-b
	 add   eax,r_p						//	-b+r mod p

	 mul   ecx							// poroduct by the inverse of 2a
	 div edi

	 sub   edx,Mmodp					//compute the last location in the sieve array
	 js    Neg1 					   // where prime p divides the corresponding residue
	 sub edx,edi
   }
Neg1:
  __asm {
	 add   edx,[SieveUnit]
	 mov   ebx,edx

  }


   __asm {

	 mov   eax,b_p						// eax=-b
	 sub   eax,r_p						// -b-r modp r^2=pN mod p
	 add   eax,edi

	 mul   ecx							// a2 ̋t
	 div edi

	 sub   edx,Mmodp
	 js    Neg2
	 sub   edx,edi
   }
Neg2:
  __asm {
	 add  edx,[SieveUnit]

	 cmp  ebx,edx
	 jge  SET1
	 xchg ebx,edx						// exchange so that SievePos[1]>SievePos[2]
  }
SET1:
  __asm {
	 mov  [esi+8],ebx
	 mov  [esi+12],edx

	 jmp LOOP1

  }




PRE_LOOP2:

  __asm {
	  mov  eax,nPrimes2
	  mov  cnt,eax

	}

LOOP2:									// 2 ̙pŊʒûӂ邢
	__asm {
	  dec  cnt
	  js RET3
										// 2 ̙po

	  lea	esi,[esi+16]
//		movzx  eax,word ptr [esi]
//		mov    edi,eax
	  movzx  edi,word ptr [esi] 	   // prime

	  mov	 eax,[esi+4]

	  mov	r_p,eax

	  mov	edx,[SieveWidth]
	  dec	 edi
	  and	edx,edi
	  mov	Mmodp,edx

	  mov	edx,[_A]		  // a mod p vZ
	  and	edx,edi
	  mov	a2_p,edx

	  mov  edx,[_B] 		  // -b mod p vZ
	  and  edx,edi
	  inc edi

	  neg	edx
	  add	edx,edi
	  mov	b_p,edx
	}


  __asm {

	xor   ebx,ebx

//	  mov	v3,esi						  // v3=p
//	  mov	eax,edi
	mov   v3,edi
	mov   ecx,1 						// ecx is inverse
	mov   eax,a2_p
  }
DIV2:
  __asm {
	xor   edx,edx
	div   v3							// a/v3
	mov   t3,edx						// ]Z|u
	mul   ebx
	sub   ecx,eax						// ecx -= q*v1
	xchg  ecx,ebx

	mov   eax,t3
	or	  eax,eax
	jz	  RET12
	xchg  eax,v3
	jmp  DIV2

  }

RET12:
   __asm {
	 add   ecx,edi

	 mov   eax,b_p						// eax=-b
	 add   eax,r_p


	 shr   eax,1
//	   dec	 esi
	 dec edi
//	   and	 eax,esi
	 and   eax,edi

	 mul   ecx							// a2 ̋t
	 and  eax,edi
	 inc p

	 sub   eax,Mmodp
	 js    Neg11
	 sub   eax,esi
   }
Neg11:
  __asm {
	 add   eax,[SieveUnit]

	 mov   ebx,eax

	 mov   eax,b_p						// eax=-b
	 sub   eax,r_p
	 add eax,edi
   }
NOT_EXCEED2:
  __asm {

	 shr   eax,1
	 dec edi
	 and eax,edi

	 mul   ecx							// a2 ̋t
	 and eax,edi
	 inc edi

	 sub   eax,Mmodp
	 js    Neg12
	 sub   eax,edi
   }
Neg12:
  __asm {
	 add   eax,[SieveUnit]

	  cmp  ebx,eax
	  jge  SET2
	  xchg ebx,eax
  }
SET2:
  __asm  {
	 mov  [esi+8],ebx
	 mov  [esi+12],eax
	 jmp   LOOP2
  }
RET2:

PRE_LOOP3:
  __asm {
	mov eax,nPowers
	mov cnt,eax
  }

LOOP3:
	__asm {
	  dec cnt
	  js PRE_LOOP2
										// fo
										// esi <-> Primes Ƃ
										// edi <-> SievePos
	  lea esi,[esi+16]
//		movzx eax,word ptr [esi]		  // difference
//		add  edi,eax
	  movzx edi,word ptr [esi]

	  mov	eax,[esi+4] 				  // root
	  mov	r_p,eax

//		lea   ebx,[edi*2+edi]			 // ebx=3*edi
//		mov   eax,[SievePos+ebx*4]
//		mov   r_p,eax

	  mov	eax,[SieveWidth]
	  xor	edx,edx
	  div	edi
//		div   esi
	  mov	Mmodp,edx					// SieveWidth mod p

										// a mod p	߂
	  mov	ebx,andigit 				// 
	  xor	edx,edx
	}
DIV3:									 // mod p vZ
	__asm {
	  mov	eax,[_A+ebx*NBYTE-NBYTE]
	  div	edi
	  dec	ebx
	  jnz	DIV3

	  shl	edx,1						// 2*a mod p
	  mov	a2_p,edx

										// -b mod p ߂
	  mov	ebx,bndigit 				// 
	  xor	edx,edx
	}
DIV_b3:
	__asm {
	  mov	eax,[_B+ebx*NBYTE-NBYTE]
	  div  edi
//		div   esi
	  dec	ebx
	  jnz	DIV_b3

	  neg	edx
	  add	edx,esi 					// ]ɂ
	  mov	b_p,edx 					// b_p<p łKv͂Ȃ

	  xor	ebx,ebx 					// 2a^-1 mod p vZ
  }
Check_a3:
  __asm {

//	  mov	v3,esi
//	  mov	 eax,edi
	mov   v3,edi
	mov   ecx,1 						// ecx is inverse
	mov   eax,a2_p						// ȉ eax=a
  }
DIV13:
  __asm {
	xor   edx,edx
	div   v3							// a/v3
	mov   t3,edx						// ]Z|u
	mul   ebx
	sub   ecx,eax						// ecx -= q*v1
	xchg  ecx,ebx
	mov   eax,t3
	or	  eax,eax
	jz	  RET13
	xchg  eax,v3
	jmp   DIV13
  }

RET13:

   __asm {
//	   add	 ecx,esi
	 add   ecx,edi

	 mov   eax,b_p						// eax=-b
	 add   eax,r_p						//	-b+r mod p

	 mul   ecx							// 2a ̋t
//	   div	 esi
	 div edi

	 sub   edx,Mmodp					// fŊŌ̈ʒu߂
	 js    Neg13
	 sub   edx,esi
   }
Neg13:
  __asm {
	 add   edx,[SieveUnit]
	 mov   ebx,edx

  }


   __asm {

	 mov   eax,b_p						// eax=-b
	 sub   eax,r_p						// -b-r modp r^2=pN mod p
//	   add	 eax,esi					  // eax ɂȂ悤ɂ
	 add   eax,edi

	 mul   ecx							// a2 ̋t
//	   div	 esi
	 div edi

	 sub   edx,Mmodp
	 js    Neg23
	 sub   edx,edi
   }
Neg23:
  __asm {
	 add  edx,[SieveUnit]

	 cmp  ebx,edx
	 jge  SET13
	 xchg ebx,edx						// exchange so that SievePos[1]>SievePos[2]
  }
SET13:
  __asm {
	 mov  [esi+8],ebx
	 mov  [esi+12],edx


	 jmp  LOOP3
  }
RET3:

#ifdef PROFILE_TEST
cpu_sieve_init.Stop() ;
cpu_sieve.Start() ;
#endif




DO_SIEVE:

  __asm {
	mov   dword ptr [_nResult],0
	mov   eax,[SieveWidth2]
	mov   off,eax
  }

MORE:
  __asm {
	mov   edx,[SieveUnit]
	sub   off,edx
	jc	  RET9
  }

  __asm {

	mov   eax,-1
	mov   ecx,edx
	shr   ecx,2
	lea   edi,[SieveArray]
	rep   stosd 						// padding seive array by -128 (0xFF)
	mov   ecx,2
	mov   esi,Primes
	lea   esi,[esi+16]
  }
  __asm {
	mov   edi,nPrimes
	dec   edi
	cmp   off,0
	je	  MAINLOOP2
 }

MAINLOOP1:								// ̃[vƂ
	__asm {
	  dec edi
	  jz PRE_MAINLOOP1_1

	  lea	esi,[esi+16]
	  movzx eax,word ptr [esi]
	  add	ecx,eax
	  mov	al,[esi+2]				   // log(p)
	  mov	ebx,[esi+8] 			   // SievePos
	  mov	edx,[esi+12]			   // SievePos

	  or	ebx,ebx
	  jl	LOOP_END1					// outside of sieve array

	  or	edx,edx
	  jl	SUB2						// outside of sieve array
	}
SUB1:
  __asm {
	sub   [SieveArray+ebx],al
	sub   [SieveArray+edx],al
	sub   ebx,ecx
	sub   edx,ecx
	js	  END_SUB1
	sub   [SieveArray+ebx],al
	sub   [SieveArray+edx],al
	sub   ebx,ecx
	sub   edx,ecx
	jns   SUB1
  }
END_SUB1:
  __asm {
	or	  ebx,ebx
	jl	  LOOP_END1
  }

SUB2:
  __asm {
	sub   [SieveArray+ebx],al
	sub   ebx,ecx
	xchg  ebx,edx
  }

LOOP_END1:
	__asm {
	  add	ebx,[SieveUnit]
	  add	edx,[SieveUnit]
	  mov	[esi+8],ebx
	  mov	[esi+12],edx

	  jmp	MAINLOOP1
	}


PRE_MAINLOOP1_1:
  __asm {
	mov edi,nPowers
	add edi,nPrimes2
  }

MAINLOOP1_1:
	__asm {
	  dec edi
	  js	SetResult

	  lea esi,[esi+16]
	  movzx  ecx,word ptr [esi]
	  mov  al,[esi+2]
	  mov  ebx,[esi+8]
	  mov  edx,[esi+12]

	  or	ebx,ebx
	  jl	LOOP_END1_1 				  // outside of sieve array

	  or	edx,edx
	  jl	SUB2_1						  // outside of sieve array
	}
SUB1_1:
  __asm {
	sub   [SieveArray+ebx],al
	sub   [SieveArray+edx],al
	sub   ebx,ecx
	sub   edx,ecx
	js	  END_SUB1_1					  // loop unitl index is nagative
	sub   [SieveArray+ebx],al
	sub   [SieveArray+edx],al
	sub   ebx,ecx
	sub   edx,ecx
	jns   SUB1_1						  // loop unitl index is nagative
  }
END_SUB1_1:
  __asm {
	or	  ebx,ebx
	jl	  LOOP_END1_1
  }

SUB2_1:
  __asm {
	sub   [SieveArray+ebx],al
	sub   ebx,ecx
	xchg  ebx,edx
  }

LOOP_END1_1:
	__asm {
	  add	ebx,[SieveUnit]
	  add	edx,[SieveUnit]
	  mov	[esi+8],ebx
	  mov	[esi+12],edx
	  jmp	MAINLOOP1_1
	}

MAINLOOP2:
	__asm {
	  dec edi
	  jz PRE_MAINLOOP2_1


	  lea esi,[esi+16]
	  movzx  eax,word ptr [esi]
	  add	 ecx,eax					// prime of factor base
	  mov  al,[esi+2]
	  mov  ebx,[esi+8]
	  mov  edx,[esi+12]

	  or	ebx,ebx
	  jl	LOOP_END2

	  or	edx,edx
	  jl	SUB22
	}
SUB21:
  __asm {
	sub [SieveArray+ebx],al
	sub [SieveArray+edx],al
	sub ebx,ecx
	sub edx,ecx
	jns SUB21

	or	ebx,ebx
	jl	LOOP_END2
  }

SUB22:
  __asm {
	sub  [SieveArray+ebx],al
	sub  ebx,ecx
	xchg ebx,edx
  }

LOOP_END2:
	__asm {
	  mov	[esi+8],ebx
	  mov	[esi+12],edx

	  jmp	MAINLOOP2
	}

PRE_MAINLOOP2_1:
  __asm {
	mov edi,nPowers
	add edi,nPrimes2
  }

MAINLOOP2_1:
	__asm {
	  dec edi
	  js   SetResult

	  lea esi,[esi+16]
	  movzx  ecx,word ptr [esi] 		// prime of factor base (case powers)
	  mov  al,[esi+2]
	  mov  ebx,[esi+8]
	  mov  edx,[esi+12]

	  or	ebx,ebx
	  jl	LOOP_END2_1

	  or	edx,edx
	  jl	SUB22_1
	}
SUB21_1:
  __asm {
	sub [SieveArray+ebx],al
	sub [SieveArray+edx],al
	sub ebx,ecx
	sub edx,ecx
	jns SUB21_1

	or	ebx,ebx
	jl	LOOP_END2_1
  }

SUB22_1:
  __asm {
	sub  [SieveArray+ebx],al
	sub  ebx,ecx
	xchg ebx,edx
  }

LOOP_END2_1:
	__asm {
	  mov	[esi+8],ebx
	  mov	[esi+12],edx

	  jmp	MAINLOOP2_1
	}


SetResult:								// set sieving result
  __asm {
	lea edi,[SieveArray]

	mov   ecx,off
	mov   ebx,[SieveUnit]
	dec   ebx
	mov   esi,[_nResult]
	mov   al,[Cutoff]
  }
Count:
  __asm {
	cmp   al,[edi+ebx]					// greater than  Cutoff(threshold) ?
	ja	  Set_Index
  }
NEXT:
  __asm {
	dec   ebx
	jns   Count
	jmp   Set_Count
  }
Set_Index:
  __asm {
	mov   edx,ebx
	add   edx,ecx
	mov   [SieveResult+esi*4],edx		// set index ( offset from the top of sieve array)
	inc   esi

	dec   ebx
	jns   Count
  }
Set_Count:
  __asm {
	mov  [_nResult],esi
	jmp  MORE
  }
RET9: ;
#ifdef PROFILE_TEST
cpu_sieve.Stop() ;
#endif

}

