//
//  Copyright (C) by S.Tomabechi 2001
//  All rights reserved.
//
//  Sieve Part of SIQS method
//
//

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "PPMPQS.hpp"
#include "IntFuncs.hpp"
#include "Error.hpp"
//extern unsigned long _A[] ;
//extern unsigned long _B[] ;
extern unsigned long nSieveResult ;
extern unsigned long SieveResult[] ;
extern Mint _a ;
extern Mint _b ;
extern unsigned long SieveUnit ;
extern unsigned long SieveWidth ;
extern unsigned long SieveWidth2 ;
extern char Cutoff ;
extern const unsigned long MaxSieveResult ;
extern Mint pN ;

extern char SieveArray[] ;
extern unsigned long ip[] ;
extern unsigned long pq[] ;
extern unsigned long Cmodp[] ;

#if 1
void SieveShift(unsigned long nPrimes,PPrimes* Primes,unsigned long* Bmodp,long sign,
                Mint& b,Mint& c)
{
#ifdef SIQS_DEBUG
    unsigned long k(0) ;
#endif
    unsigned long v3,t3 ;
    unsigned long cmodp ;

    __asm {
        mov edi,2           // edi represent a prime of factor base
        mov esi,Primes      // fe[ũAhX
        add esi,40
        sub nPrimes,2
        add Bmodp,4
    }
LOOP_MAIN:
    __asm {

        movzx eax,word ptr [esi]    // difference of primes
        add   edi,eax               // next primes
        dec   nPrimes
        js    RET

        add   Bmodp,4
//      mov   edx,[esi.ainv]        // Mmodp
//      or    edx,edx
#ifndef LINEAR_SIEVE
        cmp   byte ptr [esi.dmy],0
        je    OK
//        jz    OK
#else
        mov   dl,byte ptr [esi.dmy]
        or    dl,dl
#endif
#ifdef LINEAR_SIEVE
        jnz   SET_PARM
                                    // in this case   p | a
        mov  ebx,c                  // calculate the root of bx+c=0
        mov  ecx,[ebx.nDigit]
        mov  ebx,[ebx.digit]
        dec  ecx
        xor  edx,edx
    }
DIV_C:
    __asm {
        mov eax,[ebx+4*ecx]
        div edi
        dec ecx
        jns DIV_C

        mov ebx,c
        cmp [ebx.nDim],0
        jle NEG_C                  // c<0 ?
        sub edx,edi                // c-p
        neg edx                    // p-c
    }                              // Ōɂ mod p ŏ]Ƃ邩 c=0 ̏ꍇlȂĂ悢
NEG_C:
    __asm {
//      sub edx,edi
//      neg edx

#ifdef SIQS_DEBUG
//      mov [esi+16],edx
        mov ecx,k
//      lea ebx,[Cmodp]
        mov [Cmodp+4*ecx],edx
//      mov cmodp,edx
#endif
        mov cmodp,edx

//push edx
//      inc  k                  // remove q from sieve primes

        mov ebx,b
        mov ecx,[ebx.nDigit]
        mov ebx,[ebx.digit]
        dec ecx
        xor edx,edx
    }

DIV_B:
    __asm {
        mov eax,[ebx+4*ecx]
        div edi
        dec ecx
        jns DIV_B

        mov ebx,b
        cmp [ebx.nDim],0
        jge POS_B
        sub edx,edi
        neg edx
    }
POS_B:
    __asm {
        shl edx,1
        sub edx,edi
        jnc OK_B
        add edx,edi
    }
OK_B:
    __asm {
        mov eax,edx
    }



//SET_PARM:
    __asm {

        xor ebx,ebx                     // compute a^-1 mod p

        mov   v3,edi
        mov   ecx,1                         // ecx is inverse
        mov   eax,edx
      }
DIV1:
    __asm {
        xor   edx,edx
        div   v3                            // a/v3
        mov   t3,edx                        // save residue
        mul   ebx
        sub   ecx,eax                       // ecx -= q*v1
        xchg  ecx,ebx
        mov   eax,t3
        or    eax,eax
        jz    RET1
        xchg  eax,v3
        jmp   DIV1
    }

RET1:
    __asm {
        add ecx,edi
        cmp ecx,edi
        jbe BELOW
        sub ecx,edi
    }
BELOW:
    __asm {
//      mov a,ecx       // a= a^-1 mod q
#if 0
        mov ebx,k
        lea ebx,[Cmodp+4*ebx]
        mov eax,[ebx]
#else
        mov eax,cmodp
#endif
        mul ecx
        div edi
        mov ebx,edx


//      mov eax,[SieveWidth]      // SieveWidth%q vZ
//      xor edx,edx
//      div edi
//      mov Mmodp,edx
//      mov [esi+16],edx

        sub ebx,[esi+16]         // - Mmodp
//      sub ebx,edx
        js SET_R22
        sub ebx,edi
    }
SET_R22:
    __asm {

    }
BBBB2:
    __asm {
        add ebx,[SieveUnit]
        mov [esi+8],ebx
        mov [esi+12],ebx

#ifdef SIQS_DEBUG
        inc k
#endif
        lea   esi,[esi+20]
        jmp   LOOP_MAIN
#endif

    }
SET_PARM:
    __asm {
//      mov a,eax

#if 0
        mov ebx,B
        mov ecx,[ebx].nDigit
        mov ebx,[ebx].digit
        dec ecx
        xor edx,edx
    }
DIV_B:                          // B̂Ƃ̂Œ
    __asm {
        mov eax,[ebx+4*ecx]
        div edi
        dec ecx
        jns DIV_B

        mov ebx,B
        mov ebx,[ebx.nDim] ;
        or  ebx,ebx
#endif
        mov ebx,Bmodp
        mov edx,[ebx]
    }
HOGE:
    __asm{
//neg edx
//add edx,edi
        cmp sign,0
        jne B_IS_POSITIVE
//      jge B_IS_POSITIVE

        neg edx
        add edx,edi

//      mov bq,edx

    }
B_IS_POSITIVE:
    __asm {
        mov eax,edi
        sub eax,edx                 // q-B mod q
//      mul dword ptr [esi+16]      // (q-B)a^-1
//      div edi

#if 0
        mov t,eax
#endif


        mov ebx,[esi+8]            // SievePos[0]
        or  ebx,ebx
        jz  ZERO1
        add ebx,edi
    }
ZERO1:
    __asm {
//      sub ebx,Mmodp
        sub ebx,[esi+16]
        jns  P1
        add ebx,edi
    }
P1:
    __asm {
        mov ecx,[esi+12]
        or  ecx,ecx
        jz  ZERO2
        add ecx,edi
    }
ZERO2:
    __asm {
//      sub ecx,Mmodp
        sub ecx,[esi+16]                // Mmodp
        jns P2
        add ecx,edi

    }
P2:
    __asm {


//      mov ebx,[esi+4]       //  r^2=N mod q
//      mov ebx,[esi+8]

//      add ebx,t
        add ebx,eax         // eax=t
        sub ebx,edi
        jnc SET_Q_R_B
        add ebx,edi
//      mov ecx,q
//      add ecx,ebx             // ecx <- q+(r-bq)     0<ecx<q
//      neg ebx                 // ebx=bq-r ->   ebx


    }
SET_Q_R_B:
    __asm {
//      add ecx,t
        add ecx,eax
        sub ecx,edi
        jnc SET_R1_R2
        add ecx,edi


    }
SET_R1_R2:
    __asm {
//      mov ebx,edi

//      mov eax,ebx // mul(r1,a,q)
//      mul a
//      div q
//      mov ebx,edx

//      mov eax,ecx // mul(r2,a,q)
//      mul a
//      div q
//      mov ecx,edx

//      sub ebx,Mmodp
        sub ebx,[esi+16]
        js  SET_R2
        sub ebx,edi
    }
SET_R2:
    __asm {
//      sub ecx,Mmodp
        sub ecx,[esi+16]
        js BBBB
        sub ecx,edi

    }
BBBB:
    __asm {
        add ecx,[SieveUnit]
        add ebx,[SieveUnit]
        cmp ebx,ecx
        jge SET_POS     // SievePos[0]>SievePos[1] ƂȂ悤ɂƂ
        xchg ebx,ecx    // compare ebx and ecx as signed integer
    }
SET_POS:
    __asm {
        mov [esi+8],ebx
        mov [esi+12],ecx
    }
OK:
    __asm {
        lea esi,[esi+20]
        jmp LOOP_MAIN
    }
RET:

}

void SieveShiftp(unsigned long nPrimes,PPrimes* Primes,unsigned long* Bmodp)
{
    unsigned long cmodp ;

    __asm {
        mov edi,2           // edi represent a prime of factor base
        mov esi,Primes      // fe[ũAhX
        add esi,40
        sub nPrimes,2
        add Bmodp,4
    }
LOOP_MAIN:
    __asm {

        movzx eax,word ptr [esi]    // difference of primes
        add   edi,eax               // next primes
        dec   nPrimes
        js    RET

        add   Bmodp,4
        cmp   byte ptr [esi.dmy],0
        je    OK
    }
SET_PARM:
    __asm {
        mov ebx,Bmodp
        mov edx,[ebx]
    }
HOGE:
    __asm{
    }
B_IS_POSITIVE:
    __asm {
        mov eax,edi
        sub eax,edx                 // q-B mod q

        mov ebx,[esi+8]            // SievePos[0]
        or  ebx,ebx
        jz  ZERO1
        add ebx,edi
    }
ZERO1:
    __asm {
        sub ebx,[esi+16]
        jns  P1
        add ebx,edi
    }
P1:
    __asm {
        mov ecx,[esi+12]
#if 0
        or  ecx,ecx
        jz  ZERO2
#else
        jecxz ZERO2
#endif
        add ecx,edi
    }
ZERO2:
    __asm {
        sub ecx,[esi+16]                // Mmodp
        jns P2
        add ecx,edi

    }
P2:
    __asm {

        add ebx,eax         // eax=t
        sub ebx,edi
        jnc SET_Q_R_B
        add ebx,edi

    }
SET_Q_R_B:
    __asm {
        add ecx,eax
        sub ecx,edi
        jnc SET_R1_R2
        add ecx,edi


    }
SET_R1_R2:
    __asm {
        sub ebx,[esi+16]
        js  SET_R2
        sub ebx,edi
    }
SET_R2:
    __asm {
        sub ecx,[esi+16]
        js BBBB
        sub ecx,edi

    }
BBBB:
    __asm {
        add ecx,[SieveUnit]
        add ebx,[SieveUnit]
        cmp ebx,ecx
        jge SET_POS     // SievePos[0]>SievePos[1] ƂȂ悤ɂƂ
        xchg ebx,ecx    // compare ebx and ecx as signed integer
    }
SET_POS:
    __asm {
        mov [esi+8],ebx
        mov [esi+12],ecx
    }
OK:
    __asm {
        lea esi,[esi+20]
        jmp LOOP_MAIN
    }
RET:

}

void SieveShiftm(unsigned long nPrimes,PPrimes* Primes,unsigned long* Bmodp)
{
    unsigned long cmodp ;

    __asm {
        mov edi,2           // edi represent a prime of factor base
        mov esi,Primes      // fe[ũAhX
        add esi,40
        sub nPrimes,2
        add Bmodp,4
    }
LOOP_MAIN:
    __asm {

        movzx eax,word ptr [esi]    // difference of primes
        add   edi,eax               // next primes
        dec   nPrimes
        js    RET

        add   Bmodp,4
//      mov   edx,[esi.ainv]        // Mmodp
//      or    edx,edx
        cmp   byte ptr [esi.dmy],0
        je    OK

    }
SET_PARM:
    __asm {

        mov ebx,Bmodp
        mov edx,[ebx]
    }
HOGE:
    __asm{
        neg edx
        add edx,edi
    }
B_IS_POSITIVE:
    __asm {
        mov eax,edi
        sub eax,edx                 // q-B mod q

        mov ebx,[esi+8]            // SievePos[0]
        or  ebx,ebx
        jz  ZERO1
        add ebx,edi
    }
ZERO1:
    __asm {
//      sub ebx,Mmodp
        sub ebx,[esi+16]
        jns  P1
        add ebx,edi
    }
P1:
    __asm {
        mov ecx,[esi+12]
#if 0
        or  ecx,ecx
        jz  ZERO2
#else
        jecxz ZERO2
#endif
        add ecx,edi
    }
ZERO2:
    __asm {
        sub ecx,[esi+16]                // Mmodp
        jns P2
        add ecx,edi

    }
P2:
    __asm {

        add ebx,eax         // eax=t
        sub ebx,edi
        jnc SET_Q_R_B
        add ebx,edi

    }
SET_Q_R_B:
    __asm {
        add ecx,eax
        sub ecx,edi
        jnc SET_R1_R2
        add ecx,edi


    }
SET_R1_R2:
    __asm {
        sub ebx,[esi+16]
        js  SET_R2
        sub ebx,edi
    }
SET_R2:
    __asm {
        sub ecx,[esi+16]
        js BBBB
        sub ecx,edi

    }
BBBB:
    __asm {
        add ecx,[SieveUnit]
        add ebx,[SieveUnit]
        cmp ebx,ecx
        jge SET_POS     // SievePos[0]>SievePos[1] ƂȂ悤ɂƂ
        xchg ebx,ecx    // compare ebx and ecx as signed integer
    }
SET_POS:
    __asm {
        mov [esi+8],ebx
        mov [esi+12],ecx
    }
OK:
    __asm {
        lea esi,[esi+20]
        jmp LOOP_MAIN
    }
RET:

}


#else
void SieveShift(unsigned long nPrimes,PPrimes* Primes,unsigned long* Bmodp,long sign,Mint& B,Mint& c)
{

    unsigned long q ;
    unsigned long a ;
    unsigned long r1,r2 ;
    unsigned long b ;
    unsigned long k=0 ;
    unsigned long t ;
    unsigned long j ;
    q=2 ;
    unsigned long Mmodp ;

    for( k=0,j=2 ; j<nPrimes ; j++ ) {


        q+=(unsigned long)(Primes[j].diff) ;
        a=Primes[j].ainv ;
        Mmodp=SieveWidth%q ;

        if( a==0 ) {
            r1=isMul(mod(-c,q),invmodp((2*B)%q,q),q) ;
            Primes[j].ainv=mod(-c,q) ;
            if( r1<Mmodp ) r1=r1+q-Mmodp ;
            else r1=r1-Mmodp ;
            r1+=SieveUnit ;
            Primes[j].SievePos[0]=r1 ;
            Primes[j].SievePos[1]=r1 ;
            continue ;
        }
//      t=isMul(q-mod(B,q),a,q) ;
        if( sign==1 ) {
            t=isSub(q,Bmodp[j],q) ;
        }
        else {
            t=isAdd(q,Bmodp[j],q) ;
        }
//      r1=isSub(Primes[j].SievePos[0],SieveWidth,q) ;
//      r2=isSub(Primes[j].SievePos[1],SieveWidth,q) ;
        r1=isSub(long(Primes[j].SievePos[0])+q,SieveWidth,q) ;
        r2=isSub(long(Primes[j].SievePos[1])+q,SieveWidth,q) ;
        (r1+=t)%=q ;
        (r2+=t)%=q ;
        if( r1<Mmodp ) r1=r1+q-Mmodp ;
        else r1=r1-Mmodp ;
        if( r2<Mmodp ) r2=r2+q-Mmodp ;
        else r2=r2-Mmodp ;
        r1+=SieveUnit ;
        r2+=SieveUnit ;
        if( r1>r2 ) {
            Primes[j].SievePos[0]=r1 ;
            Primes[j].SievePos[1]=r2 ;
        }
        else {
            Primes[j].SievePos[0]=r2 ;
            Primes[j].SievePos[1]=r1 ;
        }
    }
}

#endif
