//
//  Copyright (C) by S.Tomabechi 2001
//  All rights reserved.
//
//  Sieve Part of SIQS method
//
//  1995/03/07 created
//
//  1996/11/25
//   PPMPQSpɕύX
//   ʒu߂ōςނ悤ɂ

//
//  unsigned long nPrimes :  f̌
//  unsigned long SieveWidth2 : ӂ邤S͈
//  unsigned long SieveUnit   : łӂ邤͈
//
//  SievePos[0] 
//  SievePos[1] : ʒu
//  SievePos[2] : ʒu
// total 16 bytes

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "PPMPQS.hpp"
#include "IntFuncs.hpp"


extern unsigned long _A[] ;
extern unsigned long _B[] ;
extern unsigned long nSieveResult ;
extern unsigned long SieveResult[] ;
extern Mint _a ;
extern Mint _b ;
extern unsigned long SieveUnit ;
extern unsigned long SieveWidth ;
extern unsigned long SieveWidth2 ;
extern char Cutoff ;
extern const unsigned long MaxSieveResult ;
extern Mint pN ;

extern char SieveArray[] ;
extern char lg1[] ;
extern unsigned long ip[] ;
extern unsigned long pq[] ;
extern Mint B[] ;


extern long _nResult ;      // number of cancidates which seem to be smooth


void Sieve(PPrimes* Primes,unsigned long nPrimes,unsigned long nPrimes2,unsigned long nPowers)
{
  unsigned long off ;
  unsigned long andigit ;
  unsigned long bndigit  ;
  unsigned long a2_p ;
  long b_p ;
  long r_p ;
//  long Mmodp ;
//  long v3 ;
//  long t3 ;
  unsigned long p ;
  unsigned long cnt ;



DO_SIEVE:

  __asm {
    mov   [_nResult],0
    mov   eax,[SieveWidth2]
    mov   off,eax
  }

MORE:
  __asm {
    mov   edx,[SieveUnit]
    sub   off,edx
    jc    RET9
  }

  __asm {

    mov   eax,-1
    mov   ecx,edx
    shr   ecx,2
    lea   edi,[SieveArray]
    rep   stosd                         // padding seive array by -128 (0xFF)
    mov   ecx,2
    mov   esi,Primes
    lea   esi,[esi+16+4]
  }
  __asm {
    mov   edi,nPrimes
    dec   edi
    cmp   off,0
//  je    MAINLOOP2
    je    PRE_MAIN2
 }
 
PRE_MAIN1:
#ifndef LINEAR_SIEVE 
    #if 1
    __asm {
      cmp byte ptr [esi.dmy+16+4],0
      jne  MAINLOOP1

      dec edi
      jz PRE_MAINLOOP1_1

      lea   esi,[esi+16+4]
      movzx eax,word ptr [esi]
      add   ecx,eax
      jmp   PRE_MAIN1 
    } 
    #endif
#endif

MAINLOOP1:                              // ̃[vƂ
    __asm {
      dec edi
      jz PRE_MAINLOOP1_1
    }
LOOP1_1:    
    __asm {       

      lea   esi,[esi+16+4]
      movzx eax,word ptr [esi]
      add   ecx,eax
      mov   al,[esi+2]                 // log(p)
      mov   ebx,[esi+8]                // SievePos
      mov   edx,[esi+12]               // SievePos

      or    ebx,ebx
      jl    LOOP_END1                   // outside of sieve array

      or    edx,edx
      jl    SUB2                        // outside of sieve array
    }
SUB1:
  __asm {
    sub   [SieveArray+ebx],al
    sub   [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    js    END_SUB1
    sub   [SieveArray+ebx],al
    sub   [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    jns   SUB1
  }
END_SUB1:
  __asm {
    or    ebx,ebx
    jl    LOOP_END1
  }

SUB2:
  __asm {
    sub   [SieveArray+ebx],al
    sub   ebx,ecx
    xchg  ebx,edx
  }

LOOP_END1:
    __asm {
      add   ebx,[SieveUnit]
      add   edx,[SieveUnit]
      mov   [esi+8],ebx
      mov   [esi+12],edx

      jmp   MAINLOOP1
    }


PRE_MAINLOOP1_1:
  __asm {
    mov edi,nPowers
    add edi,nPrimes2
  }

MAINLOOP1_1:
    __asm {
      dec edi
      js    SetResult

      lea esi,[esi+16+4]
      movzx  ecx,word ptr [esi]
      mov  al,[esi+2]
      mov  ebx,[esi+8]
      mov  edx,[esi+12]

      or    ebx,ebx
      jl    LOOP_END1_1                   // outside of sieve array

      or    edx,edx
      jl    SUB2_1                        // outside of sieve array
    }
SUB1_1:
  __asm {
    sub   [SieveArray+ebx],al
    sub   [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    js    END_SUB1_1                      // loop unitl index is nagative
    sub   [SieveArray+ebx],al
    sub   [SieveArray+edx],al
    sub   ebx,ecx
    sub   edx,ecx
    jns   SUB1_1                          // loop unitl index is nagative
  }
END_SUB1_1:
  __asm {
    or    ebx,ebx
    jl    LOOP_END1_1
  }

SUB2_1:
  __asm {
    sub   [SieveArray+ebx],al
    sub   ebx,ecx
    xchg  ebx,edx
  }

LOOP_END1_1:
    __asm {
      add   ebx,[SieveUnit]
      add   edx,[SieveUnit]
      mov   [esi+8],ebx
      mov   [esi+12],edx
      jmp   MAINLOOP1_1
    }

PRE_MAIN2:
#ifndef LINEAR_SIEVE 
    #if 1
    __asm {         
      cmp byte ptr [esi.dmy+16+4],0
      jne  MAINLOOP2

      dec edi
      jz PRE_MAINLOOP2_1

      lea   esi,[esi+16+4]
      movzx eax,word ptr [esi]
      add   ecx,eax
      jmp   PRE_MAIN2 
    } 
    #endif
#endif
MAINLOOP2:
    __asm {
      dec edi
      jz PRE_MAINLOOP2_1


      lea esi,[esi+16+4]
      movzx  eax,word ptr [esi]
      add    ecx,eax                    // prime of factor base
      mov  al,[esi+2]
      mov  ebx,[esi+8]
      mov  edx,[esi+12]

      or    ebx,ebx
      jl    LOOP_END2

      or    edx,edx
      jl    SUB22
    }
SUB21:
  __asm {
    sub [SieveArray+ebx],al
    sub [SieveArray+edx],al
    sub ebx,ecx
    sub edx,ecx
    jns SUB21

    or  ebx,ebx
    jl  LOOP_END2
  }

SUB22:
  __asm {
    sub  [SieveArray+ebx],al
    sub  ebx,ecx
    xchg ebx,edx
  }

LOOP_END2:
    __asm {
      mov   [esi+8],ebx
      mov   [esi+12],edx

      jmp   MAINLOOP2
    }

PRE_MAINLOOP2_1:
  __asm {
    mov edi,nPowers
    add edi,nPrimes2
  }

MAINLOOP2_1:
    __asm {
      dec edi
      js   SetResult

      lea esi,[esi+16+4]
      movzx  ecx,word ptr [esi]         // prime of factor base (case powers)
      mov  al,[esi+2]
      mov  ebx,[esi+8]
      mov  edx,[esi+12]

      or    ebx,ebx
      jl    LOOP_END2_1

      or    edx,edx
      jl    SUB22_1
    }
SUB21_1:
  __asm {
    sub [SieveArray+ebx],al
    sub [SieveArray+edx],al
    sub ebx,ecx
    sub edx,ecx
    jns SUB21_1

    or  ebx,ebx
    jl  LOOP_END2_1
  }

SUB22_1:
  __asm {
    sub  [SieveArray+ebx],al
    sub  ebx,ecx
    xchg ebx,edx
  }

LOOP_END2_1:
    __asm {
      mov   [esi+8],ebx
      mov   [esi+12],edx

      jmp   MAINLOOP2_1
    }


SetResult:                              // set sieving result
  __asm {
    lea edi,[SieveArray]

    mov   ecx,off
    mov   ebx,[SieveUnit]
    dec   ebx
    mov   esi,[_nResult]
    mov   al,[Cutoff]
  }
Count:
  __asm {
    cmp   al,[edi+ebx]                  // greater than  Cutoff(threshold) ?
    ja    Set_Index
  }
NEXT:
  __asm {
    dec   ebx
    jns   Count
    jmp   Set_Count
  }
Set_Index:
  __asm {
    mov   edx,ebx
    add   edx,ecx
    mov   [SieveResult+esi*4],edx       // set index ( offset from the top of sieve array)
    inc   esi

    dec   ebx
    jns   Count
  }
Set_Count:
  __asm {
    mov  [_nResult],esi
    jmp  MORE
  }
RET9: ;

}
